package CS::CountString;

use strict;
use warnings;

use Erreurs;
use GreenIT::lib::KeepPortalData;
use GreenIT::lib::HardCodedPathNotGreen;
use CommonOutput::ElaborateLog;

my $rulesDescription = GreenIT::lib::KeepPortalData::keepPortalData();

my $mnemo_HardCodedPathNotGreen = Ident::Alias_HardCodedPathNotGreen();
 
my $nb_HardCodedPathNotGreen = 0;

sub CountString($$$$)
{
    my ($fichier, $vue, $compteurs, $options) = @_;
    my $status = 0;
    $nb_HardCodedPathNotGreen = 0;

    my $code = \$vue->{'code'};
    # C# / VB.Net
    my $HString = $vue->{'HString'} || $vue->{'string'};
    my $text = \$vue->{'text'};


  	if ( ! defined $code )
	{
		$status |= Couples::counter_add($compteurs, $mnemo_HardCodedPathNotGreen, Erreurs::COMPTEUR_ERREUR_VALUE );
    }

    my $parameters = AnalyseUtil::recuperer_options();
    my $techno = $parameters->[0]->{'--language'};

    $nb_HardCodedPathNotGreen += GreenIT::lib::HardCodedPathNotGreen::checkHardCodedPathNotGreen($HString, $techno, $text, $rulesDescription);
    
	$status |= Couples::counter_add ($compteurs, $mnemo_HardCodedPathNotGreen, $nb_HardCodedPathNotGreen);
    return $status;
}

1;
