package CloudReady::CountDocker;

use strict;
use warnings;

use Erreurs;
use CloudReady::detection;
use CloudReady::config;
use CloudReady::Ident;
use CloudReady::lib::HardCodedIP;
use CloudReady::lib::HardCodedPath;
use CloudReady::lib::HardCodedURL;
use CloudReady::lib::URINotSecured;
use CloudReady::lib::SensitiveDataString;

use constant BEGINNING_MATCH => 0;
use constant FULL_MATCH => 1;

my $rulesDescription = CloudReady::lib::KeepPortalData::keepPortalData();

sub checkPatternSensitive($$$) {
	my $reg = shift;
	my $code = shift;
	my $mnemo = shift;

	return CommonOutput::ElaborateLog::ElaborateLogPartOne($code, $reg, $mnemo, $rulesDescription);
	#return () = ($$code =~ /$reg/gm);
}

sub checkImport($$$$$) {
	my $code = shift;
	my $HString = shift;
	my $pattern = shift;
	my $text = shift;
	my $mnemo = shift;
	pos($$code) = undef;

	my $nb_string_content = 0;
	while ($$code =~ /\bimport\s*\((.*)\)/sgc || $$code =~ /\bimport\s+(.*)$/mgc) {
		my $importContent = $1;
		while ($importContent =~ /\b(CHAINE_\d+)\b/gc) {
			my $stringID = $1;
			if ($HString->{$stringID} =~ /$pattern/) {
				$nb_string_content++;
				my $string = quotemeta($HString->{$stringID});
				my $regex = qr/$string/;
				CommonOutput::ElaborateLog::ElaborateLogPartOne($text, $regex, $mnemo, $rulesDescription);
			}
		}
	}
	return $nb_string_content;
}

sub checkImportAndCode($$$$$$) {
	my $code = shift;
	my $HString = shift;
	my $patternImport = shift;
	my $patternCode = shift;
	my $text = shift;
	my $mnemo = shift;
	pos($$code) = undef;

	my $nb_detect = 0;
	while ($$code =~ /\bimport\s*\((.*)\)/sgc || $$code =~ /\bimport\s+(.*)$/mgc) {
		my $importContent = $1;
		while ($importContent =~ /\b(CHAINE_\d+)\b/gc) {
			my $stringID = $1;
			if ($HString->{$stringID} =~ /$patternImport/) {
				$nb_detect++;
				my $string = quotemeta($HString->{$stringID});
				my $regex = qr/$string/;
				CommonOutput::ElaborateLog::ElaborateLogPartOne($text, $regex, $mnemo, $rulesDescription);
			}
		}
	}

	# search pattern in code
	my $regex = qr/$patternCode/;
	$nb_detect += CommonOutput::ElaborateLog::ElaborateLogPartOne($text, $regex, $mnemo, $rulesDescription);

	return $nb_detect;
}

sub CountDocker($$$$) {
	my ($fichier , $vue , $compteurs , $techno) = @_;
	my $ret = 0;

#	my $code;
#	my $HString;
#	my $MixBloc;
#	my $text;
#	$text = \$vue->{'text'};
#	my $checkPattern = \&checkPatternSensitive;
#
#	$code = \$vue->{'code'};
#	$HString = $vue->{'HString'};
#	$MixBloc = \$vue->{'MixBloc'};
#
#	if ((!defined $code) || (!defined $$code)) {
#		#$ret |= Couples::counter_add($compteurs, $MissingJSPComment__mnemo, Erreurs::COMPTEUR_ERREUR_VALUE );
#		return $ret |= Erreurs::COMPTEUR_STATUS_VUE_ABSENTE;
#	}
#
#	# BOOSTERS
#	# HL-2823 Detect Dockerfile as a Cloud Maturity booster
#	# CloudReady::detection::addFileDetection($fichier, CloudReady::Ident::Alias_Docker(), $checkPattern->(qr/os\.Create\b/, $code, CloudReady::Ident::Alias_Docker()));
#
#	my $parameters = AnalyseUtil::recuperer_options();
#	my $dbgMatchPatternDetail = $parameters->[0]->{'--dbgMatchPatternDetail'};
#	if (defined $dbgMatchPatternDetail) {
#		# replacing SHA by filenames in log
#		CommonOutput::ElaborateLog::ElaborateLogPartTwo($fichier);
#	}

	return $ret;
}

1;
