package CloudReady::detection;

use strict;
use warnings;
use AnalyseOptions;
use AnalyseUtil;
use File::Spec;

use CloudReady::config;

use CommonOutput::detection;

#use framework::Logs;

my %H_AVAILABLE_FILE_MNEMOS = ();

my $CURRENT_FILE_NAME = "";
my $CURRENT_TECHNO = "";
my %FILE_DATA = ();
my %APPLI_DATA = ();

my $OUTPUT_FILE_NAME = undef;
my $OUTPUT_FILE_HANDLER = undef;

#my $META_DATA = undef;

# TEST getter ...
sub getCurrentFileCounter($) {
	my $mnemo = shift;
	return $FILE_DATA{$mnemo};
}
sub getCurrentAppliCounter($) {
	my $mnemo = shift;
	return $APPLI_DATA{$mnemo};
}

sub loadAvailableFileMnemo($) {
	my $techno = shift;
	for my $mnemo (@{CloudReady::config::getFileMnemoList($techno)}) {
		$H_AVAILABLE_FILE_MNEMOS{$mnemo} = 1;
	}
}

my $CONTEXT = {
	"OUTPUT_FILE_NAME" => \$OUTPUT_FILE_NAME,
	"OUTPUT_FILE_HANDLER" => \$OUTPUT_FILE_HANDLER,
	"FILE_DATA" => \%FILE_DATA,
	"APPLI_DATA" => \%APPLI_DATA,
};

# call for each techno analysis.
sub init($$) {
	my $options = shift;
	my $techno = shift;
	#framework::Logs::init($options);
	$CONTEXT->{'CloudReadyDetectionActivated'} = 1;

	$CONTEXT->{"FILE_MNEMO_LIST"} = CloudReady::config::getFileMnemoList($techno);
	$CONTEXT->{"APPLI_MNEMO_LIST"} = CloudReady::config::getAppliMnemoList($techno);

	CommonOutput::detection::init("CloudReady", $techno, $CONTEXT);
}

# Declare a new file being processed
# - commit data of previous file
# - init data for new current file.
sub setCurrentFile($) {
	# FIXME : remove this function
	#CommonOutput::detection::setCurrentFile(shift);
	return;
}

sub addFileDetection($$$) {
	my $file = shift;
	my $mnemo = shift;
	my $value = shift;
	$FILE_DATA{$mnemo} = $value;
	CommonOutput::detection::addFileDetection('CloudReady', $mnemo, $value, undef);
}

sub addAppliDetection($$) {
	my $mnemo = shift;
	my $data = shift;

	CommonOutput::detection::addAppliDetection('CloudReady', $mnemo, $data);
}

1;

