package CloudReady::lib::KeepPortalData;

use strict;
use warnings;
use File::Basename;

sub keepPortalData {
    my %rulesDescription;
    my $dirname = dirname(__FILE__);
    open my $handle_csv, '<', File::Spec->catfile($dirname, 'RulesDescription.csv');

    # [0] techno
    # [1] rule name (portal)
    # [2] alert label
    # [3] url doc
    # [4] ID mnemo
    # [5] mnemo
    # [6] multiPatternFormula
    # [7] kind (booster/blocker)

    while (my $line = <$handle_csv>) {
        my @lines = split(/;/, $line);
        $rulesDescription{$lines[4]}{$lines[0]}{$lines[1]}[0] = $lines[2];
        $rulesDescription{$lines[4]}{$lines[0]}{$lines[1]}[1] = $lines[3];
        $rulesDescription{$lines[4]}{$lines[0]}{$lines[1]}[2] = $lines[6];
        if ($lines[7] ne "\n") {
            $lines[7] =~ s/\n$//m;
            $rulesDescription{$lines[4]}{$lines[0]}{$lines[1]}[3] = $lines[7];
        }
    }
    close $handle_csv;

    return \%rulesDescription;
}

1;
