#----------------------------------------------------------------------#
#                 @ISOSCOPE 2008                                       #
#----------------------------------------------------------------------#
#       Auteur  : ISOSCOPE SA                                          #
#       Adresse : TERSUD - Bat A                                       #
#                 5, AVENUE MARCEL DASSAULT                            #
#                 31500  TOULOUSE                                      #
#       SIRET   : 410 630 164 00037                                    #
#----------------------------------------------------------------------#
# Ce fichier a ete l'objet d'un depot aupres de                        #
# l'Institut National de la Propriete Industrielle (lettre Soleau)     #
#----------------------------------------------------------------------#

# Composant: Plugin

package CountEmptyCatches;

use strict;
use warnings;
use Erreurs;
use GreenIT::lib::KeepPortalData;

use CommonOutput::ElaborateLog;

my $rulesDescription = GreenIT::lib::KeepPortalData::keepPortalData();

# prototypes publiques
sub CountEmptyCatches($$$);

#-------------------------------------------------------------------------------
# DESCRIPTION: Module de comptage des instructions Catch vide.
#-------------------------------------------------------------------------------
sub CountEmptyCatches($$$) {
  my ($fichier, $vue, $compteurs) = @_ ;

  my $mnemo_EmptyCatches = Ident::Alias_EmptyCatches();
  my $nbr_EmptyCatches = 0;
  my $status = 0;

  my $code = \$vue->{'code'};


  if ( ! defined $vue->{'code'} ) {
    $status |= Couples::counter_add($compteurs, $mnemo_EmptyCatches, Erreurs::COMPTEUR_ERREUR_VALUE );
    return $status |= Erreurs::COMPTEUR_STATUS_VUE_ABSENTE;
  }

  # FIXME: optimisation possible pour attraper plus de catches vides:
  # FIXME: Suppression des imbrications d'accolades vides:
  # FIXME: - { { } } est remplace par { }
  # FIXME: - { } { } est remplace par { }
  # FIXME: - { ; } est remplace par { }
  # FIXME: while ( $code =~ s/\{[\s\n]*\{[\s\n]*\}[\s\n]*\}|\{[\s\n]*\}[\s\n]*\{[\s\n]*\}|\{[\s\n]*;+[\s\n]*\}/\{\}/sg ) { }

  # regexp is multilined
  my $regex = qr/\bcatch\b[^\{]*\{(?:\s|\n)*\}/;
  my $numline = 1;
  while ($$code =~ /($regex|\n)/g) {
    if ($1 eq "\n") {
      $numline++;
    }
    else {
      my $patt = $1;
      $nbr_EmptyCatches++;
      CommonOutput::ElaborateLog::SimpleElaborateLog($numline, $mnemo_EmptyCatches, $rulesDescription, "Avoid_EmptyCatches");
      while ($patt =~ /\n/g) {$numline++};
    }
  }

  # replacing SHA by filenames in log
  CommonOutput::ElaborateLog::ElaborateLogPartTwo($fichier);

  $status |= Couples::counter_add($compteurs, $mnemo_EmptyCatches, $nbr_EmptyCatches);

  return $status;

}


1;

