package Lib::LongPathUtils;

use strict;
use warnings;

sub PathExists($) {
    my $file = shift;

    if ($^O eq 'MSWin32') {
        if (Win32::LongPath::testL('e', $file)) {
            return 1;
        }
    }
    else {
        if (-e $file) {
            return 1;
        }
    }
    return 0;
}

sub IsFolder($) {
    my $folder = shift;
    if ($^O eq 'MSWin32') {
        if (Win32::LongPath::testL('d', $folder)) {
            return 1;
        }
    }
    else {
        if (-d $folder) {
            return 1;
        }
    }
    return 0;
}

sub IsFile($) {
    my $file = shift;
    if ($^O eq 'MSWin32') {
        if (Win32::LongPath::testL('f', $file)) {
            return 1;
        }
    }
    else {
        if (-f $file) {
            return 1;
        }
    }
    return 0;
}

1;