package Ruby_Conf;

use strict;
use warnings;
use Ident;

# Ne pas modifier ce fichier

# Composant: Plugin

our @table_Comptages = (

     [ Ident::Alias_LinesOfCode(), 'CountLinesOfCode', 'CountCommun', \&CountCommun::CountLinesOfCode, 'APPEL', 1 ],
     [ Ident::Alias_CommentBlocs(), 'CountCommentsBlocs', 'CountCommentsBlocs', \&CountCommentsBlocs::CountCommentsBlocs, 'APPEL', 1 ],
     [ Ident::Alias_BlankLines(), 'CountCommun', 'CountCommun', \&CountCommun::CountCommun, 'APPEL', 1 ],
     [ Ident::Alias_CommentLines(), 'CountCommun', 'CountCommun', \&CountCommun::CountCommun, 'APPEL', 1 ],
     [ Ident::Alias_AlphaNumCommentLines(), 'CountCommun', 'CountCommun', \&CountCommun::CountCommun, 'APPEL', 1 ],
     [ Ident::Alias_SuspiciousComments(), 'CountSuspiciousCommentsInternational', 'CountSuspiciousComments', \&CountSuspiciousComments::CountSuspiciousCommentsInternational, 'APPEL', 1 ],
     
     [ Ident::Alias_BadLogicIndents(), 'CountRuby', 'Ruby::CountRuby', \&Ruby::CountRuby::CountRuby, 'APPEL', 1 ],
     [ Ident::Alias_TabInsideIndentation(), 'CountRuby', 'Ruby::CountRuby', \&Ruby::CountRuby::CountRuby, 'APPEL', 1 ],
     [ Ident::Alias_BadIndentationStyle(), 'CountRuby', 'Ruby::CountRuby', \&Ruby::CountRuby::CountRuby, 'APPEL', 1 ],
     [ Ident::Alias_GlobalVariables(), 'CountVariable', 'Ruby::CountRuby', \&Ruby::CountRuby::CountVariable, 'APPEL', 1 ],
     [ Ident::Alias_LongLines80(), 'CountLongLines', 'CountLongLines', \&CountLongLines::CountLongLines, 'APPEL', 1 ],
     [ Ident::Alias_UnexpectedSemicolon(), 'CountLinePerLine', 'Ruby::CountRuby', \&Ruby::CountRuby::CountLinePerLine, 'APPEL', 1 ],
     [ Ident::Alias_MultipleStatementsOnSameLine(), 'CountLinePerLine', 'Ruby::CountRuby', \&Ruby::CountRuby::CountLinePerLine, 'APPEL', 1 ],
     [ Ident::Alias_UselessThen(), 'CountLinePerLine', 'Ruby::CountRuby', \&Ruby::CountRuby::CountLinePerLine, 'APPEL', 1 ],
     
     #[ "YYY", 'CountBegin', 'Ruby::CountRuby', \&Ruby::CountRuby::CountBegin, 'APPEL', 1 ],
     
     [ Ident::Alias_NestedRoutines(), 'CountMethod', 'Ruby::CountMethod', \&Ruby::CountMethod::CountMethod, 'APPEL', 1 ],
     [ Ident::Alias_MethodImplementations(), 'CountMethod', 'Ruby::CountMethod', \&Ruby::CountMethod::CountMethod, 'APPEL', 1 ],
     [ Ident::Alias_MethodsLengthAverage(), 'CountMethod', 'Ruby::CountMethod', \&Ruby::CountMethod::CountMethod, 'APPEL', 1 ],
     [ Ident::Alias_EmptyMethods(), 'CountMethod', 'Ruby::CountMethod', \&Ruby::CountMethod::CountMethod, 'APPEL', 1 ],
     [ Ident::Alias_LongRoutines(), 'CountMethod', 'Ruby::CountMethod', \&Ruby::CountMethod::CountMethod, 'APPEL', 1 ],
     [ Ident::Alias_OptionalParamsBeforeRequired(), 'CountMethod', 'Ruby::CountMethod', \&Ruby::CountMethod::CountMethod, 'APPEL', 1 ],
     [ Ident::Alias_MultiLinesExpressionRoutines(), 'CountMethod', 'Ruby::CountMethod', \&Ruby::CountMethod::CountMethod, 'APPEL', 1 ],
     [ Ident::Alias_MissingParenthesesForParams(), 'CountMethod', 'Ruby::CountMethod', \&Ruby::CountMethod::CountMethod, 'APPEL', 1 ],
     [ Ident::Alias_UselessParenthesesForParams(), 'CountMethod', 'Ruby::CountMethod', \&Ruby::CountMethod::CountMethod, 'APPEL', 1 ],
     [ Ident::Alias_MissingLambdaLiteral(), 'CountMethod', 'Ruby::CountMethod', \&Ruby::CountMethod::CountMethod, 'APPEL', 1 ],
     [ Ident::Alias_ParametersAverage(), 'CountMethod', 'Ruby::CountMethod', \&Ruby::CountMethod::CountMethod, 'APPEL', 1 ],
     [ Ident::Alias_WithTooMuchParametersMethods(), 'CountMethod', 'Ruby::CountMethod', \&Ruby::CountMethod::CountMethod, 'APPEL', 1 ],
     [ Ident::Alias_UnusedParameters(), 'CountMethod', 'Ruby::CountMethod', \&Ruby::CountMethod::CountMethod, 'APPEL', 1 ],
     [ Ident::Alias_BadMethodNames(), 'CountMethod', 'Ruby::CountMethod', \&Ruby::CountMethod::CountMethod, 'APPEL', 1 ],
     [ Ident::Alias_TopLevelRoutines(), 'CountMethod', 'Ruby::CountMethod', \&Ruby::CountMethod::CountMethod, 'APPEL', 1 ],
     [ Ident::Alias_ShortMethodNamesLT(), 'CountMethod', 'Ruby::CountMethod', \&Ruby::CountMethod::CountMethod, 'APPEL', 1 ],
     [ Ident::Alias_MethodNameLengthAverage(), 'CountMethod', 'Ruby::CountMethod', \&Ruby::CountMethod::CountMethod, 'APPEL', 1 ],
     
     [ Ident::Alias_EmptyCatches(), 'CountException', 'Ruby::CountException', \&Ruby::CountException::CountException, 'APPEL', 1 ],
     [ Ident::Alias_GenericCatches(), 'CountException', 'Ruby::CountException', \&Ruby::CountException::CountException, 'APPEL', 1 ],
     
     [ Ident::Alias_ClassImplementations(), 'CountClass', 'Ruby::CountClass', \&Ruby::CountClass::CountClass, 'APPEL', 1 ],
     [ Ident::Alias_MethodsAverage(), 'CountClass', 'Ruby::CountClass', \&Ruby::CountClass::CountClass, 'APPEL', 1 ],
     [ Ident::Alias_ClassVariables(), 'CountClass', 'Ruby::CountClass', \&Ruby::CountClass::CountClass, 'APPEL', 1 ],
     [ Ident::Alias_UtilityClassShouldBeModule(), 'CountClass', 'Ruby::CountClass', \&Ruby::CountClass::CountClass, 'APPEL', 1 ],
     [ Ident::Alias_UnusedPrivateMethods(), 'CountClass', 'Ruby::CountClass', \&Ruby::CountClass::CountClass, 'APPEL', 1 ],
     [ Ident::Alias_BadVariableNames(), 'CountClass', 'Ruby::CountClass', \&Ruby::CountClass::CountClass, 'APPEL', 1 ],
     [ Ident::Alias_BadConstantNames(), 'CountClass', 'Ruby::CountClass', \&Ruby::CountClass::CountClass, 'APPEL', 1 ],
     [ Ident::Alias_BadClassNames(), 'CountClass', 'Ruby::CountClass', \&Ruby::CountClass::CountClass, 'APPEL', 1 ],
     [ Ident::Alias_VariableNameLengthAverage(), 'CountClass', 'Ruby::CountClass', \&Ruby::CountClass::CountClass, 'APPEL', 1 ],
     [ Ident::Alias_TotalAttributes(), 'CountClass', 'Ruby::CountClass', \&Ruby::CountClass::CountClass, 'APPEL', 1 ],
     [ Ident::Alias_ShortVarName(), 'CountClass', 'Ruby::CountClass', \&Ruby::CountClass::CountClass, 'APPEL', 1 ],
     [ Ident::Alias_ShortClassNamesLT(), 'CountClass', 'Ruby::CountClass', \&Ruby::CountClass::CountClass, 'APPEL', 1 ],
     [ Ident::Alias_ClassNameLengthAverage(), 'CountClass', 'Ruby::CountClass', \&Ruby::CountClass::CountClass, 'APPEL', 1 ],
     [ Ident::Alias_LocalVariables(), 'CountClass', 'Ruby::CountClass', \&Ruby::CountClass::CountClass, 'APPEL', 1 ],
     [ Ident::Alias_ConstantDefinitions(), 'CountClass', 'Ruby::CountClass', \&Ruby::CountClass::CountClass, 'APPEL', 1 ],

     [ Ident::Alias_AssignmentsInConditionalExpr(), 'CountCondition', 'Ruby::CountCondition', \&Ruby::CountCondition::CountCondition, 'APPEL', 1 ],
     [ Ident::Alias_ComplexConditions(), 'CountCondition', 'Ruby::CountCondition', \&Ruby::CountCondition::CountCondition, 'APPEL', 1 ],
     [ Ident::Alias_InvertedLogic(), 'CountCondition', 'Ruby::CountCondition', \&Ruby::CountCondition::CountCondition, 'APPEL', 1 ],
     [ Ident::Alias_NegativeConditions(), 'CountCondition', 'Ruby::CountCondition', \&Ruby::CountCondition::CountCondition, 'APPEL', 1 ],
     [ Ident::Alias_UselessParenthesesForConditions(), 'CountCondition', 'Ruby::CountCondition', \&Ruby::CountCondition::CountCondition, 'APPEL', 1 ],
     [ Ident::Alias_MissingDefaults(), 'CountSwitch', 'Ruby::CountCondition', \&Ruby::CountCondition::CountSwitch, 'APPEL', 1 ],
     [ Ident::Alias_UnlessWithElse(), 'CountUnless', 'Ruby::CountCondition', \&Ruby::CountCondition::CountUnless, 'APPEL', 1 ],
     
);

sub get_table_Comptages() {
  return \@table_Comptages;
}

our @table_Synth_Comptages = (
     # [ Ident::Alias_VG(), 'CountVG', 'Java::CountJava', \&Java::CountJava::CountVG, 'APPEL', 1 ],

);

sub get_table_Synth_Comptages() {
  return \@table_Synth_Comptages;
}

1;

