# Composant: Plugin
# Module de creation des vues code et comment a partir de la vue text d'un
# source Cobol

package StripCobol;

use strict;
use warnings ;

use CommonOutput::ManageVue;

# parser is working on text vue, we are adding code view & string extraction for diags
sub separer_code_chaines($$)
{
    my ($vues, $options) = @_;
    my $text = $vues->{'text'};
    my $code = \$vues->{'code'};
    my $MIX = \$vues->{'MixBloc'};

    my %HString;
    my $stringID;
    my $error = 0;

    while ($text =~ /([^\n]*)\n/g) {

        my $line = $1;
        # comment lines begin by * or /
        if ($line =~ /^\d*\s*[*\/]/m) {
            $$code .= "\n";
            $$MIX .= "/* " . $line . "*/ \n";
        }
        else {
            my $line_stringID;
            while ($line =~ /(["'].*?["'])/g) {
                # if value doesn't exists
                if (! grep {$_ eq $1} values %HString) {
                    $stringID++;
                    $HString{"CHAINE_".$stringID} = $1;
                }
                $line_stringID = $line;
                my $chaine_str = quotemeta ($HString{"CHAINE_".$stringID});
                $line_stringID =~ s/$chaine_str/CHAINE_$stringID/g;
            }
            if (defined $line_stringID) {
                $$code .= $line_stringID . "\n";
                $$MIX .= $line_stringID . "\n";
            }
            elsif  (defined $line) {
                $$code .= $line . "\n";
                $$MIX .= $line . "\n";
            }
            else {
                $error = 1;
            }
        }
    }

    if ($error == 0)
    {
        $vues->{'HString'} = \%HString;
    }
    return $error;
}


# analyse du fichier
sub StripCobol($$$$)
{
    my ($filename, $vues, $options, $couples) = @_;
    if (defined $options->{'--verbose'} )
    {
        print "working with  $filename \n";
    }

    my $error =  separer_code_chaines($vues, $options);

    $vues->{'agglo'} = "";
    StripUtils::agglomerate_C_Comments(\$vues->{'MixBloc'}, \$vues->{'agglo'});

    CommonOutput::ManageVue::setVue($vues);

    return $error;
}


1;

