package framework::Logs;

my $DEBUG =0;
my $outputDirectory = "./";

my $LOG_CATEGORY = {};

sub setLogCategory($) {
	my $user_category = shift;
	
	for my $key (keys %{$user_category}) {
		$LOG_CATEGORY->{$key} = 1;
	}
}

sub init($) {
	my $options = shift;

	if ((defined $options->{'--framework-debug'}) || (defined $ENV{"HL_FRAMEWORK_DEBUG"})){
		$DEBUG = 1;
	}
	
	
}

sub setOutputDirectory($) {
	$outputDirectory = shift;
}

sub getOutputDirectory() {
	return $outputDirectory;
}

sub isDebugOn() {
	return $DEBUG;
}

sub Error($) {
	my $msg = shift;
	
	print STDERR "[framework] ERROR : $msg";
}

sub Warning($) {
	my $msg = shift;
	
	print STDERR "[framework] WARNING : $msg";
}

sub printErr($) {
	my $msg = shift;
	
	print STDERR "[framework] $msg";
}

sub Debug($;$) {
	my $msg = shift;
	my $category = shift;
	
	if (	($DEBUG) &&
			((! defined $category) || (exists $LOG_CATEGORY->{$category}))) {
		print STDERR "[framework] $msg";
	}
}

sub printOut($) {
	my $msg = shift;
	
	print "[framework] $msg";
}

1;
