package framework::frameworksDescr;
use strict;
use warnings;

my %DB = (
	'CS' => {
		'stackexchange.redis' => ['https://github.com/StackExchange/StackExchange.Redis/','Stack Exchange, Inc., marc.gravell',undef,'https://raw.github.com/StackExchange/StackExchange.Redis/master/LICENSE','High performance Redis client, incorporating both synchronous and asynchronous usage.',undef,],
		'jquery.ui.combined' => ['http://jqueryui.com/','jQuery UI Team',undef,'http://jquery.org/license','jQuery UI is an open source library of interface components — interactions, full-featured widgets, and animation effects — based on the stellar jQuery javascript library ',undef,],
		'hangfire.core' => ['http://hangfire.io/','Sergey Odinokov',undef,'https://raw.github.com/HangfireIO/Hangfire/master/LICENSE.md','Core components for Hangfire (background job system for ASP.NET applications).',undef,],
		'csla' => ['http://cslanet.com/',undef,'MIT',undef,'CSLA .NET is a software development framework that helps you build a reusable, maintainable object-oriented business layer for your app','Application framework',],
		'aforge' => ['http://www.aforgenet.com/','google','LGPL','http://www.aforgenet.com/framework/license.html','AForge.NET is a C# framework designed for developers and researchers in the fields of Computer Vision and Artificial Intelligence - image processing, neural networks, genetic algorithms, machine learning, robotics, etc.','Image Processing & Artificial Intelligence',],
		'google.apis.auth' => ['https://github.com/google/google-api-dotnet-client','Google Inc.',undef,'http://www.apache.org/licenses/LICENSE-2.0','The Google APIs Client Library is a runtime client for working with Google services.This package includes auth components like user-credential, authorization code flow, etc',undef,],
		'swashbuckle' => ['https://github.com/domaindrivendev/Swashbuckle','Richard Morris',undef,'http://opensource.org/licenses/BSD-3-Clause','Seamlessly adds a Swagger to WebApi projects!',undef,],
		'fluentassertions' => ['http://www.fluentassertions.com/','Dennis Doomen',undef,'https://github.com/fluentassertions/fluentassertions/blob/master/LICENSE','A very extensive set of extension methods that allow you to more naturally specify the expected outcome of a TDD or      BDD-style unit tests',undef,],
		'nmock' => ['http://nmock.sourceforge.net/',undef,'Proprietary','http://nmock.sourceforge.net/license.html','NMock is a dynamic mock object library for .NET.','Unit Testing framework',],
		'moq' => ['https://github.com/moq/moq4','Daniel Cazzulino, kzu',undef,'https://raw.githubusercontent.com/moq/moq4/master/License.txt','Moq is the most popular and friendly mocking framework for .NET',undef,],
		'automapper' => ['http://automapper.org/','Jimmy Bogard',undef,'https://github.com/AutoMapper/AutoMapper/blob/master/LICENSE.txt','A convention-based object-object mapper.',undef,],
		'nest' => ['https://github.com/elastic/elasticsearch-net','Elastic and contributors',undef,'https://github.com/elastic/elasticsearch-net/blob/master/license.txt','Strongly typed interface to Elasticsearch',undef,],
		'google.apis.core' => ['https://github.com/google/google-api-dotnet-client','Google Inc.',undef,'http://www.apache.org/licenses/LICENSE-2.0','The Google APIs Core Library contains the Google APIs HTTP layer, JSON support, Data-store, logging and so on.Supported Platforms:- .NET Framework 4.5+- NetStandard1.3, providing .NET Core support',undef,],
		'csvhelper' => ['https://github.com/JoshClose/CsvHelper','Josh Close',undef,'https://raw.githubusercontent.com/JoshClose/CsvHelper/master/LICENSE.txt','A library for reading and writing CSV files',undef,],
		'nunit3testadapter' => ['https://github.com/nunit/docs/wiki/VS-Adapter','Charlie Poole, Terje Sandstrom',undef,'http://nunit.org/nuget/nunit3-license.txt','A package including the NUnit 3 TestAdapter for Visual Studio 2012 onwards',undef,],
		'webactivatorex' => ['https://github.com/davidebbo/WebActivator','David Ebbo',undef,'http://opensource.org/licenses/Apache-2.0','A package that allows other packages to execute some startup code in web apps',undef,],
		'system.interactive.async' => ['http://go.microsoft.com/fwlink/?LinkId=261273','.NET Foundation and Contributors',undef,'https://raw.githubusercontent.com/Reactive-Extensions/Rx.NET/master/Ix.NET/Source/license.txt','Interactive Extensions Async Library used to express queries over asynchronous enumerable sequences.',undef,],
		'remotion.linq' => ['http://relinq.codeplex.com/','rubicon IT GmbH',undef,'http://opensource.org/licenses/Apache-2.0','re-linq Frontend: A foundation for parsing LINQ expression trees and generating queries in SQL or other languages.Key features:- Transforms expression trees into abstract syntax trees resemblying LINQ query expressions (from ..',undef,],
		'automapper.extensions.microsoft.dependencyinjection' => ['http://automapper.org/','Jimmy Bogard',undef,'https://github.com/AutoMapper/AutoMapper/blob/master/LICENSE.txt','AutoMapper extensions for ASP.NET Core',undef,],
		'mongodb.driver' => ['http://www.mongodb.org/display/DOCS/CSharp+Language+Center','MongoDB, Inc.',undef,'http://www.apache.org/licenses/LICENSE-2.0','Official .NET driver for MongoDB.',undef,],
		'jquery.validation' => ['http://bassistance.de/jquery-plugins/jquery-plugin-validation/','Jörn Zaefferer',undef,'https://raw.githubusercontent.com/domaindrivendev/Swashbuckle.AspNetCore/master/LICENSE','This jQuery plugin makes simple clientside form validation trivial, while offering lots of option for customization',undef,],
		'xunit' => ['https://github.com/xunit/xunit','James Newkirk, Brad Wilson',undef,'https://raw.githubusercontent.com/xunit/xunit/master/license.txt','xUnit.net is a developer testing framework, built to support Test Driven Development, with a design goal of extreme simplicity and alignment with framework features.Installing this package installs xunit.core, xunit.assert, and xunit.analyzers.',undef,],
		'xunit.extensibility.core' => ['https://github.com/xunit/xunit','James Newkirk, Brad Wilson',undef,'https://raw.githubusercontent.com/xunit/xunit/master/license.txt','Includes xunit.core.dll for extensibility purposes',undef,],
		'xunit.abstractions' => ['https://github.com/xunit/xunit','James Newkirk, Brad Wilson',undef,'https://raw.githubusercontent.com/xunit/xunit/master/license.txt','Common abstractions used to exchange information between xUnit.net and version-independent runners (xunit.abstractions.dll).',undef,],
		'xunit.extensibility.execution' => ['https://github.com/xunit/xunit','James Newkirk, Brad Wilson',undef,'https://raw.githubusercontent.com/xunit/xunit/master/license.txt','Includes xunit.execution.*.dll for extensibility purposes',undef,],
		'common.logging' => ['http://net-commons.github.io/common-logging/','Aleksandar Seovic, Mark Pollack, Erich Eichinger, Stephen Bohlen',undef,'http://jquery.org/license','Common.Logging library introduces a simple abstraction to allow you to select a specific logging implementation at runtime.',undef,],
		'serilog.sinks.rollingfile' => ['http://serilog.net/','Serilog Contributors',undef,'http://www.apache.org/licenses/LICENSE-2.0','The rolling file sink for Serilog - Simple .NET logging with fully-structured events',undef,],
		'serilog.settings.configuration' => ['https://github.com/serilog/serilog-settings-configuration','Serilog Contributors',undef,'https://www.apache.org/licenses/LICENSE-2.0','Microsoft.Extensions.Configuration (appsettings.json) support for Serilog.',undef,],
		'awssdk.s3' => ['https://github.com/aws/aws-sdk-net/','Amazon Web Services',undef,'http://aws.amazon.com/apache2.0/','Amazon Simple Storage Service (Amazon S3), provides developers and IT teams with secure, durable, highly-scalable object storage.',undef,],
		'mysql.data' => ['https://dev.mysql.com/downloads/','Oracle',undef,'https://downloads.mysql.com/docs/licenses/connector-net-8.0-gpl-en.pdf','MySql.Data.MySqlClient .Net Core Class Library',undef,],
		'log4net' => ['http://logging.apache.org/log4net/','The Apache Software Foundation',undef,'http://logging.apache.org/log4net/license.html','log4net is a tool to help the programmer output log statements to a variety of output targets',undef,],
		'justmock' => ['http://www.telerik.com/products/mocking.aspx',undef,'Proprietary',undef,'Fast, flexible, fully featured mocking framework','Unit Testing framework',],
		'sendgrid' => ['https://github.com/sendgrid/sendgrid-csharp','Elmer Thomas, SendGrid DX Team',undef,'https://github.com/sendgrid/sendgrid-csharp/blob/master/MIT.LICENSE','C# client library and examples for using SendGrid API\'s to send mail and access Web API v3 endpoints with .NET Standard 1.3 and .NET Core support',undef,],
		'octopack' => ['https://octopus.com/','Octopus Deploy',undef,'https://github.com/OctopusDeploy/OctoPack/blob/master/LICENSE.txt','Octopus Deploy is an automated deployment tool powered by NuGet',undef,],
		'sqlitepclraw.core' => ['https://github.com/ericsink/SQLitePCL.raw','Eric Sink, et al',undef,'https://raw.github.com/ericsink/SQLitePCL.raw/master/LICENSE.TXT','SQLitePCL.raw is a Portable Class Library (PCL) for low-level (raw) access to SQLite',undef,],
		'microsoft.entityframeworkcore.analyzers' => ['https://asp.net/','Microsoft',undef,'https://raw.githubusercontent.com/aspnet/Home/2.0.0/LICENSE.txt','CSharp Analyzers for Entity Framework Core.',undef,],
		'commonservicelocator' => ['https://github.com/unitycontainer/commonservicelocator','Microsoft.Practices.ServiceLocation',undef,'https://opensource.org/licenses/MS-PL','The library provides an abstraction over IoC containers and service locators',undef,],
		'identitymodel' => ['https://github.com/IdentityModel/IdentityModel2','Dominick Baier, Brock Allen',undef,'https://github.com/IdentityModel/IdentityModel2/blob/release/LICENSE','OpenID Connect & OAuth 2.0 client library',undef,],
		'bootstrap' => ['https://getbootstrap.com/','The Bootstrap Authors, Twitter Inc.',undef,'https://github.com/twbs/bootstrap/blob/master/LICENSE','The most popular front-end framework for developing responsive, mobile first projects on the web.',undef,],
		'selenium.webdriver.chromedriver' => ['https://github.com/jsakamoto/nupkg-selenium-webdriver-chromedriver/','jsakamoto',undef,'http://unlicense.org/','Install Chrome Driver (Win32, macOS, and Linux64) for Selenium WebDriver into your Unit Test Project',undef,],
		'mongodb.driver.core' => ['http://www.mongodb.org/display/DOCS/CSharp+Language+Center','MongoDB, Inc.',undef,'http://www.apache.org/licenses/LICENSE-2.0','Core Component of the Official MongoDB .NET Driver.',undef,],
		'swashbuckle.aspnetcore' => ['https://github.com/domaindrivendev/Swashbuckle.AspNetCore','Swashbuckle.AspNetCore',undef,'https://raw.githubusercontent.com/domaindrivendev/Swashbuckle.AspNetCore/master/LICENSE','Swagger tools for documenting APIs built on ASP.NET Core',undef,],
		'monorail' => ['http://www.castleproject.org/projects/monorail/',undef,'LGPL','http://www.gnu.org/licenses/lgpl.html','MVC framework where the controllers handle solely application flow, the models represent the data, and the view is just about presentation logic. If your project depends too much on third party Web controls or if your IT team skill set is totally centered around WebForms, MonoRail would not be a good choice','MVC framework',],
		'nlog' => ['http://nlog-project.org/','Jarek Kowalski, Kim Christensen, Julian Verdurmen',undef,'https://github.com/NLog/NLog/blob/master/LICENSE.txt','NLog is a logging platform for .NET with rich log routing and management capabilities.NLog supports traditional logging, structured logging and the combination of both.Supported platforms:- .NET Framework 3.5, 4, 4.5, 4.6 & 4.7- .NET Standard 1.3+ and 2.0+- .NET Framework 4 client profile- Xamarin Android, Xamarin iOs- UWP- Windows Phone 8- Silverlight 4 and 5- Mono 4For ASP.NET Core, check: https://www.nuget.org/packages/NLog.Web.AspNetCore',undef,],
		'castle.core' => ['http://www.castleproject.org/','Castle Project Contributors',undef,'http://www.apache.org/licenses/LICENSE-2.0.html','Castle Core, including DynamicProxy, Logging Abstractions and DictionaryAdapter',undef,],
		'dotnet-xunit' => ['https://github.com/xunit/xunit','James Newkirk, Brad Wilson',undef,'https://raw.githubusercontent.com/xunit/xunit/master/license.txt','.NET CLI SDK runner for the xUnit.net framework',undef,],
		'newtonsoft.json' => ['https://www.newtonsoft.com/json','James Newton-King',undef,'https://raw.github.com/JamesNK/Newtonsoft.Json/master/LICENSE.md','Json.NET is a popular high-performance JSON framework for .NET',undef,],
		'xunit.core' => ['https://github.com/xunit/xunit','James Newkirk, Brad Wilson',undef,'https://raw.githubusercontent.com/xunit/xunit/master/license.txt','Includes the libraries for writing unit tests with xUnit.net.',undef,],
		'protobuf-net' => ['https://github.com/mgravell/protobuf-net','Marc Gravell',undef,'https://github.com/mgravell/protobuf-net/blob/master/Licence.txt','Provides simple access to fast and efficient ""Protocol Buffers"" serialization from .NET applications',undef,],
		'google.apis' => ['https://github.com/google/google-api-dotnet-client','Google Inc.',undef,'http://www.apache.org/licenses/LICENSE-2.0','The Google APIs Client Library is a runtime client for working with Google services.The library supports service requests, media upload and download, etc',undef,],
		'sqlitepclraw.lib.e_sqlite3.osx' => ['https://github.com/ericsink/SQLitePCL.raw','Eric Sink, D. Richard Hipp, et al',undef,'https://raw.github.com/ericsink/SQLitePCL.raw/master/LICENSE.TXT','This package contains a platform-specific native code build of SQLite for use with SQLitePCL.raw',undef,],
		'microsoft.entityframeworkcore.abstractions' => ['https://asp.net/','Microsoft',undef,'https://raw.githubusercontent.com/aspnet/Home/2.0.0/LICENSE.txt','Provides abstractions and attributes that are used to configure Entity Framework Core',undef,],
		'awssdk.core' => ['https://github.com/aws/aws-sdk-net/','Amazon Web Services',undef,'http://aws.amazon.com/apache2.0/','The Amazon Web Services SDK for .NET - Core Runtime',undef,],
		'rabbitmq.client' => ['http://www.rabbitmq.com/dotnet.html','RabbitMQ.Client',undef,'http://www.rabbitmq.com/dotnet.html','The RabbitMQ .NET client is the official client library for C# (and, implicitly, other .NET languages)',undef,],
		'fluentvalidation' => ['http://github.com/JeremySkinner/fluentvalidation','Jeremy Skinner',undef,'https://github.com/JeremySkinner/FluentValidation/blob/master/License.txt','A validation library for .NET that uses a fluent interface to construct strongly-typed validation rules.',undef,],
		'selenium.support' => ['https://www.seleniumhq.org/','Selenium Committers',undef,'http://www.apache.org/licenses/LICENSE-2.0','Selenium is a set of different software tools each with a different approach      to supporting browser automation',undef,],
		'ncrontab' => ['https://github.com/atifaziz/NCrontab','Atif Aziz',undef,'http://www.apache.org/licenses/LICENSE-2.0','NCrontab is crontab for all .NET runtimes supported by .NET Standard 1.0',undef,],
		'xunit.runner.console' => ['https://github.com/xunit/xunit','James Newkirk, Brad Wilson',undef,'https://raw.githubusercontent.com/xunit/xunit/master/license.txt','Console runner for the xUnit.net framework',undef,],
		'fakeiteasy' => ['https://github.com/FakeItEasy/FakeItEasy',undef,'MIT',undef,'A .Net dynamic fake framework for creating all types of fake objects, mocks, stubs etc','Unit Testing framework',],
		'swashbuckle.core' => ['https://github.com/domaindrivendev/Swashbuckle','Richard Morris',undef,'http://opensource.org/licenses/BSD-3-Clause','Seamlessly adds a Swagger to WebApi projects!',undef,],
		'commandlineparser' => ['https://github.com/commandlineparser/commandline','gsscoder nemec ericnewton76',undef,'https://github.com/commandlineparser/commandline/blob/master/License.md','Terse syntax C# command line parser for .NET',undef,],
		'swashbuckle.aspnetcore.swaggerui' => ['https://github.com/domaindrivendev/Swashbuckle.AspNetCore','Swashbuckle.AspNetCore.SwaggerUI',undef,'https://raw.githubusercontent.com/domaindrivendev/Swashbuckle.AspNetCore/master/LICENSE','Middleware to expose an embedded version of the swagger-ui 3 from an ASP.NET Core application',undef,],
		'autofac' => ['http://autofac.org/','Autofac Contributors',undef,'http://www.opensource.org/licenses/mit-license.php','Autofac is an IoC container for Microsoft .NET',undef,],
		'sqlitepclraw.bundle_green' => ['https://github.com/ericsink/SQLitePCL.raw','Eric Sink',undef,'https://raw.github.com/ericsink/SQLitePCL.raw/master/LICENSE.TXT','This \'batteries-included\' bundle brings in SQLitePCLRaw.core and the necessary stuff for certain common use cases',undef,],
		'serilog.sinks.periodicbatching' => ['http://serilog.net/','Serilog Contributors',undef,'http://www.apache.org/licenses/LICENSE-2.0','The periodic batching sink for Serilog',undef,],
		'easymock.net' => ['https://sourceforge.net/projects/easymocknet/',undef,'BSD',undef,'EasyMock.NET is a class library that provides an easy way to use mockobjects for given interfaces or remote objects.','Unit Testing framework',],
		'sqlitepclraw.lib.e_sqlite3.v110_xp' => ['https://github.com/ericsink/SQLitePCL.raw','Eric Sink, D. Richard Hipp, et al',undef,'https://raw.github.com/ericsink/SQLitePCL.raw/master/LICENSE.TXT','This package contains a platform-specific native code build of SQLite for use with SQLitePCL.raw',undef,],
		'nunit.consolerunner' => ['http://nunit.org/','Charlie Poole, Rob Prouse',undef,'https://raw.githubusercontent.com/nunit/nunit-console/master/LICENSE.txt','This package includes the nunit3-console runner and test engine for version 3 of the NUnit unit-testing framework',undef,],
		'microsoft.aspnetcore.connections.abstractions' => ['https://asp.net/','Microsoft',undef,'https://raw.githubusercontent.com/aspnet/Home/2.0.0/LICENSE.txt','Core components of ASP.NET Core networking protocol stack.',undef,],
		'rhino mocks' => ['https://www.hibernatingrhinos.com/oss/rhino-mocks',undef,'BSD','http://www.codeproject.com/info/cpol10.aspx','Rhino Mocks is a dynamic mock object framework for the .Net platform. Its purpose is to ease testing by allowing the developer to create mock implementations of custom objects and verify the interactions using unit testing.','Unit Testing framework',],
		'swashbuckle.aspnetcore.swagger' => ['https://github.com/domaindrivendev/Swashbuckle.AspNetCore','Swashbuckle.AspNetCore.Swagger',undef,'https://raw.githubusercontent.com/domaindrivendev/Swashbuckle.AspNetCore/master/LICENSE','Middleware to expose Swagger JSON endpoints from API\'s built on ASP.NET Core',undef,],
		'nancy' => ['http://nancyfx.org/',undef,'MIT',undef,'Nancy is a lightweight, low-ceremony, framework for building HTTP based services on .NET and Mono. The goal of the framework is to stay out of the way as much as possible and provide a super-duper-happy-path to all interactions.','Web applications',],
		'unity' => ['https://github.com/unitycontainer/unity','Microsoft.Practices.Unity',undef,'https://github.com/unitycontainer/unity/blob/master/LICENSE','Unity Container Library as single package',undef,],
		'portable.bouncycastle' => ['https://www.bouncycastle.org/csharp/','Oren Novotny',undef,'https://www.bouncycastle.org/csharp/licence.html','BouncyCastle portable version with support for .NET 4, .NET Standard 1.0-2.0, WP, Silverlight, MonoAndroid, Xamarin.iOS, .NET Core',undef,],
		'stackexchange.redis.strongname' => ['https://github.com/StackExchange/StackExchange.Redis/','Stack Exchange, Inc., marc.gravell',undef,'https://raw.github.com/StackExchange/StackExchange.Redis/master/LICENSE','High performance Redis client, incorporating both synchronous and asynchronous usage.',undef,],
		'xunit.runner.visualstudio' => ['https://github.com/xunit/xunit','James Newkirk, Brad Wilson',undef,'https://raw.githubusercontent.com/xunit/xunit/master/license.txt','Visual Studio 2012+ Test Explorer runner for the xUnit.net framework',undef,],
		'nodatime' => ['http://nodatime.org/','Jon Skeet',undef,'http://www.apache.org/licenses/LICENSE-2.0','Noda Time is a date and time API acting as an alternative to the built-in DateTime/DateTimeOffset etc types built into the .NET framework.',undef,],
		'nsubstitute' => ['http://nsubstitute.github.com/','Anthony Egerton, David Tchepak, Alexandr Nikitin',undef,'https://github.com/nsubstitute/NSubstitute/raw/master/LICENSE.txt','NSubstitute is a friendly substitute for .NET mocking frameworks',undef,],
		'nunit' => ['http://nunit.org/','Charlie Poole, Rob Prouse',undef,'https://raw.githubusercontent.com/nunit/nunit/master/LICENSE.txt','NUnit features a fluent assert syntax, parameterized, generic and theory tests and is user-extensible.This package includes the NUnit 3 framework assembly, which is referenced by your tests',undef,],
		'nsubstitute' => ['http://nsubstitute.github.io/',undef,'BSD',undef,'NSubstitute is designed as a friendly substitute for .NET mocking libraries.','Unit Testing framework',],
		'jquery' => ['http://jquery.com/','jQuery Foundation, Inc.',undef,'http://jquery.org/license','jQuery is a new kind of JavaScript Library',undef,],
		'serilog.sinks.file' => ['http://serilog.net/','Serilog Contributors',undef,'http://www.apache.org/licenses/LICENSE-2.0','Write Serilog events to text files in plain or JSON format.',undef,],
		'htmlagilitypack' => ['http://html-agility-pack.net/','ZZZ Projects, Simon Mourrier, Jeff Klawiter, Stephan Grell',undef,'https://github.com/zzzprojects/html-agility-pack/blob/master/LICENSE','This is an agile HTML parser that builds a read/write DOM and supports plain XPATH or XSLT (you actually don\'t HAVE to understand XPATH nor XSLT to use it, don\'t worry...)',undef,],
		'autofixture' => ['https://github.com/AutoFixture/AutoFixture','Mark Seemann, AutoFixture',undef,'https://github.com/AutoFixture/AutoFixture/blob/master/LICENCE.txt','AutoFixture makes it easier for developers to do Test-Driven Development by automating non-relevant Test Fixture Setup, allowing the Test Developer to focus on the essentials of each test case.',undef,],
		'epplus' => ['https://github.com/JanKallman/EPPlus','Jan Källman',undef,'https://www.gnu.org/licenses/lgpl-3.0.en.html','Create advanced Excel spreadsheets using .NET',undef,],
		'swashbuckle.aspnetcore.swaggergen' => ['https://github.com/domaindrivendev/Swashbuckle.AspNetCore','Swashbuckle.AspNetCore.SwaggerGen',undef,'https://raw.githubusercontent.com/domaindrivendev/Swashbuckle.AspNetCore/master/LICENSE','Swagger Generator for API\'s built on ASP.NET Core',undef,],
		'stylecop.analyzers' => ['https://github.com/DotNetAnalyzers/StyleCopAnalyzers','Sam Harwell et. al.',undef,'https://raw.githubusercontent.com/DotNetAnalyzers/StyleCopAnalyzers/1.0.2/LICENSE','An implementation of StyleCop\'s rules using Roslyn analyzers and code fixes',undef,],
		'sharpziplib' => ['http://www.icsharpcode.net/OpenSource/SharpZipLib/Default.aspx','http://www.icsharpcode.net/',undef,'http://www.apache.org/licenses/LICENSE-2.0','#ziplib (SharpZipLib, formerly NZipLib) is a Zip, GZip, Tar and BZip2 library written entirely in C# for the .NET platform',undef,],
		'modernizr' => ['http://www.modernizr.com/','Faruk Ateş,  Paul Irish,  Alex Sexton',undef,'http://www.modernizr.com/license/','Modernizr adds classes to the <html> element which allow you to target specific browser functionality in your stylesheet',undef,],
		'mongodb.bson' => ['http://www.mongodb.org/display/DOCS/CSharp+Language+Center','MongoDB, Inc.',undef,'http://www.apache.org/licenses/LICENSE-2.0','MongoDB\'s Official Bson Library.',undef,],
		'typemock isolator' => ['http://www.typemock.com/isolator-product-page',undef,'Proprietary',undef,'Typemock Isolator is a complete system to help you become agile by automating most of your unit testing tasks. It�enables you to get more coverage with the original Isolator and it Runs your impacted tests�in fast and intelligently.�','Unit Testing framework',],
		'restsharp' => ['http://restsharp.org/','John Sheehan, RestSharp Community',undef,'https://github.com/restsharp/RestSharp/blob/master/LICENSE.txt','Simple REST and HTTP API Client',undef,],
		'xunit.analyzers' => ['https://github.com/xunit/xunit.analyzers','Marcin Dobosz',undef,'https://raw.githubusercontent.com/xunit/xunit.analyzers/master/LICENSE','Code Analyzers for projects using xUnit.net that help find and fix frequent issues when writing tests.',undef,],
		'microsoft.diagnostics.tracing.eventsource.redist' => ['https://dot.net/','Microsoft',undef,'https://github.com/dotnet/corefx/blob/master/LICENSE.TXT','This package includes the class Microsoft.Diagnostics.Tracing.EventSource which enables firing ETW events from managed code',undef,],
		'dapper' => ['https://github.com/StackExchange/Dapper','Sam Saffron, Marc Gravell, Nick Craver',undef,'http://www.apache.org/licenses/LICENSE-2.0','A high performance Micro-ORM supporting SQL Server, MySQL, Sqlite, SqlCE, Firebird etc..',undef,],
		'owin' => ['https://github.com/owin-contrib/owin-hosting/','OWIN startup components contributors',undef,'https://github.com/owin-contrib/owin-hosting/blob/master/LICENSE.txt','OWIN IAppBuilder startup interface',undef,],
		'antlr' => ['https://github.com/antlr/antlrcs','Sam Harwell, Terence Parr',undef,'http://www.antlr3.org/license.html','ANother Tool for Language Recognition, is a language tool that provides a framework for constructing recognizers, interpreters, compilers, and translators from grammatical descriptions containing actions in a variety of target languages.',undef,],
		'serilog.sinks.console' => ['https://github.com/serilog/serilog-sinks-console','Serilog Contributors',undef,'https://www.apache.org/licenses/LICENSE-2.0','A Serilog sink that writes log events to the console/terminal.',undef,],
		'serilog.extensions.logging' => ['https://github.com/serilog/serilog-extensions-logging','Microsoft, Serilog Contributors',undef,'http://www.apache.org/licenses/LICENSE-2.0','Low-level Serilog provider for Microsoft.Extensions.Logging',undef,],
		'selenium.webdriver' => ['https://www.seleniumhq.org/','Selenium Committers',undef,'http://www.apache.org/licenses/LICENSE-2.0','Selenium is a set of different software tools each with a different approach      to supporting browser automation',undef,],
		'common.logging.core' => ['http://net-commons.github.io/common-logging/','Aleksandar Seovic, Mark Pollack, Erich Eichinger, Stephen Bohlen',undef,'https://github.com/commandlineparser/commandline/blob/master/License.md','Common.Logging.Core contains the portable (PCL) implementation of the Common.Logging low-level abstractions common to all other Common.Logging packages.',undef,],
		'documentformat.openxml' => ['https://github.com/OfficeDev/Open-XML-SDK','Microsoft',undef,'https://github.com/OfficeDev/Open-XML-SDK/blob/master/LICENSE','The Open XML SDK provides tools for working with Office Word, Excel, and PowerPoint documents',undef,],
		'polly' => ['https://github.com/App-vNext/Polly','Michael Wolfenden, App vNext',undef,'https://raw.github.com/App-vNext/Polly/master/LICENSE.txt','Polly is a .NET Standard 1.1 and .NET Standard 2.0 library that allows developers to express resilience and transient fault handling policies such as Retry, Circuit Breaker, Timeout, Bulkhead Isolation and Fallback in a fluent and thread-safe manner.',undef,],
		'ninject' => ['http://www.ninject.org/','Ninject Project Contributors',undef,'https://github.com/ninject/ninject/raw/master/LICENSE.txt','Ninject is a lightning-fast, ultra-lightweight dependency injector for .NET applications.',undef,],
		'sqlitepclraw.lib.e_sqlite3.linux' => ['https://github.com/ericsink/SQLitePCL.raw','Eric Sink, D. Richard Hipp, et al',undef,'https://raw.github.com/ericsink/SQLitePCL.raw/master/LICENSE.TXT','This package contains a platform-specific native code build of SQLite for use with SQLitePCL.raw',undef,],
		'moq' => ['https://github.com/Moq/moq4/',undef,'BSD',undef,'The most popular and friendly mocking framework for .NET','Unit Testing framework',],
		'xunit.assert' => ['https://github.com/xunit/xunit','James Newkirk, Brad Wilson',undef,'https://raw.githubusercontent.com/xunit/xunit/master/license.txt','Includes the assertion library from xUnit.net (xunit.assert.dll)',undef,],
		'npgsql' => ['http://www.npgsql.org/','Shay Rojansky, Emil Lenngren, Francisco Figueiredo Jr., Kenji Uno',undef,'https://raw.githubusercontent.com/npgsql/npgsql/master/LICENSE.txt','Npgsql is the open source .NET data provider for PostgreSQL.',undef,],
		'elasticsearch.net' => ['https://github.com/elastic/elasticsearch-net','Elastic and contributors',undef,'https://github.com/elastic/elasticsearch-net/blob/master/license.txt','Elasticsearch.Net',undef,],
		'serilog' => ['https://github.com/serilog/serilog','Serilog Contributors',undef,'https://www.apache.org/licenses/LICENSE-2.0','Simple .NET logging with fully-structured events',undef,],
		'google.protobuf' => ['https://github.com/google/protobuf','Google Inc.',undef,'https://github.com/google/protobuf/blob/master/LICENSE','C# runtime library for Protocol Buffers - Google\'s data interchange format.',undef,],
		'respond' => ['https://github.com/scottjehl/Respond','Scott Jehl, Paul Irish, Nicholas Zakas',undef,'https://github.com/scottjehl/Respond/blob/master/LICENSE-MIT','The goal of this script is to provide a fast and lightweight (3kb minified / 1kb gzipped) script to enable responsive web designs in browsers that don\'t support CSS3 Media Queries - in particular, Internet Explorer 8 and under',undef,],
	},

	'Python' => {
		'configobj' => ['http://www.voidspace.org.uk/python/configobj.html',undef,undef,undef,'INI file parser with validation.',undef,],
		'greenlet' => ['https://github.com/python-greenlet/greenlet','Alexey Borzenkov','MIT License',undef,'Lightweight in-process concurrent programming',undef,],
		'flask-oauthlib' => ['https://github.com/lepture/flask-oauthlib','lepture','BSD 3-Clause ""New"" or ""Revised"" License',undef,'OAuth 1.0/a. 2.0 implementation of client and provider for Flask.',undef,],
		'wxpython' => ['https://wxpython.org/',undef,undef,undef,'A blending of the wxWidgets C++ class library with the Python.',undef,],
		'factory_boy' => ['https://github.com/FactoryBoy/factory_boy','FactoryBoy','MIT License',undef,'A test fixtures replacement for Python.',undef,],
		'marshmallow' => ['https://github.com/marshmallow-code/marshmallow','marshmallow-code','MIT License',undef,'marshmallow is an ORM/ODM/framework-agnostic library for converting complex datatypes. such as objects. to and from native Python datatypes.',undef,],
		'cubicweb' => ['https://www.cubicweb.org/',undef,'LGPL 3.0',undef,'CubicWeb is a semantic web application framework, that empowers developers to efficiently build web applications by reusing components (called cubes) and following the well known object-oriented design principles.','web framework',],
		'pydub' => ['https://github.com/jiaaro/pydub','jiaaro','MIT License',undef,'Manipulate audio with a simple and easy high level interface.',undef,],
		'thrift' => ['http://thrift.apache.org','Thrift Developers',undef,undef,'Python bindings for the Apache Thrift RPC system',undef,],
		'voluptuous' => ['https://github.com/alecthomas/voluptuous','alecthomas','BSD 3-Clause ""New"" or ""Revised"" License',undef,'A Python data validation library.',undef,],
		'python-sql' => ['https://pypi.python.org/pypi/python-sql',undef,undef,undef,'Write SQL queries pythonically.',undef,],
		'dejavu' => ['https://github.com/worldveil/dejavu','worldveil','MIT License',undef,'Audio fingerprinting and recognition.',undef,],
		'pyenv' => ['https://github.com/pyenv/pyenv','pyenv','MIT License',undef,'Simple Python version management.',undef,],
		'django-mptt' => ['http://github.com/django-mptt/django-mptt','Craig de Stigter','MIT License',undef,'Utilities for implementing Modified Preorder Tree Traversal with your Django Models and working with trees of Model instances.',undef,],
		'pyopengl' => ['http://pyopengl.sourceforge.net/',undef,undef,undef,'Python ctypes bindings for OpenGL and its related APIs.',undef,],
		'orange' => ['https://orange.biolab.si/',undef,undef,undef,'Data mining. data visualization. analysis and machine learning through visual programming or scripts.',undef,],
		'mocket' => ['https://github.com/mindflayer/python-mocket','mindflayer','BSD 3-Clause ""New"" or ""Revised"" License',undef,'Socket Mock Framework plus HTTP[S]/asyncio/gevent mocking library with recording/replaying capability.',undef,],
		'python-dateutil' => ['https://dateutil.readthedocs.io','Gustavo Niemeyer','BSD License',undef,'Extensions to the standard Python datetime module',undef,],
		'pygram' => ['https://github.com/ajkumar25/pygram','ajkumar25',undef,undef,'Instagram-like image filters.',undef,],
		'gunnery' => ['https://github.com/gunnery/gunnery','gunnery','Apache License 2.0',undef,'Multipurpose task execution tool for distributed systems with web-based interface.',undef,],
		'moment' => ['https://github.com/zachwill/moment','zachwill',undef,undef,'A Python library for dealing with dates/times. Inspired by [Moment.js](http://momentjs.com/).',undef,],
		'pastedeploy' => ['http://pythonpaste.org/deploy/','Alex Gronholm','MIT License',undef,'Load, configure, and compose WSGI applications and servers',undef,],
		'talkbox' => ['http://scikits.appspot.com/talkbox',undef,undef,undef,'A Python library for speech/signal processing.',undef,],
		'moviepy' => ['http://zulko.github.io/moviepy/',undef,undef,undef,'A module for script-based movie editing with many formats. including animated GIFs.',undef,],
		'hiredis' => ['https://github.com/redis/hiredis-py','Jan-Erik Rediger, Pieter Noordhuis','BSD License',undef,'Python wrapper for hiredis',undef,],
		'flask-sqlalchemy' => ['http://github.com/mitsuhiko/flask-sqlalchemy','Phil Howell','BSD License',undef,'Adds SQLAlchemy support to your Flask application',undef,],
		'esengine' => ['https://github.com/seek-ai/esengine','seek-ai','MIT License',undef,'ElasticSearch ODM (Object Document Mapper) for Python.',undef,],
		'manhole' => ['https://github.com/ionelmc/python-manhole','ionelmc','Other',undef,'Debug service that will accept unix domain socket connections and present the stacktraces for all threads and an interactive prompt.',undef,],
		'python-heatclient' => ['http://docs.openstack.org/developer/python-heatclient/','OpenStack','Apache Software License',undef,'OpenStack Orchestration API Client Library',undef,],
		'posix_ipc' => ['http://semanchuk.com/philip/posix_ipc/','Philip Semanchuk','BSD License',undef,'POSIX IPC primitives (semaphores, shared memory and message queues) for Python',undef,],
		'pep8' => ['http://pep8.readthedocs.org/','Ian Lee','MIT License',undef,'Python style guide checker',undef,],
		'pycco' => ['https://github.com/pycco-docs/pycco','pycco-docs','Other',undef,'The literate-programming-style documentation generator.',undef,],
		'ptpython' => ['https://github.com/jonathanslenders/ptpython','jonathanslenders','BSD 3-Clause ""New"" or ""Revised"" License',undef,'Advanced Python REPL built on top of the [python-prompt-toolkit](https://github.com/jonathanslenders/python-prompt-toolkit).',undef,],
		'pygraphviz' => ['https://pypi.python.org/pypi/pygraphviz',undef,undef,undef,'Python interface to [Graphviz](http://www.graphviz.org/).',undef,],
		'tmuxp' => ['https://github.com/tony/tmuxp','tony','MIT License',undef,'A [tmux](https://github.com/tmux/tmux) session manager.',undef,],
		'setuptools' => ['https://github.com/pypa/setuptools','Python Packaging Authority','MIT License',undef,'Easily download, build, install, upgrade, and uninstall Python packages',undef,],
		'initools' => ['http://pythonpaste.org/initools/','Ian Bicking','MIT License',undef,'Tools for parsing and using INI-style files',undef,],
		'python-glanceclient' => ['https://docs.openstack.org/python-glanceclient/latest/','OpenStack','Apache Software License',undef,'OpenStack Image API Client Library',undef,],
		'bcdoc' => ['https://github.com/botocore/bcdoc','Amazon Web Services',undef,undef,'ReST document generation tools for botocore.',undef,],
		'sublimejedi' => ['https://github.com/srusskih/SublimeJEDI','srusskih','MIT License',undef,'A Sublime Text plugin to the awesome auto-complete library Jedi.',undef,],
		'lockfile' => ['http://launchpad.net/pylockfile','OpenStack','MIT License',undef,'Platform-independent file locking module',undef,],
		'vowpal_porpoise' => ['https://github.com/josephreisinger/vowpal_porpoise','josephreisinger','Other',undef,'A lightweight Python wrapper for [Vowpal Wabbit](https://github.com/JohnLangford/vowpal_wabbit/).',undef,],
		'shoop' => ['https://www.shuup.com/en/',undef,undef,undef,'An open source E-Commerce platform based on Django.',undef,],
		'pytorch' => ['http://pytorch.org/',undef,undef,undef,'Tensors and Dynamic neural networks in Python with strong GPU acceleration.',undef,],
		'trollius' => ['https://github.com/haypo/trollius','Victor Stinner','Apache Software License',undef,'Port of the Tulip project (asyncio module, PEP 3156) on Python 2',undef,],
		'sqlobject' => ['http://sqlobject.org/','Ian Bicking','GNU Library or Lesser General Public License (LGPL)',undef,'Object-Relational Manager, aka database wrapper',undef,],
		'webassets' => ['https://github.com/miracle2k/webassets','miracle2k','Other',undef,'Bundles. optimizes. and manages unique cache-busting URLs for static resources.',undef,],
		'lamson' => ['https://github.com/zedshaw/lamson','zedshaw','Other',undef,'Pythonic SMTP Application Server.',undef,],
		'scrapy' => ['https://scrapy.org/',undef,undef,undef,'A fast high-level screen scraping and web crawling framework.',undef,],
		'python-neutronclient' => ['https://docs.openstack.org/python-neutronclient/latest/','OpenStack Networking Project','Apache Software License',undef,'CLI and Client Library for OpenStack Networking',undef,],
		'os-client-config' => ['https://docs.openstack.org/os-client-config/latest','OpenStack','Apache Software License',undef,'OpenStack Client Configuation Library',undef,],
		'py2neo' => ['http://py2neo.org/2.0/',undef,undef,undef,'Python wrapper client for Neo4js restful interface.',undef,],
		'python-currencies' => ['https://github.com/Alir3z4/python-currencies','Alir3z4','GNU General Public License v3.0',undef,'Display money format and its filthy currencies.',undef,],
		'watchdog' => ['https://github.com/gorakhargosh/watchdog','gorakhargosh','Other',undef,'API and shell utilities to monitor file system events.',undef,],
		'simplegeneric' => ['http://cheeseshop.python.org/pypi/simplegeneric','Phillip J. Eby','Zope Public License',undef,'Simple generic functions (similar to Python\'s own len(), pickle.dump(), etc.)',undef,],
		'pulsar' => ['https://github.com/quantmind/pulsar','quantmind','BSD 3-Clause ""New"" or ""Revised"" License',undef,'Event-driven concurrent framework for Python.',undef,],
		's3transfer' => ['https://github.com/boto/s3transfer','Amazon Web Services','Apache Software License',undef,'An Amazon S3 Transfer Manager',undef,],
		'django-wordpress' => ['https://github.com/istrategylabs/django-wordpress','istrategylabs','BSD 3-Clause ""New"" or ""Revised"" License',undef,'WordPress models and views for Django.',undef,],
		'urwid' => ['http://urwid.org/',undef,undef,undef,'A library for creating terminal GUI applications with strong support for widgets. events. rich colors. etc.',undef,],
		'meld3' => ['https://github.com/supervisor/meld3','Chris McDonough',undef,undef,'meld3 is an HTML/XML templating engine.',undef,],
		'localshop' => ['https://github.com/jazzband/localshop','jazzband','MIT License',undef,'Local PyPI server (custom packages and auto-mirroring of pypi).',undef,],
		'django models' => ['https://docs.djangoproject.com/en/dev/topics/db/models/',undef,undef,undef,'A part of Django.',undef,],
		'django-extensions' => ['http://github.com/django-extensions/django-extensions','Michael Trier','MIT License',undef,'Extensions for Django',undef,],
		'bccb' => ['https://github.com/chapmanb/bcbb','chapmanb',undef,undef,'Collection of useful code related to biological analysis.',undef,],
		'python-novaclient' => ['https://docs.openstack.org/python-novaclient/latest','OpenStack','Apache Software License',undef,'Client library for OpenStack Compute API',undef,],
		'curses' => ['https://docs.python.org/3/library/curses.html',undef,undef,undef,'Built-in wrapper for [ncurses](http://www.gnu.org/software/ncurses/) used to create terminal GUI applications.',undef,],
		'merchant' => ['https://github.com/agiliq/merchant','agiliq','BSD 3-Clause ""New"" or ""Revised"" License',undef,'A Django app to accept payments from various payment processors.',undef,],
		'wand' => ['https://github.com/dahlia/wand','dahlia','MIT License',undef,'Python bindings for [MagickWand](http://www.imagemagick.org/script/magick-wand.php). C API for ImageMagick.',undef,],
		'textdistance' => ['https://github.com/orsinium/textdistance','orsinium','GNU Lesser General Public License v3.0',undef,'Compute distance between sequences. 30+ algorithms. pure python implementation. common interface. optional external libs usage.',undef,],
		'tinkerer' => ['http://tinkerer.me/',undef,undef,undef,'Tinkerer is a blogging engine/.static website generator powered by Sphinx.',undef,],
		'future' => ['https://python-future.org','Ed Schofield','MIT License',undef,'Clean single-source support for Python 3 and 2',undef,],
		'django-schedule' => ['https://github.com/thauber/django-schedule','thauber',undef,undef,'A calendaring app for Django.',undef,],
		'webtest' => ['http://webtest.pythonpaste.org/','Gael Pasgrimaud','MIT License',undef,'Helper to test WSGI applications',undef,],
		'websocket-client' => ['https://github.com/websocket-client/websocket-client.git','liris','GNU Library or Lesser General Public License (LGPL)',undef,'WebSocket client for python. hybi13 is supported.',undef,],
		'leaf' => ['https://github.com/penpen/leaf','Roman Koblov','MIT License',undef,'Simple Python library for HTML parsing',undef,],
		'sympy' => ['https://github.com/sympy/sympy','sympy','Other',undef,'A Python library for symbolic mathematics.',undef,],
		'quads' => ['https://github.com/fogleman/Quads','fogleman',undef,undef,'Computer art based on quadtrees.',undef,],
		'werkzeug' => ['http://werkzeug.pocoo.org/',undef,undef,undef,'A WSGI utility library for Python that powers Flask and can easily be embedded into your own projects.',undef,],
		'swig' => ['http://www.swig.org/Doc1.3/Python.html',undef,undef,undef,'Simplified Wrapper and Interface Generator.',undef,],
		'rdflib' => ['https://github.com/RDFLib/rdflib','RDFLib Team','BSD License',undef,'RDFLib is a Python library for working with RDF, a simple yet powerful language for representing information.',undef,],
		'phonenumbers' => ['https://github.com/daviddrysdale/python-phonenumbers','daviddrysdale','Apache License 2.0',undef,'Parsing. formatting. storing and validating international phone numbers.',undef,],
		'mccabe' => ['https://github.com/pycqa/mccabe','Ian Cordasco','MIT License',undef,'McCabe checker, plugin for flake8',undef,],
		'mamba' => ['http://nestorsalceda.github.io/mamba/',undef,undef,undef,'The definitive testing tool for Python. Born under the banner of BDD.',undef,],
		'python-markdown' => ['https://github.com/waylan/Python-Markdown','waylan','Other',undef,'A Python implementation of John Gruber’s Markdown.',undef,],
		'djedi-cms' => ['http://djedi-cms.org/',undef,undef,undef,'A lightweight but yet powerful Django CMS with plugins. inline editing and performance in mind.',undef,],
		'scipy' => ['https://www.scipy.org/',undef,undef,undef,'A Python-based ecosystem of open-source software for mathematics. science. and engineering.',undef,],
		'awesome-postgres' => ['https://github.com/dhamaniasad/awesome-postgres',undef,undef,undef,'[awesome-postgres](https://github.com/dhamaniasad/awesome-postgres)',undef,],
		'openpyxl' => ['https://openpyxl.readthedocs.io/en/default/',undef,undef,undef,'A library for reading and writing Excel 2010 xlsx/xlsm/xltx/xltm files.',undef,],
		'robobrowser' => ['https://github.com/jmcarp/robobrowser','jmcarp',undef,undef,'A simple. Pythonic library for browsing the web without a standalone web browser.',undef,],
		'pox' => ['https://github.com/noxrepo/pox','noxrepo','Apache License 2.0',undef,'An open source development platform for Python-based Software Defined Networking (SDN) control applications. such as OpenFlow SDN controllers.',undef,],
		'spark ml' => ['http://spark.apache.org/docs/latest/ml-guide.html',undef,undef,undef,'[Apache Spark](http://spark.apache.org/)s scalable Machine Learning library.',undef,],
		'memory_profiler' => ['https://github.com/fabianp/memory_profiler','fabianp','Other',undef,'Monitor Memory usage of Python code.',undef,],
		'feincms' => ['http://www.feincms.org/',undef,undef,undef,'One of the most advanced Content Management Systems built on Django.',undef,],
		'robotframework' => ['http://robotframework.org','Robot Framework Developers','Apache Software License',undef,'A generic test automation framework',undef,],
		'diamond' => ['https://github.com/python-diamond/Diamond','The Diamond Team',undef,undef,'Smart data producer for graphite graphing package',undef,],
		'pyparsing' => ['http://pyparsing.wikispaces.com/',undef,undef,undef,'A general purpose framework for generating parsers.',undef,],
		'msgpack-python' => ['http://msgpack.org/','INADA Naoki','Apache Software License',undef,'MessagePack (de)serializer.',undef,],
		'algorithms' => ['https://github.com/keon/algorithms','keon','MIT License',undef,'Minimal examples of data structures and algorithms in Python.',undef,],
		'nose2' => ['https://github.com/nose-devs/nose2','nose-devs','Other',undef,'The successor to nose. based on unittest2.',undef,],
		'sanic' => ['https://github.com/channelcat/sanic','channelcat','MIT License',undef,'Web server thats written to go fast.',undef,],
		'unidecode' => [undef,'Tomaz Solc','GNU General Public License v2 or later (GPLv2+)',undef,'ASCII transliterations of Unicode text',undef,],
		'bjoern' => ['https://pypi.python.org/pypi/bjoern',undef,undef,undef,'Asynchronous. very fast and written in C.',undef,],
		'pyspark' => ['https://pypi.python.org/pypi/pyspark/',undef,undef,undef,'Apache Spark Python API.',undef,],
		'pystache' => ['http://github.com/defunkt/pystache','Chris Jerdonek','MIT License',undef,'Mustache for Python',undef,],
		'pyyaml' => ['http://pyyaml.org/wiki/PyYAML','Kirill Simonov','MIT License',undef,'YAML parser and emitter for Python',undef,],
		'fn.py' => ['https://github.com/kachayev/fn.py','kachayev','Other',undef,'Functional programming in Python: implementation of missing features to enjoy FP.',undef,],
		'hermescache' => ['https://pypi.python.org/pypi/HermesCache',undef,undef,undef,'Python caching library with tag-based invalidation and dogpile effect prevention.',undef,],
		'cryptography' => ['https://cryptography.io/en/latest/',undef,undef,undef,'A package designed to expose cryptographic primitives and recipes to Python developers.',undef,],
		'bitbake' => ['http://www.yoctoproject.org/docs/1.6/bitbake-user-manual/bitbake-user-manual.html',undef,undef,undef,'A make-like build tool for embedded Linux.',undef,],
		'valideer' => ['https://github.com/podio/valideer','podio','MIT License',undef,'Lightweight extensible data validation and adaptation library.',undef,],
		'ino' => ['http://inotool.org/',undef,undef,undef,'Command line toolkit for working with [Arduino](https://www.arduino.cc/).',undef,],
		'oauth2' => ['http://github.com/joestump/python-oauth2','Joe Stump','MIT License',undef,'library for OAuth version 1.9',undef,],
		'flask' => ['https://www.palletsprojects.com/p/flask/','Armin Ronacher','BSD License',undef,'A simple framework for building complex web applications.',undef,],
		'httplib2' => ['https://github.com/httplib2/httplib2','httplib2','Other',undef,'Comprehensive HTTP client library.',undef,],
		'argh' => ['http://github.com/neithere/argh/','Andrey Mikhaylenko','GNU Library or Lesser General Public License (LGPL)',undef,'An unobtrusive argparse wrapper with natural syntax',undef,],
		'liclipse' => ['http://www.liclipse.com/',undef,undef,undef,'Free polyglot IDE based on Eclipse. Uses PyDev for Python support.',undef,],
		'oslo.rootwrap' => ['https://docs.openstack.org/oslo.rootwrap/latest/','OpenStack','Apache Software License',undef,'Oslo Rootwrap',undef,],
		'sanction' => ['https://github.com/demianbrecht/sanction','demianbrecht','MIT License',undef,'A dead simple OAuth2 client implementation.',undef,],
		'virtualenv-clone' => ['http://github.com/edwardgeorge/virtualenv-clone','Edward George','MIT License',undef,'script to clone virtualenvs.',undef,],
		'astropy' => ['http://www.astropy.org/',undef,undef,undef,'A community Python library for Astronomy.',undef,],
		'scons' => ['http://www.scons.org/',undef,undef,undef,'A software construction tool.',undef,],
		'pickleshare' => ['https://github.com/pickleshare/pickleshare','Ville Vainio','MIT License',undef,'Tiny \'shelve\'-like database with concurrency support',undef,],
		'marionette_client' => ['https://wiki.mozilla.org/Auto-tools/Projects/Marionette','Auto-tools','Mozilla Public License 2.0 (MPL 2.0)',undef,'Marionette test automation client',undef,],
		'purl' => ['https://github.com/codeinthehole/purl','codeinthehole','MIT License',undef,'A simple. immutable URL class with a clean API for interrogation and manipulation.',undef,],
		'schema' => ['https://github.com/keleshev/schema','keleshev','MIT License',undef,'A library for validating Python data structures.',undef,],
		'webob' => ['http://webob.org/','Pylons Project','MIT License',undef,'WSGI request and response object',undef,],
		'pyopenssl' => ['https://pyopenssl.org/','Hynek Schlawack','Apache Software License',undef,'Python wrapper module around the OpenSSL library',undef,],
		'unoconv' => ['https://github.com/dagwieers/unoconv','dagwieers','GNU General Public License v2.0',undef,'Convert between any document format supported by LibreOffice/OpenOffice.',undef,],
		'tldextract' => ['https://github.com/john-kurkowski/tldextract','John Kurkowski','BSD License',undef,'Accurately separate the TLD from the registered domain and subdomains of a URL, using the Public Suffix List. By default, this includes the public ICANN TLDs and their exceptions. You can optionally support the Public Suffix List\'s private domains as well.',undef,],
		'gensim' => ['https://github.com/RaRe-Technologies/gensim','RaRe-Technologies','GNU Lesser General Public License v2.1',undef,'Topic Modelling for Humans.',undef,],
		'ftfy' => ['https://github.com/LuminosoInsight/python-ftfy','LuminosoInsight','MIT License',undef,'Makes Unicode text less broken and more consistent automagically.',undef,],
		'paste' => ['http://pythonpaste.org','Ian Bicking','MIT License',undef,'Tools for using a Web Server Gateway Interface stack',undef,],
		'imgseek' => ['https://sourceforge.net/projects/imgseek/',undef,undef,undef,'A project for searching a collection of images using visual similarity.',undef,],
		'astroid' => ['https://github.com/PyCQA/astroid','Python Code Quality Authority',undef,undef,'A abstract syntax tree for Python with inference support.',undef,],
		'implicit' => ['https://github.com/benfred/implicit','benfred','MIT License',undef,'A fast Python implementation of collaborative filtering for implicit datasets.',undef,],
		'chardet' => ['https://github.com/chardet/chardet','chardet','GNU Lesser General Public License v2.1',undef,'Python 2/3 compatible character encoding detector.',undef,],
		'spotlight' => ['https://github.com/maciejkula/spotlight','maciejkula','MIT License',undef,'Deep recommender models using PyTorch.',undef,],
		'tempita' => ['http://pythonpaste.org/tempita/','Ian Bicking','MIT License',undef,'A very small text templating language',undef,],
		'spyder' => ['https://github.com/spyder-ide/spyder','spyder-ide','Other',undef,'Open Source Python IDE.',undef,],
		'supervisor' => ['https://github.com/Supervisor/supervisor','Supervisor','Other',undef,'Supervisor process control system for UNIX.',undef,],
		'taskflow' => ['https://docs.openstack.org/developer/taskflow/',undef,undef,undef,'A Python library that helps to make task execution easy. consistent and reliable.',undef,],
		'jsonpatch' => ['https://github.com/stefankoegl/python-json-patch','Stefan Kögl','BSD License',undef,'Apply JSON-Patches (RFC 6902)',undef,],
		'fuckit.py' => ['https://github.com/ajalt/fuckitpy','ajalt',undef,undef,'FuckIt.py uses state-of-the-art technology to make sure your Python code runs whether it has any right to or not.',undef,],
		'pydy' => ['http://www.pydy.org/',undef,undef,undef,'Short for Python Dynamics. used to assist with workflow in the modeling of dynamic motion.',undef,],
		'pycrypto' => ['http://www.pycrypto.org/','Dwayne C. Litzenberger','Public Domain',undef,'Cryptographic modules for Python.',undef,],
		'lassie' => ['https://github.com/michaelhelmick/lassie','michaelhelmick','MIT License',undef,'Web Content Retrieval for Humans.',undef,],
		'python-mimeparse' => ['https://github.com/dbtsai/python-mimeparse','DB Tsai','MIT License',undef,'A module provides basic functions for parsing mime-type names and matching them against a list of media-ranges.',undef,],
		'gmail' => ['https://github.com/charlierguo/gmail','charlierguo','MIT License',undef,'A Pythonic interface for Gmail.',undef,],
		'txredis' => ['https://github.com/deldotdr/txRedis','deldotdr','Other',undef,'Twisted based client for Redis.',undef,],
		'versiontools' => ['https://launchpad.net/versiontools','Zygmunt Krynicki','GNU Library or Lesser General Public License (LGPL)',undef,'Smart replacement for plain tuple used in __version__',undef,],
		'django-activity-stream' => ['https://github.com/justquick/django-activity-stream','justquick','BSD 3-Clause ""New"" or ""Revised"" License',undef,'Generating generic activity streams from the actions on your site.',undef,],
		'pbr' => ['https://docs.openstack.org/pbr/latest/','OpenStack','Apache Software License',undef,'Python Build Reasonableness',undef,],
		'xlsxwriter' => ['https://xlsxwriter.readthedocs.io',undef,undef,undef,'A Python module for creating Excel .xlsx files.',undef,],
		'eel' => ['https://github.com/ChrisKnott/Eel','ChrisKnott','MIT License',undef,'Little library for making simple Electron-like offline HTML/JS GUI apps. with full access to Python capabilities and libraries.',undef,],
		'textract' => ['https://github.com/deanmalmgren/textract','deanmalmgren','MIT License',undef,'Extract text from any document. Word. PowerPoint. PDFs. etc.',undef,],
		'sumy' => ['https://github.com/miso-belica/sumy','miso-belica','Apache License 2.0',undef,'A module for automatic summarization of text documents and HTML pages.',undef,],
		'httpie' => ['https://github.com/jakubroztocil/httpie','jakubroztocil','Other',undef,'A command line HTTP client. a user-friendly cURL replacement.',undef,],
		'wrapt' => ['https://github.com/GrahamDumpleton/wrapt','Graham Dumpleton','BSD License',undef,'Module for decorators, wrappers and monkey patching.',undef,],
		'zodb' => ['http://www.zodb.org/en/latest/',undef,undef,undef,'A native object database for Python. A key-value and object graph database.',undef,],
		'configparser' => ['https://docs.python.org/3/library/configparser.html',undef,undef,undef,'(Python standard library) INI file parser.',undef,],
		'pyjwt' => ['http://github.com/jpadilla/pyjwt','Jose Padilla','MIT License',undef,'JSON Web Token implementation in Python',undef,],
		'newspaper' => ['https://github.com/codelucas/newspaper','codelucas','Other',undef,'News extraction. article extraction and content curation in Python.',undef,],
		'cola' => ['https://github.com/chineking/cola','chineking','Other',undef,'A distributed crawling framework.',undef,],
		'lightfm' => ['https://github.com/lyst/lightfm','lyst','Apache License 2.0',undef,'A Python implementation of a number of popular recommendation algorithms.',undef,],
		'carteblanche' => ['https://github.com/neuman/python-carteblanche/','neuman',undef,undef,'Module to align code with thoughts of users and designers. Also magically handles navigation and permissions.',undef,],
		'python-social-auth' => ['https://github.com/omab/python-social-auth','omab','Other',undef,'An easy-to-setup social authentication mechanism.',undef,],
		'imghdr' => ['https://docs.python.org/3/library/imghdr.html',undef,undef,undef,'(Python standard library) Determine the type of an image.',undef,],
		'reportlab' => ['http://www.reportlab.com/opensource/',undef,undef,undef,'Allowing Rapid creation of rich PDF documents.',undef,],
		'cpython' => ['https://github.com/python/cpython','python','Other',undef,'**Default. most widely used implementation of the Python programming language written in C.**',undef,],
		'django-nose' => ['http://github.com/django-nose/django-nose','Erik Rose','BSD License',undef,'Makes your Django tests simple and snappy',undef,],
		'python-docx' => ['https://github.com/python-openxml/python-docx','python-openxml','MIT License',undef,'Reads. queries and modifies Microsoft Word 2007/2008 docx files.',undef,],
		'peachpy' => ['https://github.com/Maratyszcza/PeachPy','Maratyszcza','Other',undef,'x86-64 assembler embedded in Python. Can be used as inline assembler for Python or as a stand-alone assembler for Windows. Linux. OS X. Native Client and Go.',undef,],
		'python' => ['https://github.com/DonJayamanne/pythonVSCode','DonJayamanne','MIT License',undef,'An extension with rich support for the Python language. with features including linting. IntelliSense. formatting. refactoring. debugging. unit tests. and jupyter support.',undef,],
		'uwsgi' => ['https://uwsgi-docs.readthedocs.io/en/latest/',undef,undef,undef,'A project aims at developing a full stack for building hosting services. written in C.',undef,],
		'magic python' => ['https://github.com/MagicStack/MagicPython','MagicStack','MIT License',undef,'Cutting edge Python syntax highlighter for Sublime Text. Atom. and Visual Studio Code. Used by GitHub to highlight your Python code!',undef,],
		'pangu.py' => ['https://github.com/vinta/pangu.py','vinta','MIT License',undef,'Spacing texts for CJK and alphanumerics.',undef,],
		'mistune' => ['https://github.com/lepture/mistune','lepture','BSD 3-Clause ""New"" or ""Revised"" License',undef,'Fastest and full featured pure Python parsers of Markdown.',undef,],
		'fastfm' => ['https://github.com/ibayer/fastFM','ibayer','Other',undef,'A library for Factorization Machines.',undef,],
		'nude.py' => ['https://github.com/hhatto/nude.py','hhatto',undef,undef,'Nudity detection.',undef,],
		'pexpect' => ['https://github.com/pexpect/pexpect','pexpect','Other',undef,'Controlling interactive programs in a pseudo-terminal like GNU expect.',undef,],
		'hgtools' => ['https://github.com/jaraco/hgtools','Jason R. Coombs','MIT License',undef,'Classes and setuptools plugin for Mercurial and Git repositories',undef,],
		'uwsgi' => ['https://uwsgi-docs.readthedocs.io/en/latest/','Unbit',undef,undef,'The uWSGI server',undef,],
		'tornado' => ['http://www.tornadoweb.org/en/latest/',undef,undef,undef,'A Web framework and asynchronous networking library.',undef,],
		'requests-html' => ['https://github.com/kennethreitz/requests-html','kennethreitz','MIT License',undef,'Pythonic HTML Parsing for Humans.',undef,],
		'apsw' => ['http://rogerbinns.github.io/apsw/',undef,undef,undef,'Another Python SQLite wrapper.',undef,],
		'xmltodict' => ['https://github.com/martinblech/xmltodict','martinblech','MIT License',undef,'Working with XML feel like you are working with JSON.',undef,],
		'bokeh' => ['https://github.com/bokeh/bokeh','bokeh','BSD 3-Clause ""New"" or ""Revised"" License',undef,'Interactive Web Plotting for Python.',undef,],
		'django-filter' => ['https://github.com/carltongibson/django-filter/tree/master','Alex Gaynor','BSD License',undef,'Django-filter is a reusable Django application for allowing users to filter querysets dynamically.',undef,],
		'python-gflags' => ['https://github.com/google/python-gflags','Google Inc. and others','BSD License',undef,'Obsolete. Please migrate to absl-py instead.',undef,],
		'coverage' => ['https://pypi.python.org/pypi/coverage',undef,undef,undef,'Code coverage measurement.',undef,],
		'web2py' => ['http://www.web2py.com/',undef,'LGPL 3.0',undef,'Free open source full-stack framework for rapid development of fast, scalable, secure and portable database-driven web-based applications','MVC framework',],
		'pydal' => ['https://github.com/web2py/pydal/','web2py','Other',undef,'A pure Python Database Abstraction Layer.',undef,],
		'micropython' => ['https://github.com/micropython/micropython','micropython','MIT License',undef,'MicroPython - a lean and efficient Python programming language implementation for microcontrollers and constrained systems',undef,],
		'kombu' => ['https://kombu.readthedocs.io','Ask Solem','BSD License',undef,'Messaging library for Python.',undef,],
		'xlrd' => ['http://www.python-excel.org/','John Machin','BSD License',undef,'Library for developers to extract data from Microsoft Excel (tm) spreadsheet files',undef,],
		'coveralls' => ['http://github.com/coveralls-clients/coveralls-python','coveralls-clients contributors','MIT License',undef,'Show coverage stats online via coveralls.io',undef,],
		'py2app' => ['http://pythonhosted.org/py2app/',undef,undef,undef,'Freezes Python scripts (Mac OS X).',undef,],
		's3cmd' => ['https://github.com/s3tools/s3cmd','s3tools','GNU General Public License v2.0',undef,'A command line tool for managing Amazon S3 and CloudFront.',undef,],
		'funcsigs' => ['http://funcsigs.readthedocs.org','Testing Cabal','Apache Software License',undef,'Python function signatures from PEP362 for Python 2.6, 2.7 and 3.2+',undef,],
		'twisted' => ['http://twistedmatrix.com/','Twisted Matrix Laboratories',undef,undef,'An asynchronous networking framework written in Python',undef,],
		'helper' => ['https://github.com/gmr/helper','Gavin M. Roy','BSD License',undef,'Development library for quickly writing configurable applications and daemons',undef,],
		'xgboost' => ['https://github.com/dmlc/xgboost','dmlc','Other',undef,'A scalable. portable. and distributed gradient boosting library.',undef,],
		'pygeoip' => ['https://github.com/appliedsec/pygeoip','appliedsec','GNU Lesser General Public License v3.0',undef,'Pure Python GeoIP API.',undef,],
		'itsdangerous' => ['https://github.com/pallets/itsdangerous','pallets','Other',undef,'Various helpers to pass trusted data to untrusted environments.',undef,],
		'sdx platform' => ['https://github.com/sdn-ixp/internet2award','sdn-ixp',undef,undef,'SDN based IXP implementation that leverages Mininet. POX and Pyretic.',undef,],
		'python-readability' => ['https://github.com/buriy/python-readability','buriy',undef,undef,'Fast Python port of arc90s readability tool.',undef,],
		'pynamodb' => ['https://github.com/pynamodb/PynamoDB','pynamodb','MIT License',undef,'A Pythonic interface for [Amazon DynamoDB](https://aws.amazon.com/dynamodb/).',undef,],
		'plyvel' => ['https://github.com/wbolster/plyvel','wbolster','Other',undef,'A fast and feature-rich Python interface to LevelDB.',undef,],
		'sqlalchemy' => ['http://www.sqlalchemy.org/',undef,undef,undef,'The Python SQL Toolkit and Object Relational Mapper.',undef,],
		'anaconda' => ['https://github.com/DamnWidget/anaconda','DamnWidget','Other',undef,'Anaconda turns your Sublime Text 3 in a full featured Python development IDE.',undef,],
		'beautifulsoup4' => ['http://www.crummy.com/software/BeautifulSoup/bs4/','Leonard Richardson','MIT License',undef,'Screen-scraping library',undef,],
		'mako' => ['http://www.makotemplates.org/','Mike Bayer',undef,undef,'A super-fast templating language that borrows the  best ideas from the existing templating languages.',undef,],
		'django-simple-spam-blocker' => ['https://github.com/moqada/django-simple-spam-blocker','moqada','Other',undef,'Simple spam blocker for Django.',undef,],
		'saws' => ['https://github.com/donnemartin/saws','donnemartin','Other',undef,'A Supercharged AWS CLI.',undef,],
		'renpy' => ['https://www.renpy.org/',undef,undef,undef,'A Visual Novel engine.',undef,],
		'dnspython' => ['http://www.dnspython.org','Bob Halley','Freeware',undef,'A DNS toolkit for Python',undef,],
		'mkdocs' => ['http://www.mkdocs.org/',undef,undef,undef,'Markdown friendly documentation generator.',undef,],
		'lptrace' => ['https://github.com/khamidou/lptrace','khamidou','GNU General Public License v3.0',undef,'[strace](http://man7.org/linux/man-pages/man1/strace.1.html) for Python programs.',undef,],
		'python-cdb' => ['https://github.com/acg/python-cdb','Alan Grow',undef,undef,'Interface to constant database files',undef,],
		'pytest-runner' => ['https://github.com/pytest-dev/pytest-runner','Jason R. Coombs','MIT License',undef,'Invoke py.test as distutils command with dependency resolution',undef,],
		'awscli' => ['http://aws.amazon.com/cli/','Amazon Web Services','Apache Software License',undef,'Universal Command Line Environment for AWS.',undef,],
		'flask-debugtoolbar' => ['https://github.com/mgood/flask-debugtoolbar','mgood','Other',undef,'A port of the django-debug-toolbar to flask.',undef,],
		'langid.py' => ['https://github.com/saffsd/langid.py','saffsd','Other',undef,'Stand-alone language identification system.',undef,],
		'rauth' => ['https://github.com/litl/rauth','litl','MIT License',undef,'A Python library for OAuth 1.0/a. 2.0. and Ofly.',undef,],
		'moznetwork' => ['https://wiki.mozilla.org/Auto-tools/Projects/Mozbase','Mozilla Automation and Tools team',undef,undef,'Library of network utilities for use in Mozilla testing',undef,],
		'responses' => ['https://github.com/getsentry/responses','getsentry','Apache License 2.0',undef,'A utility library for mocking out the requests Python library.',undef,],
		'keyring' => ['https://github.com/jaraco/keyring','Kang Zhang','Python Software Foundation License',undef,'Store and access your passwords safely.',undef,],
		'flask-restless' => ['https://github.com/jfinkels/flask-restless','jfinkels','Other',undef,'Generating RESTful APIs for database models defined with SQLAlchemy.',undef,],
		'percol' => ['https://github.com/mooz/percol','mooz',undef,undef,'Adds flavor of interactive selection to the traditional pipe concept on UNIX.',undef,],
		'wheel' => ['http://pythonwheels.com/',undef,undef,undef,'The new standard of Python distribution and are intended to replace eggs.',undef,],
		'stevedore' => ['https://docs.openstack.org/stevedore/latest/','OpenStack','Apache Software License',undef,'Manage dynamic plugins for Python applications',undef,],
		'pyshorteners' => ['https://github.com/ellisonleao/pyshorteners','ellisonleao','GNU General Public License v3.0',undef,'A pure Python URL shortening lib.',undef,],
		'cython' => ['http://cython.org/',undef,undef,undef,'Optimizing Static Compiler for Python. Uses type mixins to compile Python into C or C++ modules resulting in large performance gains',undef,],
		'websocket-for-python' => ['https://github.com/Lawouach/WebSocket-for-Python','Lawouach','Other',undef,'WebSocket client and server library for Python 2 and 3 as well as PyPy.',undef,],
		'keras' => ['https://github.com/fchollet/keras','fchollet','Other',undef,'A high-level neural networks library and capable of running on top of either TensorFlow or Theano.',undef,],
		'zope.deprecation' => ['http://github.com/zopefoundation/zope.deprecation','Zope Corporation and Contributors',undef,undef,'Zope Deprecation Infrastructure',undef,],
		'facebook-sdk' => ['https://github.com/mobolic/facebook-sdk','mobolic','Apache License 2.0',undef,'Facebook Platform Python SDK.',undef,],
		'mysql-python' => ['https://github.com/farcepest/MySQLdb1','Andy Dustman','GNU General Public License (GPL)',undef,'Python interface to MySQL',undef,],
		'tensorrec' => ['https://github.com/jfkirk/tensorrec','jfkirk','Apache License 2.0',undef,'A Recommendation Engine Framework in TensorFlow.',undef,],
		'repoze.lru' => ['http://www.repoze.org','Agendaless Consulting','Repoze Public License',undef,'A tiny LRU cache implementation and decorator',undef,],
		'unp' => ['https://github.com/mitsuhiko/unp','mitsuhiko','Other',undef,'A command line tool that can unpack archives easily.',undef,],
		'pyicu' => ['https://github.com/ovalhub/pyicu','ovalhub','Other',undef,'A wrapper of International Components for Unicode C++ library ([ICU](http://site.icu-project.org/)).',undef,],
		'networkx' => ['https://networkx.github.io/',undef,undef,undef,'A high-productivity software for complex networks.',undef,],
		'virtualenvwrapper' => ['https://pypi.python.org/pypi/virtualenvwrapper',undef,undef,undef,'A set of extensions to virtualenv.',undef,],
		'user-agents' => ['https://github.com/selwin/python-user-agents','Selwin Ong','MIT License',undef,'A library to identify devices (phones, tablets) and their capabilities by parsing (browser/HTTP) user agent strings',undef,],
		'mozrunner' => ['https://wiki.mozilla.org/Auto-tools/Projects/Mozbase','Mozilla Automation and Tools team','Mozilla Public License 2.0 (MPL 2.0)',undef,'Reliable start/stop/configuration of Mozilla Applications (Firefox, Thunderbird, etc.)',undef,],
		'bashplotlib' => ['https://github.com/glamp/bashplotlib','glamp','MIT License',undef,'Making basic plots in the terminal.',undef,],
		'python-subunit' => ['http://launchpad.net/subunit','Robert Collins',undef,undef,'Python implementation of subunit test streaming protocol',undef,],
		'pluginbase' => ['https://github.com/mitsuhiko/pluginbase','mitsuhiko','Other',undef,'A simple but flexible plugin system for Python.',undef,],
		'oslo.messaging' => ['https://docs.openstack.org/oslo.messaging/latest/','OpenStack','Apache Software License',undef,'Oslo Messaging API',undef,],
		'll-xist' => ['http://python.livinglogic.de/','Walter Doerwald','MIT License',undef,'Extensible HTML/XML generator, cross-platform templating language, Oracle utilities and various other tools',undef,],
		'p' => ['https://github.com/qw3rtman/p','qw3rtman','MIT License',undef,'Dead simple interactive Python version management.',undef,],
		'pudb' => ['https://pypi.python.org/pypi/pudb',undef,undef,undef,'A full-screen. console-based Python debugger.',undef,],
		'markupsafe' => ['http://github.com/pallets/markupsafe','Armin Ronacher','BSD License',undef,'Implements a XML/HTML/XHTML Markup safe string for Python',undef,],
		'geojson' => ['https://github.com/frewsxcv/python-geojson','frewsxcv','BSD 3-Clause ""New"" or ""Revised"" License',undef,'Python bindings and utilities for GeoJSON.',undef,],
		'python(x' => ['y)','y',undef,undef,'x',undef,],
		'pysdl2' => ['http://pysdl2.readthedocs.io/en/rel_0_9_5/',undef,undef,undef,'A ctypes based wrapper for the SDL2 library.',undef,],
		'sixpack' => ['https://github.com/seatgeek/sixpack','seatgeek','BSD 2-Clause ""Simplified"" License',undef,'A language-agnostic A/B Testing framework.',undef,],
		'pyuserinput' => ['https://github.com/SavinaRoja/PyUserInput','SavinaRoja','GNU General Public License v3.0',undef,'A module for cross-platform control of the mouse and keyboard.',undef,],
		'scikit-image' => ['http://scikit-image.org/',undef,undef,undef,'A Python library for (scientific) image processing.',undef,],
		'django-countries' => ['https://github.com/SmileyChris/django-countries','SmileyChris','MIT License',undef,'A Django app that provides country choices for use with forms. flag icons static files. and a country field for models.',undef,],
		'cement' => ['http://builtoncement.com/',undef,undef,undef,'CLI Application Framework for Python.',undef,],
		'multiprocessing' => ['https://docs.python.org/3/library/multiprocessing.html',undef,undef,undef,'(Python standard library) Process-based ""threading"" interface.',undef,],
		'pybarcode' => ['https://pythonhosted.org/pyBarcode/',undef,undef,undef,'Create barcodes in Python without needing PIL.',undef,],
		'mrq' => ['https://github.com/pricingassistant/mrq','pricingassistant','MIT License',undef,'Mr. Queue - A distributed worker task queue in Python using Redis & gevent.',undef,],
		'forex-python' => ['https://github.com/MicroPyramid/forex-python','MicroPyramid','MIT License',undef,'Foreign exchange rates. Bitcoin price index and currency conversion.',undef,],
		'django-bootstrap3' => ['https://github.com/dyve/django-bootstrap3','dyve','BSD 3-Clause ""New"" or ""Revised"" License',undef,'Bootstrap 3 integration with Django.',undef,],
		'psutil' => ['https://github.com/giampaolo/psutil','giampaolo','Other',undef,'A cross-platform process and system utilities module.',undef,],
		'hot-redis' => ['https://github.com/stephenmcd/hot-redis','stephenmcd','BSD 2-Clause ""Simplified"" License',undef,'Rich Python data types for Redis.',undef,],
		'boto' => ['https://github.com/boto/boto/','Mitch Garnaat','MIT License',undef,'Amazon Web Services Library',undef,],
		'selenium' => ['https://pypi.python.org/pypi/selenium',undef,undef,undef,'Python bindings for [Selenium](http://www.seleniumhq.org/) WebDriver.',undef,],
		'pyautogui' => ['https://github.com/asweigart/pyautogui','asweigart','BSD 3-Clause ""New"" or ""Revised"" License',undef,'PyAutoGUI is a cross-platform GUI automation Python module for human beings.',undef,],
		'cerberus' => ['https://github.com/pyeve/cerberus','pyeve','ISC License',undef,'A lightweight and extensible data validation library.',undef,],
		'scapy' => ['https://github.com/secdev/scapy','secdev','GNU General Public License v2.0',undef,'A brilliant packet manipulation library.',undef,],
		'docker compose' => ['https://docs.docker.com/compose/',undef,undef,undef,'Fast. isolated development environments using [Docker](https://www.docker.com/).',undef,],
		'imbox' => ['https://github.com/martinrusev/imbox','martinrusev','MIT License',undef,'Python IMAP for Humans.',undef,],
		'pytime' => ['https://github.com/shinux/PyTime','shinux','MIT License',undef,'A easy-use Python module which aims to operate date/time/datetime by string.',undef,],
		'testrepository' => ['https://launchpad.net/testrepository','Robert Collins','BSD License',undef,'A repository of test results.',undef,],
		'flexget' => ['https://flexget.com','Marko Koivusalo','MIT License',undef,'FlexGet is a program aimed to automate downloading or processing content (torrents, podcasts, etc.) from different sources like RSS-feeds, html-pages, various sites and more.',undef,],
		'zope.interface' => ['https://github.com/zopefoundation/zope.interface','Zope Foundation and Contributors','Zope Public License',undef,'Interfaces for Python',undef,],
		'fileconveyor' => ['http://wimleers.com/fileconveyor',undef,undef,undef,'A daemon to detect and sync files to CDNs. S3 and FTP.',undef,],
		'kazoo' => ['https://kazoo.readthedocs.io','Kazoo team','Apache Software License',undef,'Higher Level Zookeeper Client',undef,],
		'debtcollector' => ['https://docs.openstack.org/debtcollector/latest','OpenStack','Apache Software License',undef,'A collection of Python deprecation patterns and strategies that help you collect your technical debt in a non-destructive manner.',undef,],
		'txzmq' => ['https://github.com/smira/txZMQ','smira','GNU General Public License v2.0',undef,'Twisted based wrapper for the ZeroMQ message library.',undef,],
		'pyretic' => ['http://frenetic-lang.org/pyretic/',undef,undef,undef,'A member of the Frenetic family of SDN programming languages that provides powerful abstractions over network switches or emulators.',undef,],
		'python-oauth2' => ['https://github.com/joestump/python-oauth2','joestump','MIT License',undef,'A fully tested. abstract interface to creating OAuth clients and servers.',undef,],
		'open mining' => ['https://github.com/mining/mining','mining','MIT License',undef,'Business Intelligence (BI) in Pandas interface.',undef,],
		'spacy' => ['https://spacy.io/',undef,undef,undef,'A library for industrial-strength natural language processing in Python and Cython.',undef,],
		'oslo.utils' => ['https://docs.openstack.org/oslo.utils/latest/','OpenStack','Apache Software License',undef,'Oslo Utility library',undef,],
		'ptvs' => ['https://github.com/Microsoft/PTVS','Microsoft','Apache License 2.0',undef,'Python Tools for Visual Studio.',undef,],
		'rdkit' => ['http://www.rdkit.org/',undef,undef,undef,'Cheminformatics and Machine Learning Software.',undef,],
		'six' => ['https://pypi.python.org/pypi/six',undef,undef,undef,'Python 2 and 3 compatibility utilities.',undef,],
		'pastescript' => ['http://pythonpaste.org/script/','Ian Bicking','MIT License',undef,'A pluggable command-line frontend, including commands to setup package file layouts',undef,],
		'ansible' => ['https://github.com/ansible/ansible','ansible','GNU General Public License v3.0',undef,'A radically simple IT automation platform.',undef,],
		'fuzzywuzzy' => ['https://github.com/seatgeek/fuzzywuzzy','seatgeek','GNU General Public License v2.0',undef,'Fuzzy String Matching.',undef,],
		'elasticsearch-dsl-py' => ['https://github.com/elastic/elasticsearch-dsl-py','elastic','Apache License 2.0',undef,'The official high-level Python client for Elasticsearch.',undef,],
		'cov-core' => ['https://github.com/schlamar/cov-core','Marc Schlaich','MIT License',undef,'plugin core for use by pytest-cov, nose-cov and nose2-cov',undef,],
		'surprise' => ['http://surpriselib.com',undef,undef,undef,'A scikit for building and analyzing recommender systems.',undef,],
		'thumbor' => ['https://github.com/thumbor/thumbor','thumbor','MIT License',undef,'A smart imaging service. It enables on-demand crop. re-sizing and flipping of images.',undef,],
		'flask-script' => ['http://github.com/smurfix/flask-script','Matthias Urlichs','BSD License',undef,'Scripting support for Flask',undef,],
		'graphite-web' => ['http://graphiteapp.org/','Chris Davis','Apache Software License',undef,'Enterprise scalable realtime graphing',undef,],
		'gevent' => ['http://www.gevent.org/','Denis Bilenko','MIT License',undef,'Coroutine-based network library',undef,],
		'micawber' => ['https://github.com/coleifer/micawber','coleifer','MIT License',undef,'A small library for extracting rich content from URLs.',undef,],
		'tox' => ['https://tox.readthedocs.io/en/latest/',undef,undef,undef,'Auto builds and tests distributions in multiple Python versions',undef,],
		'shortuuid' => ['https://github.com/skorokithakis/shortuuid','skorokithakis','BSD 3-Clause ""New"" or ""Revised"" License',undef,'A generator library for concise. unambiguous and URL-safe UUIDs.',undef,],
		'cuisine' => ['https://github.com/sebastien/cuisine','sebastien','Other',undef,'Chef-like functionality for Fabric.',undef,],
		'pymongo' => ['https://docs.mongodb.com/ecosystem/drivers/python/',undef,undef,undef,'The official Python client for MongoDB.',undef,],
		'cactus' => ['https://github.com/eudicots/Cactus','eudicots','Other',undef,'Static site generator for designers.',undef,],
		'pyzmq' => ['http://zeromq.github.io/pyzmq/',undef,undef,undef,'A Python wrapper for the ZeroMQ message library.',undef,],
		'asyncio' => ['https://docs.python.org/3/library/asyncio.html',undef,undef,undef,'(Python standard library) Asynchronous I/O. event loop. coroutines and tasks.',undef,],
		'pdoc' => ['https://github.com/BurntSushi/pdoc','BurntSushi','The Unlicense',undef,'Epydoc replacement to auto generate API documentation for Python libraries.',undef,],
		'functools32' => ['https://github.com/MiCHiLU/python-functools32','ENDOH takanao',undef,undef,'Backport of the functools module from Python 3.2.3 for use on 2.7 and PyPy.',undef,],
		'furl' => ['https://github.com/gruns/furl','gruns','Other',undef,'A small Python library that makes parsing and manipulating URLs easy.',undef,],
		'django-rest-framework' => ['http://www.django-rest-framework.org/',undef,undef,undef,'A powerful and flexible toolkit to build web APIs.',undef,],
		'matplotlib' => ['http://matplotlib.org/',undef,undef,undef,'A Python 2D plotting library.',undef,],
		'click' => ['http://click.pocoo.org/dev/',undef,undef,undef,'A package for creating beautiful command line interfaces in a composable way.',undef,],
		'alembic' => ['http://bitbucket.org/zzzeek/alembic','Mike Bayer',undef,undef,'A database migration tool for SQLAlchemy.',undef,],
		'django-channels' => ['https://github.com/django/channels','django','Other',undef,'Developer-friendly asynchrony for Django',undef,],
		'django' => ['https://www.djangoproject.com/','Django Software Foundation','BSD License',undef,'A high-level Python Web framework that encourages rapid development and clean, pragmatic design.',undef,],
		'flake8' => ['https://pypi.python.org/pypi/flake8',undef,undef,undef,'A wrapper around pycodestyle. pyflakes and McCabe.',undef,],
		'tryton' => ['http://www.tryton.org/',undef,undef,undef,'A general purpose business framework.',undef,],
		'howdoi' => ['https://github.com/gleitz/howdoi','gleitz','MIT License',undef,'Instant coding answers via the command line.',undef,],
		'hypothesis' => ['https://github.com/HypothesisWorks/hypothesis-python','HypothesisWorks','Other',undef,'Hypothesis is an advanced Quickcheck style property based testing library.',undef,],
		'panda3d' => ['https://www.panda3d.org/',undef,undef,undef,'3D game engine developed by Disney and maintained by Carnegie Mellons Entertainment Technology Center. Written in C++. completely wrapped in Python.',undef,],
		'pylons' => [undef,undef,'Open source',undef,'Deprecated',undef,],
		'pdfminer' => ['https://github.com/euske/pdfminer','euske','MIT License',undef,'A tool for extracting information from PDF documents.',undef,],
		'pybuilder' => ['https://github.com/pybuilder/pybuilder','pybuilder','Apache License 2.0',undef,'A continuous build tool written in pure Python.',undef,],
		'pytz' => ['https://launchpad.net/pytz',undef,undef,undef,'World timezone definitions. modern and historical. Brings the [tz database](https://en.wikipedia.org/wiki/Tz_database) into Python.',undef,],
		'mingus' => ['http://bspaans.github.io/python-mingus/',undef,undef,undef,'An advanced music theory and notation package with MIDI file and playback support.',undef,],
		'ipaddr' => ['https://github.com/google/ipaddr-py','Google','Apache Software License',undef,'Google\'s IP address manipulation library',undef,],
		'ujson' => ['http://www.esn.me','Jonas Tarnstrom','BSD License',undef,'Ultra fast JSON encoder and decoder for Python',undef,],
		'bcbio-nextgen' => ['https://github.com/chapmanb/bcbio-nextgen','chapmanb','MIT License',undef,'Providing best-practice pipelines for fully automated high throughput sequencing analysis.',undef,],
		'tempest-lib' => ['http://www.openstack.org/','OpenStack','Apache Software License',undef,'OpenStack Functional Testing Library',undef,],
		'gspread' => ['https://github.com/burnash/gspread','burnash','MIT License',undef,'Google Spreadsheets Python API.',undef,],
		'nupic' => ['https://github.com/numenta/nupic','numenta','GNU Affero General Public License v3.0',undef,'Numenta Platform for Intelligent Computing.',undef,],
		'python-lambda' => ['https://github.com/nficano/python-lambda','nficano','ISC License',undef,'A toolkit for developing and deploying Python code in AWS Lambda.',undef,],
		'honcho' => ['https://github.com/nickstenning/honcho','nickstenning','MIT License',undef,'A Python clone of [Foreman](https://github.com/ddollar/foreman). for managing Procfile-based applications.',undef,],
		'simpy' => ['https://bitbucket.org/simpy/simpy',undef,undef,undef,'A process-based discrete-event simulation framework.',undef,],
		'id3reader' => ['https://nedbatchelder.com/code/modules/id3reader.py',undef,undef,undef,'A Python module for reading MP3 meta data.',undef,],
		'py' => ['http://py.readthedocs.io/','holger krekel, Ronny Pfannschmidt, Benjamin Peterson and others','MIT License',undef,'library with cross-python path, ini-parsing, io, code, log facilities',undef,],
		'elasticsearch' => ['https://github.com/elastic/elasticsearch-py','Honza Král, Nick Lang','Apache Software License',undef,'Python client for Elasticsearch',undef,],
		'doublex' => ['https://pypi.python.org/pypi/doublex',undef,undef,undef,'Powerful test doubles framework for Python.',undef,],
		'pymysql' => ['https://github.com/PyMySQL/PyMySQL','PyMySQL','MIT License',undef,'A pure Python MySQL driver compatible to mysql-python.',undef,],
		'pyocr' => ['https://github.com/openpaperwork/pyocr','openpaperwork',undef,undef,'A wrapper for Tesseract and Cuneiform.',undef,],
		'cssselect' => ['https://github.com/scrapy/cssselect','Paul Tremberth','BSD License',undef,'cssselect parses CSS3 Selectors and translates them to XPath 1.0',undef,],
		'futures' => ['https://github.com/agronholm/pythonfutures','Alex Grönholm','Python Software Foundation License',undef,'Backport of the concurrent.futures package from Python 3',undef,],
		'tornado' => ['http://www.tornadoweb.org',undef,'Apache',undef,'Tornado is a Python web framework and asynchronous networking library, originally developed at FriendFeed','web framework',],
		'appdirs' => ['http://github.com/ActiveState/appdirs','Trent Mick Sridhar Ratnakumar Jeff Rouse','MIT License',undef,'A small Python module for determining appropriate platform-specific dirs, e.g. a ""user data dir"".',undef,],
		'apistar' => ['https://github.com/encode/apistar','encode','BSD 3-Clause ""New"" or ""Revised"" License',undef,'A smart Web API framework. designed for Python 3.',undef,],
		'redis-py' => ['https://github.com/andymccurdy/redis-py','andymccurdy','MIT License',undef,'The Redis Python Client.',undef,],
		'csvkit' => ['https://github.com/wireservice/csvkit','wireservice','MIT License',undef,'Utilities for converting to and working with CSV.',undef,],
		'grappelli' => ['http://grappelliproject.com',undef,undef,undef,'A jazzy skin for the Django Admin-Interface.',undef,],
		'mypy' => ['http://mypy-lang.org/',undef,undef,undef,'Check variable types during compile time.',undef,],
		'beaker' => ['https://github.com/bbangert/beaker','bbangert','Other',undef,'A library for caching and sessions for use with web applications and stand-alone Python scripts and applications.',undef,],
		'certifi' => ['http://certifi.io/','Kenneth Reitz','Mozilla Public License 2.0 (MPL 2.0)',undef,'Python package for providing Mozilla\'s CA Bundle.',undef,],
		'babel' => ['http://babel.pocoo.org/','Armin Ronacher','BSD License',undef,'Internationalization utilities',undef,],
		'nuitka' => ['http://nuitka.net/',undef,undef,undef,'Compile scripts. modules. packages to an executable or extension module.',undef,],
		'inbox.py' => ['https://github.com/kennethreitz/inbox.py','kennethreitz','BSD 2-Clause ""Simplified"" License',undef,'Python SMTP Server for Humans.',undef,],
		'python-fire' => ['https://github.com/google/python-fire','google','Other',undef,'A library for creating command line interfaces from absolutely any Python object.',undef,],
		'authomatic' => ['https://github.com/authomatic/authomatic','authomatic','MIT License',undef,'Simple but powerful framework agnostic authentication/authorization client.',undef,],
		'saltstack' => ['https://github.com/saltstack/salt','saltstack','Other',undef,'Infrastructure automation and management system.',undef,],
		'eyed3' => ['http://eyed3.nicfit.net/',undef,undef,undef,'A tool for working with audio files. specifically MP3 files containing ID3 metadata.',undef,],
		'ssl' => ['https://github.com/pypa/ssl','See long_description for details',undef,undef,'SSL wrapper for socket objects (2.3, 2.4, 2.5 compatible)',undef,],
		'ndg-httpsclient' => ['https://github.com/cedadev/ndg_httpsclient/','Richard Wilkinson and Philip Kershaw','BSD License',undef,'Provides enhanced HTTPS support for httplib and urllib2 using PyOpenSSL',undef,],
		'd2to1' => ['https://github.com/embray/d2to1','Erik M. Bray','BSD License',undef,'Allows using distutils2-like setup.cfg files for a package\'s metadata with a distribute/setuptools setup.py',undef,],
		'waitress' => ['https://waitress.readthedocs.io/en/latest/',undef,undef,undef,'Multi-threaded. powers Pyramid.',undef,],
		'tensorflow' => ['https://github.com/tensorflow/tensorflow','tensorflow','Apache License 2.0',undef,'The most popular Deep Learning framework created by Google.',undef,],
		'mysqlclient' => ['https://github.com/PyMySQL/mysqlclient-python','PyMySQL','GNU General Public License v2.0',undef,'MySQL connector with Python 3 support ([mysql-python](https://sourceforge.net/projects/mysql-python/) fork).',undef,],
		'importlib' => ['https://github.com/brettcannon/importlib','Brett Cannon',undef,undef,'Backport of importlib.import_module() from Python 2.7',undef,],
		'unicode-slugify' => ['https://github.com/mozilla/unicode-slugify','mozilla','Other',undef,'A slugifier that generates unicode slugs with Django as a dependency.',undef,],
		'bottle' => ['https://bottlepy.org/docs/dev/',undef,'MIT',undef,'Bottle is a fast, simple and lightweight WSGI micro web-framework for Python.','web / MVC framework',],
		'spiff' => ['https://github.com/knipknap/SpiffWorkflow','knipknap','GNU Lesser General Public License v3.0',undef,'A powerful workflow engine implemented in pure Python.',undef,],
		'ecdsa' => ['http://github.com/warner/python-ecdsa','Brian Warner',undef,undef,'ECDSA cryptographic signature library (pure python)',undef,],
		'napalm' => ['https://github.com/napalm-automation/napalm','napalm-automation','Apache License 2.0',undef,'Cross-vendor API to manipulate network devices.',undef,],
		'pyflame' => ['https://github.com/uber/pyflame','uber','Apache License 2.0',undef,'Attach this Ptracing Profiler to any processes running Python. Perfect for profiling production webservers.',undef,],
		'audioread' => ['https://github.com/beetbox/audioread','beetbox',undef,undef,'Cross-library (GStreamer + Core Audio + MAD + FFmpeg) audio decoding.',undef,],
		'ajenti' => ['https://github.com/ajenti/ajenti','ajenti',undef,undef,'The admin panel your servers deserve.',undef,],
		'winpython' => ['https://winpython.github.io/',undef,undef,undef,'Portable development environment for Windows 7/8.',undef,],
		'nikola' => ['https://www.getnikola.com/',undef,undef,undef,'A static website and blog generator.',undef,],
		'beets' => ['http://beets.io/',undef,undef,undef,'A music library manager and [MusicBrainz](https://musicbrainz.org/) tagger.',undef,],
		'nosexcover' => ['http://github.com/cmheisel/nose-xcover/','Chris Heisel','BSD License',undef,'Extends nose.plugins.cover to add Cobertura-style XML reports',undef,],
		'timeside' => ['https://github.com/Parisson/TimeSide','Parisson','GNU Affero General Public License v3.0',undef,'Open web audio processing framework.',undef,],
		'green' => ['https://github.com/CleanCut/green','CleanCut','MIT License',undef,'A clean. colorful test runner.',undef,],
		'm2crypto' => ['https://gitlab.com/m2crypto/m2crypto','Ng Pheng Siong','MIT License',undef,'M2Crypto: A Python crypto and SSL toolkit',undef,],
		'oauthlib' => ['https://github.com/idan/oauthlib','idan','Other',undef,'A generic and thorough implementation of the OAuth request-signing logic.',undef,],
		'pythonnet' => ['https://github.com/pythonnet/pythonnet','pythonnet','MIT License',undef,'Python Integration with the .NET Common Language Runtime (CLR).',undef,],
		'singledispatch' => ['http://docs.python.org/3/library/functools.html#functools.singledispatch','Łukasz Langa','MIT License',undef,'This library brings functools.singledispatch from Python 3.4 to Python 2.6-3.3.',undef,],
		'pytesseract' => ['https://github.com/madmaze/pytesseract','madmaze','GNU General Public License v3.0',undef,'Another wrapper for [Google Tesseract OCR](https://github.com/tesseract-ocr).',undef,],
		'apscheduler' => ['http://apscheduler.readthedocs.io/en/latest/',undef,undef,undef,'A light but powerful in-process task scheduler that lets you schedule functions.',undef,],
		'twython' => ['https://github.com/ryanmcgrath/twython','ryanmcgrath','MIT License',undef,'A Python wrapper for the Twitter API.',undef,],
		'monkeytype' => ['https://github.com/Instagram/MonkeyType','Instagram','Other',undef,'A system for Python that generates static type annotations by collecting runtime types',undef,],
		'ipdb' => ['https://pypi.python.org/pypi/ipdb',undef,undef,undef,'IPython-enabled [pdb](https://docs.python.org/3/library/pdb.html).',undef,],
		'pyodbc' => ['https://github.com/mkleehammer/pyodbc','Michael Kleehammer','MIT License',undef,'DB API Module for ODBC',undef,],
		'trisdb-py' => ['https://github.com/tiepologian/trisdb-py','Gianluca Tiepolo',undef,undef,'The Python interface to TrisDb',undef,],
		'schedule' => ['https://github.com/dbader/schedule','dbader','MIT License',undef,'Python job scheduling for humans.',undef,],
		'simplexmlrpcserver' => ['https://docs.python.org/3/library/xmlrpc.server.html',undef,undef,undef,'(Python standard library) Simple XML-RPC server implementation. single-threaded.',undef,],
		'xattr' => ['http://github.com/xattr/xattr','Bob Ippolito','MIT License',undef,'Python wrapper for extended filesystem attributes',undef,],
		'cookiecutter' => ['https://github.com/audreyr/cookiecutter','audreyr','BSD 3-Clause ""New"" or ""Revised"" License',undef,'A command-line utility that creates projects from cookiecutters (project templates).',undef,],
		'unipath' => ['https://github.com/mikeorr/Unipath','mikeorr',undef,undef,'An object-oriented approach to file/directory operations.',undef,],
		'geodjango' => ['https://docs.djangoproject.com/en/dev/ref/contrib/gis/',undef,undef,undef,'A world-class geographic web framework.',undef,],
		'maya' => ['https://github.com/kennethreitz/maya','kennethreitz','MIT License',undef,'Datetimes for Humans. Maya is mostly built around the headaches and use-cases around parsing datetime data from websites.',undef,],
		'psycopg2' => ['http://initd.org/psycopg/',undef,undef,undef,'The most popular PostgreSQL adapter for Python.',undef,],
		'fabric' => ['http://www.fabfile.org/',undef,undef,undef,'A simple. Pythonic tool for remote execution and deployment.',undef,],
		'hacking' => ['https://docs.openstack.org/hacking/latest/','OpenStack','Apache Software License',undef,'OpenStack Hacking Guideline Enforcement',undef,],
		'short_url' => ['https://github.com/Alir3z4/python-short_url','Alir3z4','MIT License',undef,'Python implementation for generating Tiny URL and bit.ly-like URLs.',undef,],
		'flask-restful' => ['https://www.github.com/flask-restful/flask-restful/','Twilio API Team','BSD License',undef,'Simple framework for creating REST APIs',undef,],
		'audiolazy' => ['https://github.com/danilobellini/audiolazy','danilobellini','GNU General Public License v3.0',undef,'Expressive Digital Signal Processing (DSP) package for Python.',undef,],
		'h2o' => ['https://github.com/h2oai/h2o-3','h2oai','Apache License 2.0',undef,'Open Source Fast Scalable Machine Learning Platform.',undef,],
		'rocket' => ['https://pypi.python.org/pypi/rocket',undef,undef,undef,'Multi-threaded.',undef,],
		'idna' => ['https://github.com/kjd/idna','Kim Davies','BSD License',undef,'Internationalized Domain Names in Applications (IDNA)',undef,],
		'metrics' => ['https://github.com/benhamner/Metrics','benhamner','Other',undef,'Machine learning evaluation metrics.',undef,],
		'grab' => ['http://grablib.org/',undef,undef,undef,'Site scraping framework.',undef,],
		'sarge' => ['http://sarge.readthedocs.io/en/latest/',undef,undef,undef,'Yet another wrapper for subprocess.',undef,],
		'unittest-xml-reporting' => ['http://github.com/xmlrunner/unittest-xml-reporting/tree/master/','Daniel Fernandes Martins','BSD License',undef,'unittest-based test runner with Ant/JUnit like XML reporting.',undef,],
		'genshi' => ['https://genshi.edgewall.org/',undef,undef,undef,'Python templating toolkit for generation of web-aware output.',undef,],
		'delegator.py' => ['https://github.com/kennethreitz/delegator.py','kennethreitz','MIT License',undef,'[Subprocesses](https://docs.python.org/3.6/library/subprocess.html) for Humans™ 2.0.',undef,],
		'geoip' => ['https://github.com/maxmind/geoip-api-python','maxmind','GNU Lesser General Public License v2.1',undef,'Python API for MaxMind GeoIP Legacy Database.',undef,],
		'ponyorm' => ['https://ponyorm.com/',undef,undef,undef,'ORM that provides a generator-oriented interface to SQL.',undef,],
		'untangle' => ['https://github.com/stchris/untangle','stchris','MIT License',undef,'Converts XML documents to Python objects for easy access.',undef,],
		'gitdb' => ['https://github.com/gitpython-developers/gitdb','Sebastian Thiel','BSD License',undef,'Git Object Database',undef,],
		'fabric' => ['http://fabfile.org','Jeff Forcier','BSD License',undef,'High level SSH command execution',undef,],
		'cartridge' => ['https://github.com/stephenmcd/cartridge','stephenmcd','BSD 2-Clause ""Simplified"" License',undef,'A shopping cart app built using the Mezzanine.',undef,],
		'pyspider' => ['https://github.com/binux/pyspider','binux','Apache License 2.0',undef,'A powerful spider system.',undef,],
		'try' => ['https://github.com/timofurrer/try','timofurrer','MIT License',undef,'A dead simple CLI to try out python packages - its never been easier.',undef,],
		'django-suit' => ['http://djangosuit.com/',undef,undef,undef,'Alternative Django Admin-Interface (free only for Non-commercial use).',undef,],
		'butterdb' => ['https://github.com/terrible-ideas/butterdb','terrible-ideas','MIT License',undef,'A Python ORM for Google Drive Spreadsheets.',undef,],
		'oursql' => ['https://pythonhosted.org/oursql/',undef,undef,undef,'A better MySQL connector with support for native prepared statements and BLOBs.',undef,],
		'huey' => ['https://github.com/coleifer/huey','coleifer','MIT License',undef,'Little multi-threaded task queue.',undef,],
		'treq' => ['https://github.com/twisted/treq','twisted','Other',undef,'Python requests like API built on top of Twisteds HTTP client.',undef,],
		'blaze' => ['https://github.com/blaze/blaze','blaze','Other',undef,'NumPy and Pandas interface to Big Data.',undef,],
		'django-debug-toolbar' => ['https://github.com/jazzband/django-debug-toolbar','jazzband','Other',undef,'Display various debug information for Django.',undef,],
		'telephus' => ['https://github.com/driftx/Telephus','driftx','MIT License',undef,'Twisted based client for Cassandra.',undef,],
		'testtools' => ['https://github.com/testing-cabal/testtools','Jonathan M. Lange','MIT License',undef,'Extensions to the Python standard library unit testing framework',undef,],
		'django-cacheops' => ['https://github.com/Suor/django-cacheops','Suor','Other',undef,'A slick ORM cache with automatic granular event-driven invalidation.',undef,],
		'fasteners' => ['https://github.com/harlowja/fasteners','Joshua Harlow','Apache Software License',undef,'A python package that provides useful locks.',undef,],
		'pyasn1' => ['https://github.com/etingof/pyasn1','Ilya Etingof <etingof@gmail.com>','BSD License',undef,'ASN.1 types and codecs',undef,],
		'biopython' => ['http://biopython.org/wiki/Main_Page',undef,undef,undef,'Biopython is a set of freely available tools for biological computation.',undef,],
		'jinja-assets-compressor' => ['https://github.com/jaysonsantos/jinja-assets-compressor','jaysonsantos','Other',undef,'A Jinja extension to compile and compress your assets.',undef,],
		'mezzanine' => ['http://mezzanine.jupo.org/',undef,undef,undef,'A powerful. consistent. and flexible content management platform.',undef,],
		'pgcli' => ['https://github.com/dbcli/pgcli','dbcli','BSD 3-Clause ""New"" or ""Revised"" License',undef,'Postgres CLI with autocompletion and syntax highlighting.',undef,],
		'oslo.concurrency' => ['https://docs.openstack.org/oslo.concurrency/latest/','OpenStack','Apache Software License',undef,'Oslo Concurrency library',undef,],
		'mozcrash' => ['https://wiki.mozilla.org/Auto-tools/Projects/Mozbase','Mozilla Automation and Tools team',undef,undef,'Library for printing stack traces from minidumps left behind by crashed processes',undef,],
		'cython' => ['http://cython.org/','Robert Bradshaw, Stefan Behnel, Dag Seljebotn, Greg Ewing, et al.','Apache Software License',undef,'The Cython compiler for writing C extensions for the Python language.',undef,],
		'logbook' => ['http://logbook.readthedocs.io/en/stable/',undef,undef,undef,'Logging replacement for Python.',undef,],
		'simplecv' => ['http://simplecv.org/',undef,undef,undef,'An open source framework for building computer vision applications.',undef,],
		'queries' => ['https://github.com/gmr/queries','gmr','BSD 3-Clause ""New"" or ""Revised"" License',undef,'A wrapper of the psycopg2 library for interacting with PostgreSQL.',undef,],
		'pagan' => ['https://github.com/daboth/pagan','daboth','GNU General Public License v2.0',undef,'Retro identicon (Avatar) generation based on input string and hash.',undef,],
		'qutip' => ['http://qutip.org/',undef,undef,undef,'Quantum Toolbox in Python.',undef,],
		'fabtools' => ['https://github.com/fabtools/fabtools','fabtools','BSD 2-Clause ""Simplified"" License',undef,'Tools for writing awesome Fabric files.',undef,],
		'tomorrow' => ['https://github.com/madisonmay/Tomorrow','madisonmay','MIT License',undef,'Magic decorator syntax for asynchronous code.',undef,],
		'thefuck' => ['https://github.com/nvbn/thefuck','nvbn','MIT License',undef,'Correcting your previous console command.',undef,],
		'fanstatic' => ['http://www.fanstatic.org/en/latest/',undef,undef,undef,'Packages. optimizes. and serves static file dependencies as Python packages.',undef,],
		'behave' => ['http://github.com/behave/behave','Jens Engel, Benno Rice and Richard Jones','BSD License',undef,'behave is behaviour-driven development, Python style',undef,],
		'dask' => ['https://dask.pydata.org/en/latest/',undef,undef,undef,'A flexible parallel computing library for analytic computing.',undef,],
		'testscenarios' => ['https://launchpad.net/testscenarios','Testing-cabal','BSD License',undef,'Testscenarios, a pyunit extension for dependency injection',undef,],
		'nylas sync engine' => ['https://github.com/nylas/sync-engine','nylas','GNU Affero General Public License v3.0',undef,'Providing a RESTful API on top of a powerful email sync platform.',undef,],
		'jinja2' => ['http://jinja.pocoo.org/','Armin Ronacher','BSD License',undef,'A small but fast and easy to use stand-alone template engine written in pure python.',undef,],
		'line_profiler' => ['https://github.com/rkern/line_profiler','rkern','Other',undef,'Line-by-line profiling.',undef,],
		'levenshtein' => ['https://github.com/ztane/python-Levenshtein/','ztane','GNU General Public License v2.0',undef,'Fast computation of Levenshtein distance and string similarity.',undef,],
		'pycassa' => ['https://github.com/pycassa/pycassa','pycassa','Other',undef,'Python Thrift driver for Cassandra.',undef,],
		'python-cinderclient' => ['https://docs.openstack.org/python-cinderclient/latest/','OpenStack','Apache Software License',undef,'OpenStack Block Storage API Client Library',undef,],
		'apex' => ['https://github.com/apex/apex','apex','MIT License',undef,'Build. deploy. and manage [AWS Lambda](https://aws.amazon.com/lambda/) functions with ease.',undef,],
		'xlwt' => ['https://github.com/python-excel/xlwt','python-excel','Other',undef,'Writing and reading data and formatting information from Excel files.',undef,],
		'extras' => ['https://github.com/testing-cabal/extras','Testing cabal','MIT License',undef,'Useful extra bits for Python - things that shold be in the standard library',undef,],
		'weasyprint' => ['http://weasyprint.org',undef,undef,undef,'A visual rendering engine for HTML and CSS that can export to PDF.',undef,],
		'xpinyin' => ['https://github.com/lxneng/xpinyin','lxneng',undef,undef,'A library to translate Chinese hanzi (漢字) to pinyin (拼音).',undef,],
		'luigi' => ['https://github.com/spotify/luigi','spotify','Apache License 2.0',undef,'A module that helps you build complex pipelines of batch jobs.',undef,],
		'sortedcontainers' => ['http://www.grantjenks.com/docs/sortedcontainers/',undef,undef,undef,'Fast. pure-Python implementation of SortedList. SortedDict. and SortedSet types.',undef,],
		'dotted' => ['https://github.com/carlosescri/DottedDict','carlosescri','MIT License',undef,'A library that provides a method of accessing lists and dicts with a dotted path notation.',undef,],
		'numpy' => ['http://www.numpy.org/',undef,undef,undef,'A fundamental package for scientific computing with Python.',undef,],
		'dateutil' => ['https://github.com/dateutil/dateutil','dateutil','Other',undef,'Extensions to the standard Python [datetime](https://docs.python.org/3/library/datetime.html) module.',undef,],
		'facepy' => ['https://github.com/jgorset/facepy','jgorset','MIT License',undef,'Facepy makes it really easy to interact with Facebooks Graph API',undef,],
		'sqlalchemy' => ['http://www.sqlalchemy.org','Mike Bayer','MIT License',undef,'Database Abstraction Library',undef,],
		'djangorestframework' => ['http://www.django-rest-framework.org','Tom Christie','BSD License',undef,'Web APIs for Django, made easy.',undef,],
		'flask-api-utils' => ['https://github.com/marselester/flask-api-utils','marselester','MIT License',undef,'Taking care of API representation and authentication for Flask.',undef,],
		'wtforms' => ['https://wtforms.readthedocs.io/','Thomas Johansson, James Crasta','BSD License',undef,'A flexible forms validation and rendering library for Python web development.',undef,],
		'when.py' => ['https://github.com/dirn/When.py','dirn','Other',undef,'Providing user-friendly functions to help perform common date and time actions.',undef,],
		'prospector' => ['https://github.com/landscapeio/prospector','landscapeio','GNU General Public License v2.0',undef,'A tool to analyse Python code.',undef,],
		'logging' => ['https://docs.python.org/3/library/logging.html',undef,undef,undef,'(Python standard library) Logging facility for Python.',undef,],
		'whoosh' => ['http://bitbucket.org/mchaput/whoosh','Matt Chaput','BSD License',undef,'Fast, pure-Python full text indexing, search, and spell checking library.',undef,],
		'amqp' => ['http://github.com/celery/py-amqp','Barry Pederson','BSD License',undef,'Low-level AMQP client for Python (fork of amqplib).',undef,],
		'linecache2' => ['https://github.com/testing-cabal/linecache2','Testing-cabal','Python Software Foundation License',undef,'Backports of the linecache module',undef,],
		'ipaddress' => ['https://github.com/phihag/ipaddress','Philipp Hagemeister','Python Software Foundation License',undef,'IPv4/IPv6 manipulation library',undef,],
		'django-compressor' => ['https://github.com/django-compressor/django-compressor','django-compressor','Other',undef,'Compresses linked and inline JavaScript or CSS into a single cached file.',undef,],
		'deform' => ['https://github.com/Pylons/deform','Pylons','Other',undef,'Python HTML form generation library influenced by the formish form generation library.',undef,],
		'protobuf' => ['https://developers.google.com/protocol-buffers/',undef,undef,undef,'Protocol Buffers',undef,],
		'cssutils' => ['https://pypi.python.org/pypi/cssutils/',undef,undef,undef,'A CSS library for Python.',undef,],
		'oslo.context' => ['https://docs.openstack.org/oslo.context/latest/','OpenStack','Apache Software License',undef,'Oslo Context library',undef,],
		'sparqlwrapper' => ['http://rdflib.github.io/sparqlwrapper','Ivan Herman, Sergio Fernández, Carlos Tejo Alonso, Alexey Zakhlestin','W3C License',undef,'SPARQL Endpoint interface to Python',undef,],
		'youtube_dl' => ['https://github.com/rg3/youtube-dl','Sergey M.','Public Domain',undef,'YouTube video downloader',undef,],
		'beautifulsoup' => ['https://www.crummy.com/software/BeautifulSoup/bs4/doc/',undef,undef,undef,'Providing Pythonic idioms for iterating. searching. and modifying HTML or XML.',undef,],
		'gunicorn' => ['https://pypi.python.org/pypi/gunicorn',undef,undef,undef,'Pre-forked. partly written in C.',undef,],
		'vcversioner' => ['https://github.com/habnabit/vcversioner','Aaron Gallagher','ISC License (ISCL)',undef,'Use version control tags to discover version numbers',undef,],
		'neupy' => ['http://neupy.com/pages/home.html',undef,undef,undef,'Running and testing different Artificial Neural Networks algorithms.',undef,],
		'fake2db' => ['https://github.com/emirozer/fake2db','emirozer','GNU General Public License v2.0',undef,'Fake database generator.',undef,],
		'pywin32' => ['https://sourceforge.net/projects/pywin32/',undef,undef,undef,'Python Extensions for Windows.',undef,],
		'geopy' => ['https://github.com/geopy/geopy','geopy','MIT License',undef,'Python Geocoding Toolbox.',undef,],
		'ggplot' => ['https://github.com/yhat/ggpy','yhat','BSD 2-Clause ""Simplified"" License',undef,'Same API as ggplot2 for R.',undef,],
		'devpi' => ['http://doc.devpi.net/latest/',undef,undef,undef,'PyPI server and packaging/testing/release tool.',undef,],
		'enaml' => ['https://github.com/nucleic/enaml','nucleic','Other',undef,'Creating beautiful user-interfaces with Declaratic Syntax like QML.',undef,],
		'locust' => ['https://github.com/locustio/locust','locustio','MIT License',undef,'Scalable user load testing tool written in Python.',undef,],
		'pytorch-nlp' => ['https://github.com/PetrochukM/PyTorch-NLP','PetrochukM','BSD 3-Clause ""New"" or ""Revised"" License',undef,'A toolkit enabling rapid deep learning NLP prototyping for research.',undef,],
		'theano' => ['https://github.com/Theano/Theano','Theano','Other',undef,'A library for fast numerical computation.',undef,],
		'm3u8' => ['https://github.com/globocom/m3u8','globocom','Other',undef,'A module for parsing m3u8 file.',undef,],
		'grumpy' => ['https://github.com/google/grumpy','google','Apache License 2.0',undef,'More compiler than interpreter as more powerful CPython2.7 replacement (alpha).',undef,],
		'wooey' => ['https://github.com/wooey/wooey','wooey','BSD 3-Clause ""New"" or ""Revised"" License',undef,'A Django app which creates automatic web UIs for Python scripts.',undef,],
		'cclib' => ['http://cclib.github.io/',undef,undef,undef,'A library for parsing and interpreting the results of computational chemistry packages.',undef,],
		'jedi-vim' => ['https://github.com/davidhalter/jedi-vim','davidhalter','MIT License',undef,'Vim bindings for the Jedi auto-completion library for Python.',undef,],
		'pyringe' => ['https://github.com/google/pyringe','google','Apache License 2.0',undef,'Debugger capable of attaching to and injecting code into Python processes.',undef,],
		'mozinfo' => ['https://wiki.mozilla.org/Auto-tools/Projects/Mozbase','Mozilla Automation and Testing Team',undef,undef,'Library to get system information for use in Mozilla testing',undef,],
		'amqplib' => ['https://github.com/barryp/py-amqplib','Barry Pederson','GNU Library or Lesser General Public License (LGPL)',undef,'AMQP Client Library',undef,],
		'sanitize' => ['https://github.com/Alir3z4/python-sanitize','Alir3z4','BSD 2-Clause ""Simplified"" License',undef,'Bringing sanity to world of messed-up data.',undef,],
		'mimesis' => ['https://github.com/lk-geimfari/mimesis','lk-geimfari','MIT License',undef,'is a Python library that help you generate fake data.',undef,],
		'pyelftools' => ['https://github.com/eliben/pyelftools','eliben','Other',undef,'Parsing and analyzing ELF files and DWARF debugging information.',undef,],
		'regex' => ['https://bitbucket.org/mrabarnett/mrab-regex','Matthew Barnett','Python Software Foundation License',undef,'Alternative regular expression module, to replace re.',undef,],
		'pika' => ['https://pika.readthedocs.io',undef,'BSD License',undef,'Pika Python AMQP Client Library',undef,],
		'python-goose' => ['https://github.com/grangier/python-goose','grangier','Apache License 2.0',undef,'HTML Content/Article Extractor.',undef,],
		'mininet' => ['http://mininet.org/',undef,undef,undef,'A popular network emulator and API written in Python.',undef,],
		'clpython' => ['https://github.com/metawilm/cl-python','metawilm','Other',undef,'Implementation of the Python programming language written in Common Lisp.',undef,],
		'cornice' => ['https://github.com/Cornices/cornice','Cornices','Other',undef,'A RESTful framework for Pyramid.',undef,],
		'anyjson' => ['http://bitbucket.org/runeh/anyjson/','Rune Halvorsen','BSD License',undef,'Wraps the best available JSON implementation available in a common interface',undef,],
		'platformio' => ['https://github.com/platformio/platformio-core','platformio','Apache License 2.0',undef,'A console tool to build code with different development platforms.',undef,],
		'bpython' => ['https://github.com/bpython/bpython','bpython','Other',undef,'A fancy interface to the Python interpreter.',undef,],
		'jsonpointer' => ['https://github.com/stefankoegl/python-json-pointer','Stefan Kögl','BSD License',undef,'Identify specific nodes in a JSON document (RFC 6901)',undef,],
		'colander' => ['https://docs.pylonsproject.org/projects/colander/en/latest/',undef,undef,undef,'Validating and deserializing data obtained via XML. JSON. an HTML form post.',undef,],
		'elasticsearch-py' => ['https://www.elastic.co/guide/en/elasticsearch/client/python-api/current/index.html',undef,undef,undef,'The official low-level Python client for [Elasticsearch](https://www.elastic.co/products/elasticsearch).',undef,],
		'blessings' => ['https://github.com/erikrose/blessings','Erik Rose','MIT License',undef,'A thin, practical wrapper around terminal coloring, styling, and positioning',undef,],
		'iptools' => ['https://github.com/bd808/python-iptools','Bryan Davis','BSD License',undef,'Python utilites for manipulating IPv4 and IPv6 addresses',undef,],
		'vispy' => ['https://github.com/vispy/vispy','vispy','Other',undef,'High-performance scientific visualization based on OpenGL.',undef,],
		'pluggy' => ['https://github.com/pytest-dev/pluggy','Holger Krekel','MIT License',undef,'plugin and hook calling mechanisms for python',undef,],
		'pathlib' => ['https://pathlib.readthedocs.org/en/pep428/',undef,undef,undef,'(Python standard library in Python 3.4+) An cross-platform. object-oriented path library.',undef,],
		'enum34' => ['https://bitbucket.org/stoneleaf/enum34','Ethan Furman','BSD License',undef,'Python 3.4 Enum backported to 3.3, 3.2, 3.1, 2.7, 2.6, 2.5, and 2.4',undef,],
		'pathtools' => ['http://github.com/gorakhargosh/pathtools','Yesudeep Mangalapilly','MIT License',undef,'File system general utilities',undef,],
		'ptyprocess' => ['https://github.com/pexpect/ptyprocess','Thomas Kluyver','ISC License (ISCL)',undef,'Run a subprocess in a pseudo terminal',undef,],
		'remote-pdb' => ['https://github.com/ionelmc/python-remote-pdb','ionelmc','BSD 2-Clause ""Simplified"" License',undef,'Remote vanilla PDB (over TCP sockets).',undef,],
		'nltk' => ['http://www.nltk.org/',undef,undef,undef,'A leading platform for building Python programs to work with human language data.',undef,],
		'flywheel' => ['https://github.com/stevearc/flywheel','stevearc','MIT License',undef,'Object mapper for Amazon DynamoDB.',undef,],
		'gitpython' => ['https://github.com/gitpython-developers/GitPython','Sebastian Thiel, Michael Trier','BSD License',undef,'Python Git Library',undef,],
		'redisco' => ['https://github.com/kiddouk/redisco','kiddouk','MIT License',undef,'A Python Library for Simple Models and Containers Persisted in Redis.',undef,],
		'mozfile' => ['https://wiki.mozilla.org/Auto-tools/Projects/Mozbase','Mozilla Automation and Tools team',undef,undef,'Library of file utilities for use in Mozilla testing',undef,],
		'django' => ['https://www.djangoproject.com/',undef,undef,undef,'The most popular web framework in Python.',undef,],
		'pytest' => ['https://docs.pytest.org/en/latest/',undef,undef,undef,'A mature full-featured Python testing tool.',undef,],
		'toapi' => ['https://github.com/gaojiuli/toapi','gaojiuli','Other',undef,'Every web site provides APIs.',undef,],
		'envelopes' => ['http://tomekwojcik.github.io/envelopes/',undef,undef,undef,'Mailing for human beings.',undef,],
		'pyyaml' => ['http://pyyaml.org/',undef,undef,undef,'YAML implementations for Python.',undef,],
		'mxnet' => ['https://github.com/dmlc/mxnet','dmlc','Apache License 2.0',undef,'A deep learning framework designed for both efficiency and flexibility.',undef,],
		'cmd2' => ['https://github.com/python-cmd2/cmd2','Catherine Devlin','MIT License',undef,'cmd2 - a tool for building interactive command line applications in Python',undef,],
		'pelican' => ['https://blog.getpelican.com/',undef,undef,undef,'Uses Markdown or ReST for content and Jinja 2 for themes. Supports DVCS. Disqus. AGPL.',undef,],
		'orator' => ['https://orator-orm.com',undef,undef,undef,'The Orator ORM provides a simple yet beautiful ActiveRecord implementation.',undef,],
		'twisted' => ['https://twistedmatrix.com/trac/',undef,undef,undef,'An event-driven networking engine.',undef,],
		'uritemplate' => ['https://uritemplate.readthedocs.org','Ian Cordasco','BSD License',undef,'URI templates',undef,],
		'freezegun' => ['https://github.com/spulec/freezegun','spulec','Apache License 2.0',undef,'Travel through time by mocking the datetime module.',undef,],
		'robot framework' => ['https://github.com/robotframework/robotframework','robotframework','Other',undef,'A generic test automation framework.',undef,],
		'relatorio' => ['http://relatorio.tryton.org/',undef,undef,undef,'Templating OpenDocument files.',undef,],
		'hashids' => ['https://github.com/davidaurelio/hashids-python','davidaurelio','MIT License',undef,'Implementation of [hashids](http://hashids.org) in Python.',undef,],
		'filechunkio' => ['http://bitbucket.org/fabian/filechunkio','Fabian Topfstedt',undef,undef,'FileChunkIO represents a chunk of an OS-level file containing bytes data',undef,],
		'google-api-python-client' => ['https://github.com/google/google-api-python-client','google','Other',undef,'Google APIs Client Library for Python.',undef,],
		'pandas' => ['http://pandas.pydata.org/',undef,undef,undef,'A library providing high-performance. easy-to-use data structures and data analysis tools.',undef,],
		'autobahnpython' => ['https://github.com/crossbario/autobahn-python','crossbario','MIT License',undef,'WebSocket & WAMP for Python on Twisted and [asyncio](https://docs.python.org/3/library/asyncio.html).',undef,],
		'python-jwt' => ['https://github.com/davedoesdev/python-jwt','davedoesdev','MIT License',undef,'Module for generating and verifying JSON Web Tokens.',undef,],
		'pychievements' => ['https://github.com/PacketPerception/pychievements','PacketPerception','MIT License',undef,'A framework for creating and tracking achievements.',undef,],
		'prettytable' => ['http://code.google.com/p/prettytable/','Luke Maurits','BSD License',undef,'A simple Python library for easily displaying tabular data in a visually appealing ASCII table format.',undef,],
		'django-devserver' => ['https://github.com/dcramer/django-devserver','dcramer','Other',undef,'A drop-in replacement for Djangos runserver.',undef,],
		'docopt' => ['http://docopt.org/',undef,undef,undef,'Pythonic command line arguments parser.',undef,],
		'flask-admin' => ['https://github.com/flask-admin/flask-admin','flask-admin','Other',undef,'Simple and extensible administrative interface framework for Flask.',undef,],
		'pyflakes' => ['https://github.com/PyCQA/pyflakes','A lot of people','MIT License',undef,'passive checker of Python programs',undef,],
		'bidict' => ['https://github.com/jab/bidict','jab','Mozilla Public License 2.0',undef,'Efficient. Pythonic bidirectional map data structures and related functionality..',undef,],
		'wifi' => ['https://github.com/rockymeza/wifi','rockymeza','BSD 2-Clause ""Simplified"" License',undef,'A Python library and command line tool for working with WiFi on Linux.',undef,],
		'pyjs' => ['http://pyjs.org',undef,'Apache',undef,'pyjs is a Rich Internet Application (RIA) Development Platform for both Web and Desktop','RIA framework',],
		'dash' => ['https://plot.ly/products/dash/',undef,undef,undef,'Built on top of Flask. React and Plotly aimed at analytical web applications.',undef,],
		'pygame' => ['http://www.pygame.org/news.html',undef,undef,undef,'Pygame is a set of Python modules designed for writing games.',undef,],
		'oslo.db' => ['https://docs.openstack.org/oslo.db/latest','OpenStack','Apache Software License',undef,'Oslo Database library',undef,],
		'doit' => ['http://pydoit.org/',undef,undef,undef,'A task runner and build tool.',undef,],
		'seaborn' => ['https://github.com/mwaskom/seaborn','mwaskom','BSD 3-Clause ""New"" or ""Revised"" License',undef,'Statistical data visualization using Matplotlib.',undef,],
		'packaging' => ['https://github.com/pypa/packaging','Donald Stufft and individual contributors','BSD License',undef,'Core utilities for Python packages',undef,],
		'solrpy' => ['https://github.com/edsu/solrpy','edsu',undef,undef,'A Python client for [solr](http://lucene.apache.org/solr/).',undef,],
		'restless' => ['https://github.com/toastdriven/restless','toastdriven','BSD 3-Clause ""New"" or ""Revised"" License',undef,'Framework agnostic REST framework based on lessons learned from Tastypie.',undef,],
		'tkinter' => ['https://wiki.python.org/moin/TkInter',undef,undef,undef,'Tkinter is Pythons de-facto standard GUI package.',undef,],
		'pyramid' => ['https://pylonsproject.org/',undef,undef,undef,'A small. fast. down-to-earth. open source Python web framework.',undef,],
		'vprof' => ['https://github.com/nvdv/vprof','nvdv','BSD 2-Clause ""Simplified"" License',undef,'Visual Python profiler.',undef,],
		'django-oscar' => ['http://oscarcommerce.com/',undef,undef,undef,'An open-source e-commerce framework for Django.',undef,],
		'oslo.log' => ['https://docs.openstack.org/oslo.log/latest','OpenStack','Apache Software License',undef,'oslo.log library',undef,],
		'simplejson' => ['https://github.com/simplejson/simplejson','Bob Ippolito','MIT License',undef,'Simple, fast, extensible JSON encoder/decoder for Python',undef,],
		'pyqt' => ['https://riverbankcomputing.com/software/pyqt/intro',undef,undef,undef,'Python bindings for the [Qt](https://www.qt.io/) cross-platform application and UI framework. with support for both Qt v4 and Qt v5 frameworks.',undef,],
		'pyserial' => ['https://github.com/pyserial/pyserial','Chris Liechti','BSD License',undef,'Python Serial Port Extension',undef,],
		'txpostgres' => ['https://github.com/wulczer/txpostgres','wulczer','MIT License',undef,'Twisted based asynchronous driver for PostgreSQL.',undef,],
		'python-daemon' => ['https://pagure.io/python-daemon/','Ben Finney','Apache Software License',undef,'Library to implement a well-behaved Unix daemon process.',undef,],
		'python-mode' => ['https://github.com/python-mode/python-mode','python-mode','GNU Lesser General Public License v3.0',undef,'An all in one plugin for turning Vim into a Python IDE.',undef,],
		'pattern' => ['http://www.clips.ua.ac.be/pattern',undef,undef,undef,'A web mining module for the Python.',undef,],
		'jinja2' => ['https://github.com/pallets/jinja','pallets','Other',undef,'A modern and designer friendly templating language.',undef,],
		'cffi' => ['https://pypi.python.org/pypi/cffi',undef,undef,undef,'Foreign Function Interface for Python calling C code.',undef,],
		'zope' => ['http://www.zope.org',undef,'Zope Public License',undef,'Zope is a free and open source web application server','web application server',],
		'mozdevice' => ['https://wiki.mozilla.org/Auto-tools/Projects/Mozbase','Mozilla Automation and Testing Team',undef,undef,'Mozilla-authored device management',undef,],
		'python-future' => ['http://python-future.org/index.html',undef,undef,undef,'The missing compatibility layer between Python 2 and Python 3.',undef,],
		'oslo.middleware' => ['https://docs.openstack.org/oslo.middleware/latest/','OpenStack','Apache Software License',undef,'Oslo Middleware library',undef,],
		'fixtures' => ['https://launchpad.net/python-fixtures','Robert Collins','BSD License',undef,'Fixtures, reusable state for writing clean tests and more.',undef,],
		'happybase' => ['https://github.com/wbolster/happybase','wbolster','Other',undef,'A developer-friendly library for Apache HBase.',undef,],
		'kotti' => ['http://kotti.pylonsproject.org/',undef,undef,undef,'A high-level. Pythonic web application framework built on Pyramid.',undef,],
		'xlwings' => ['https://www.xlwings.org',undef,undef,undef,'A BSD-licensed library that makes it easy to call Python from Excel and vice versa.',undef,],
		'cherrypy' => ['http://cherrypy.org/',undef,'BSD',undef,'A Minimalist Python Web Framework','web framework',],
		'django-tastypie' => ['http://tastypieapi.org/',undef,undef,undef,'Creating delicious APIs for Django apps.',undef,],
		'django-cache-machine' => ['https://github.com/django-cache-machine/django-cache-machine','django-cache-machine','Other',undef,'Automatic caching and invalidation for Django models.',undef,],
		'faker' => ['https://github.com/joke2k/faker','joke2k','MIT License',undef,'A Python package that generates fake data.',undef,],
		'execnet' => ['http://codespeak.net/execnet','holger krekel and others','MIT License',undef,'execnet: rapid multi-Python deployment',undef,],
		'django-simple-captcha' => ['https://github.com/mbi/django-simple-captcha','mbi','MIT License',undef,'A simple and highly customizable Django app to add captcha images to any Django form.',undef,],
		'uvloop' => ['https://github.com/MagicStack/uvloop','MagicStack','Other',undef,'Ultra fast implementation of asyncio event loop on top of libuv.',undef,],
		'splinter' => ['https://github.com/cobrateam/splinter','cobrateam','BSD 3-Clause ""New"" or ""Revised"" License',undef,'Open source tool for testing web applications.',undef,],
		'dogpile.cache' => ['http://dogpilecache.readthedocs.io/en/latest/',undef,undef,undef,'dogpile.cache is next generation replacement for Beaker made by same authors.',undef,],
		'keystonemiddleware' => ['https://docs.openstack.org/keystonemiddleware/latest/','OpenStack','Apache Software License',undef,'Middleware for OpenStack Identity',undef,],
		'plone' => ['https://plone.org/',undef,undef,undef,'A CMS built on top of the open source application server Zope.',undef,],
		'zappa' => ['https://github.com/Miserlou/Zappa','Miserlou','MIT License',undef,'A tool for deploying WSGI applications on AWS Lambda and API Gateway.',undef,],
		'retrying' => ['https://github.com/rholder/retrying','Ray Holder','Apache Software License',undef,'Retrying',undef,],
		'zc.recipe.egg' => ['http://cheeseshop.python.org/pypi/zc.recipe.egg','Jim Fulton','Zope Public License',undef,'Recipe for installing Python package distributions as eggs',undef,],
		'celery' => ['http://www.celeryproject.org/',undef,undef,undef,'An asynchronous task queue/job queue based on distributed message passing.',undef,],
		'markdown' => ['https://Python-Markdown.github.io/','Waylan Limberg','BSD License',undef,'Python implementation of Markdown.',undef,],
		'django-xadmin' => ['https://github.com/sshwsfc/xadmin','sshwsfc','Other',undef,'Drop-in replacement of Django admin comes with lots of goodies.',undef,],
		'haul' => ['https://github.com/vinta/Haul','vinta','MIT License',undef,'An Extensible Image Crawler.',undef,],
		'webargs' => ['https://github.com/sloria/webargs','sloria','MIT License',undef,'A friendly library for parsing HTTP request arguments. with built-in support for popular web frameworks. including Flask. Django. Bottle. Tornado. and Pyramid.',undef,],
		'falcon' => ['http://falconframework.org/',undef,undef,undef,'A high-performance framework for building cloud APIs and web app backends.',undef,],
		'openstack' => ['https://www.openstack.org/',undef,undef,undef,'Open source software for building private and public clouds.',undef,],
		'feedparser' => ['http://pythonhosted.org/feedparser/',undef,undef,undef,'Universal feed parser.',undef,],
		'portia' => ['https://github.com/scrapinghub/portia','scrapinghub','Other',undef,'Visual scraping for Scrapy.',undef,],
		'zope.component' => ['https://github.com/zopefoundation/zope.component','Zope Foundation and Contributors','Zope Public License',undef,'Zope Component Architecture',undef,],
		'pyside' => ['https://wiki.qt.io/PySide',undef,undef,undef,'Python bindings for the [Qt](http://www.qt.io/) cross-platform application and UI framework. supporting the Qt v4 framework.',undef,],
		'django-viewlet' => ['https://github.com/5monkeys/django-viewlet','5monkeys','MIT License',undef,'Render template parts with extended cache control.',undef,],
		'django-shop' => ['https://github.com/awesto/django-shop','awesto','BSD 3-Clause ""New"" or ""Revised"" License',undef,'A Django based shop system.',undef,],
		'pingo' => ['http://www.pingo.io/',undef,undef,undef,'Pingo provides a uniform API to program devices like the Raspberry Pi. pcDuino. Intel Galileo. etc.',undef,],
		'pygal' => ['http://www.pygal.org/en/latest/',undef,undef,undef,'A Python SVG Charts Creator.',undef,],
		'alabaster' => ['https://alabaster.readthedocs.io','Jeff Forcier','BSD License',undef,'A configurable sidebar-enabled Sphinx theme',undef,],
		'model_mommy' => ['https://github.com/vandersonmota/model_mommy','vandersonmota','Other',undef,'Creating random fixtures for testing in Django.',undef,],
		'python-keystoneclient' => ['https://docs.openstack.org/python-keystoneclient/latest/','OpenStack','Apache Software License',undef,'Client Library for OpenStack Identity',undef,],
		'sphinx_rtd_theme' => ['https://github.com/rtfd/sphinx_rtd_theme/','Dave Snider, Read the Docs, Inc. & contributors','MIT License',undef,'Read the Docs theme for Sphinx',undef,],
		'bottle' => ['http://bottlepy.org/docs/dev/index.html',undef,undef,undef,'A fast. simple and lightweight WSGI micro web-framework.',undef,],
		'pyinstaller' => ['https://github.com/pyinstaller/pyinstaller','pyinstaller','Other',undef,'Converts Python programs into stand-alone executables (cross-platform).',undef,],
		'nipy' => ['http://nipy.org',undef,undef,undef,'A collection of neuroimaging toolkits.',undef,],
		'python-jws' => ['https://github.com/brianloveswords/python-jws','brianloveswords',undef,undef,'Implementation of JSON Web Signatures draft 02.',undef,],
		'python-slugify' => ['https://github.com/un33k/python-slugify','un33k','MIT License',undef,'A Python slugify library that translates unicode to ASCII.',undef,],
		'pygments' => ['http://pygments.org/',undef,undef,undef,'A generic syntax highlighter.',undef,],
		'redis' => ['http://github.com/andymccurdy/redis-py','Andy McCurdy','MIT License',undef,'Python client for Redis key-value store',undef,],
		'argparse' => ['https://github.com/ThomasWaldmann/argparse/','Thomas Waldmann','Python Software Foundation License',undef,'Python command-line parsing library',undef,],
		'django-pipeline' => ['https://github.com/jazzband/django-pipeline','jazzband','MIT License',undef,'An asset packaging library for Django.',undef,],
		'schematics' => ['https://github.com/schematics/schematics','schematics','Other',undef,'Data Structure Validation.',undef,],
		'pyre' => ['https://github.com/facebook/pyre-check','facebook','MIT License',undef,'Performant type checking.',undef,],
		'html2text' => ['https://github.com/Alir3z4/html2text','Alir3z4','GNU General Public License v3.0',undef,'Convert HTML to Markdown-formatted text.',undef,],
		'pathpicker' => ['https://github.com/facebook/PathPicker','facebook','Other',undef,'Select files out of bash output.',undef,],
		'ironpython' => ['https://github.com/IronLanguages/ironpython3','IronLanguages','Apache License 2.0',undef,'Implementation of the Python programming language written in C# targeting the .NET Framework and Mono.',undef,],
		'routes' => ['https://routes.readthedocs.io/','Ben Bangert','MIT License',undef,'Routing Recognition and Generation Tools',undef,],
		'errbot' => ['http://errbot.io/en/latest/',undef,undef,undef,'The easiest and most popular chatbot to implement ChatOps.',undef,],
		'xmldataset' => ['https://xmldataset.readthedocs.io/en/latest/',undef,undef,undef,'Simple XML Parsing.',undef,],
		'django-elastic-transcoder' => ['https://github.com/StreetVoice/django-elastic-transcoder','StreetVoice',undef,undef,'Django + [Amazon Elastic Transcoder](https://aws.amazon.com/elastictranscoder/).',undef,],
		'google-apputils' => ['http://code.google.com/p/google-apputils-python','Google Inc.',undef,undef,'Obsolete. Please migrate to absl-py instead.',undef,],
		'jupyter notebook (ipython)' => ['IPython',undef,undef,undef,'A rich toolkit to help you make the most out of using Python interactively.',undef,],
		'mutagen' => ['https://github.com/quodlibet/mutagen','quodlibet','GNU General Public License v2.0',undef,'A Python module to handle audio metadata.',undef,],
		'mixer' => ['https://github.com/klen/mixer','klen','Other',undef,'Another fixtures replacement. Supported Django. Flask. SQLAlchemy. Peewee and etc.',undef,],
		'pyfiglet' => ['https://github.com/pwaller/pyfiglet','pwaller','GNU General Public License v2.0',undef,'An implementation of figlet written in Python.',undef,],
		'billiard' => ['http://github.com/celery/billiard','R Oudkerk / Python Software Foundation','BSD License',undef,'Python multiprocessing fork with improvements and bugfixes',undef,],
		'pyramid' => ['https://trypyramid.com/',undef,'BSD',undef,'The Start Small, Finish Big Stay Finished Framework','web framework',],
		'pymc' => ['https://github.com/pymc-devs/pymc3','pymc-devs','Other',undef,'Markov Chain Monte Carlo sampling toolkit.',undef,],
		'cx_oracle' => ['https://oracle.github.io/python-cx_Oracle','Anthony Tuininga','BSD License',undef,'Python interface to Oracle',undef,],
		'mozprofile' => ['https://wiki.mozilla.org/Auto-tools/Projects/Mozbase','Mozilla Automation and Tools team','Mozilla Public License 2.0 (MPL 2.0)',undef,'Library to create and modify Mozilla application profiles',undef,],
		'apache-libcloud' => ['https://libcloud.apache.org/',undef,undef,undef,'One Python library for all clouds.',undef,],
		'netaddr' => ['https://github.com/drkjam/netaddr/','Stefan Nordhausen','MIT License',undef,'A network address manipulation library for Python',undef,],
		'setuptools_scm' => ['https://github.com/pypa/setuptools_scm/','Ronny Pfannschmidt','MIT License',undef,'the blessed package to manage your versions by scm tags',undef,],
		'isodate' => ['https://github.com/gweis/isodate/','Gerhard Weis','BSD License',undef,'An ISO 8601 date/time/duration parser and formatter',undef,],
		'monotonic' => ['https://github.com/atdt/monotonic','Ori Livneh','Apache Software License',undef,'An implementation of time.monotonic() for Python 2 & < 3.3',undef,],
		'widgy' => ['https://wid.gy/',undef,undef,undef,'Last CMS framework. based on Django.',undef,],
		'mycli' => ['https://github.com/dbcli/mycli','dbcli','Other',undef,'A Terminal Client for MySQL with AutoCompletion and Syntax Highlighting.',undef,],
		'hyde' => ['http://hyde.github.io/',undef,undef,undef,'Jinja2-based static web site generator.',undef,],
		'breadsticks' => ['https://github.com/mattrobenolt/breadsticks','Matt Robenolt','BSD License',undef,'Install breadsticks into your python.',undef,],
		'flower' => ['https://github.com/mher/flower','mher','Other',undef,'Real-time monitor and web admin for Celery.',undef,],
		'pygments' => ['http://pygments.org/','Georg Brandl','BSD License',undef,'Pygments is a syntax highlighting package written in Python.',undef,],
		'pyexcel' => ['https://github.com/pyexcel/pyexcel','pyexcel','Other',undef,'Providing one API for reading. manipulating and writing csv. ods. xls. xlsx and xlsm files.',undef,],
		'pycurl' => ['http://pycurl.io/','Oleg Pudeyev','MIT License',undef,'PycURL -- A Python Interface To The cURL library',undef,],
		'attrs' => ['https://github.com/python-attrs/attrs','python-attrs','MIT License',undef,'Replacement for `__init__`. `__eq__`. `__repr__`. etc. boilerplate in class definitions.',undef,],
		'oslo.config' => ['https://docs.openstack.org/oslo.config/latest/','OpenStack','Apache Software License',undef,'Oslo Configuration API',undef,],
		'opencv' => ['http://opencv.org/',undef,undef,undef,'Open Source Computer Vision Library.',undef,],
		'ipython_genutils' => ['http://ipython.org','IPython Development Team','BSD License',undef,'Vestigial utilities from IPython',undef,],
		'netius' => ['https://github.com/hivesolutions/netius','hivesolutions','Apache License 2.0',undef,'Asynchronous. very fast.',undef,],
		'jieba' => ['https://github.com/fxsjy/jieba','fxsjy','MIT License',undef,'Chinese text segmentation.',undef,],
		'pygobject' => ['https://wiki.gnome.org/Projects/PyGObject',undef,undef,undef,'Python Bindings for GLib/GObject/GIO/GTK+ (GTK+3).',undef,],
		'qds_sdk' => ['https://github.com/qubole/qds-sdk-py','Qubole','Apache Software License',undef,'Python SDK for coding to the Qubole Data Service API',undef,],
		'httpretty' => ['https://github.com/gabrielfalcao/HTTPretty','gabrielfalcao','MIT License',undef,'HTTP request mock tool for Python.',undef,],
		'mozhttpd' => ['https://wiki.mozilla.org/Auto-tools/Projects/Mozbase','Mozilla Automation and Testing Team',undef,undef,'Python webserver intended for use with Mozilla testing',undef,],
		'python-prompt-toolkit' => ['https://github.com/jonathanslenders/python-prompt-toolkit','jonathanslenders','BSD 3-Clause ""New"" or ""Revised"" License',undef,'A library for building powerful interactive command lines.',undef,],
		'shapely' => ['https://github.com/Toblerity/Shapely','Sean Gillies','BSD License',undef,'Geometric objects, predicates, and operations',undef,],
		'django-cms' => ['https://www.django-cms.org/en/',undef,undef,undef,'An Open source enterprise CMS based on the Django.',undef,],
		'profig' => ['http://profig.readthedocs.org/en/default/',undef,undef,undef,'Config from multiple formats with value conversion.',undef,],
		'hunter' => ['https://github.com/ionelmc/python-hunter','ionelmc','Other',undef,'Hunter is a flexible code tracing toolkit.',undef,],
		'simplejsonrpcserver' => ['https://github.com/joshmarshall/jsonrpclib/','joshmarshall','Other',undef,'This library is an implementation of the JSON-RPC specification.',undef,],
		'mock' => ['https://docs.python.org/3/library/unittest.mock.html',undef,undef,undef,'(Python standard library) A mocking and patching library.',undef,],
		'django-mongodb-engine' => ['https://github.com/django-nonrel/mongodb-engine','django-nonrel',undef,undef,'Django MongoDB Backend.',undef,],
		'pyjwt' => ['https://github.com/jpadilla/pyjwt','jpadilla','MIT License',undef,'Implementation of the JSON Web Token draft 01.',undef,],
		'aws-cli' => ['https://github.com/aws/aws-cli','aws','Other',undef,'A universal command-line interface for Amazon Web Services.',undef,],
		'you-get' => ['http://you-get.org/',undef,undef,undef,'A YouTube/Youku/Niconico video downloader written in Python 3.',undef,],
		'django-celery' => ['http://celeryproject.org','Ask Solem','BSD License',undef,'Old django celery integration project.',undef,],
		'pyasn1-modules' => ['https://github.com/etingof/pyasn1-modules','Ilya Etingof <etingof@gmail.com>','BSD License',undef,'A collection of ASN.1-based protocols modules.',undef,],
		'flexx' => ['https://github.com/zoofIO/flexx','zoofIO','BSD 2-Clause ""Simplified"" License',undef,'Flexx is a pure Python toolkit for creating GUIs. that uses web technology for its rendering.',undef,],
		'altair' => ['https://github.com/altair-viz/altair','altair-viz','BSD 3-Clause ""New"" or ""Revised"" License',undef,'Declarative statistical visualization library for Python.',undef,],
		'radar' => ['https://pypi.python.org/pypi/radar',undef,undef,undef,'Generate random datetime / time.',undef,],
		'termcolor' => ['http://pypi.python.org/pypi/termcolor','Konstantin Lepa','MIT License',undef,'ANSII Color formatting for output in terminal.',undef,],
		'marrow mailer' => ['https://github.com/marrow/mailer','marrow','MIT License',undef,'High-performance extensible mail delivery framework.',undef,],
		'warlock' => ['http://github.com/bcwaldon/warlock','Brian Waldon',undef,undef,'Python object model built on JSON schema and JSON patch.',undef,],
		'pdb++' => ['https://pypi.python.org/pypi/pdbpp/',undef,undef,undef,'Another drop-in replacement for pdb.',undef,],
		'curdling' => ['http://clarete.li/curdling/',undef,undef,undef,'Curdling is a command line tool for managing Python packages.',undef,],
		'eventlet' => ['http://eventlet.net/',undef,undef,undef,'Asynchronous framework with WSGI support.',undef,],
		'saleor' => ['http://getsaleor.com/',undef,undef,undef,'An e-commerce storefront for Django.',undef,],
		'ripozo' => ['https://github.com/vertical-knowledge/ripozo','vertical-knowledge','GNU General Public License v2.0',undef,'Quickly creating REST/HATEOAS/Hypermedia APIs.',undef,],
		'hug' => ['https://github.com/timothycrosley/hug','timothycrosley','MIT License',undef,'A Python3 framework for cleanly exposing APIs over HTTP and the Command Line with automatic documentation and validation.',undef,],
		'eve' => ['https://github.com/pyeve/eve','pyeve','Other',undef,'REST API framework powered by Flask. MongoDB and good intentions.',undef,],
		'pywebview' => ['https://github.com/r0x0r/pywebview/','r0x0r','BSD 3-Clause ""New"" or ""Revised"" License',undef,'A lightweight cross-platform native wrapper around a webview component that allows to display HTML content in its own native dedicated window.',undef,],
		'cassandra-python-driver' => ['https://github.com/datastax/python-driver','datastax','Apache License 2.0',undef,'Python driver for Cassandra.',undef,],
		'nose' => ['https://github.com/nose-devs/nose','nose-devs',undef,undef,'A nicer unittest for Python.',undef,],
		'pyjion' => ['https://github.com/Microsoft/Pyjion','Microsoft','MIT License',undef,'A JIT for Python based upon CoreCLR.',undef,],
		'elpy' => ['https://github.com/jorgenschaefer/elpy','jorgenschaefer','GNU General Public License v3.0',undef,'Emacs Python Development Environment.',undef,],
		'acidfs' => ['http://acidfs.readthedocs.io',undef,'BSD',undef,'AcidFS allows interaction with the filesystem using transactions with ACID semantics','library',],
		'scoop' => ['https://github.com/soravux/scoop','soravux','GNU Lesser General Public License v3.0',undef,'Scalable Concurrent Operations in Python.',undef,],
		'config' => ['https://www.red-dove.com/config-doc/',undef,undef,undef,'Hierarchical config from the author of [logging](https://docs.python.org/3/library/logging.html).',undef,],
		'suds' => ['https://fedorahosted.org/suds','Jeff Ortel',undef,undef,'Lightweight SOAP client',undef,],
		'ply' => ['http://www.dabeaz.com/ply/',undef,undef,undef,'Implementation of lex and yacc parsing tools for Python.',undef,],
		'quokka' => ['http://quokkaproject.org/',undef,undef,undef,'Flexible. extensible. small CMS powered by Flask and MongoDB.',undef,],
		'funcy' => ['https://github.com/Suor/funcy','Suor','Other',undef,'A fancy and practical functional tools.',undef,],
		'awesome-slugify' => ['https://github.com/dimka665/awesome-slugify','dimka665',undef,undef,'A Python slugify library that can preserve unicode.',undef,],
		'wtforms' => ['https://github.com/wtforms/wtforms','wtforms','Other',undef,'A flexible forms validation and rendering library.',undef,],
		'docutils' => ['http://docutils.sourceforge.net/','docutils-develop list','Public Domain',undef,'Docutils -- Python Documentation Utilities',undef,],
		'python-openid' => ['http://github.com/openid/python-openid','JanRain','Apache Software License',undef,'OpenID support for servers and consumers.',undef,],
		'ctypes' => ['https://docs.python.org/3/library/ctypes.html',undef,undef,undef,'(Python standard library) Foreign Function Interface for Python calling C code.',undef,],
		'smmap' => ['https://github.com/gitpython-developers/smmap','Sebastian Thiel','BSD License',undef,'A pure git implementation of a sliding window memory map manager',undef,],
		'rq' => ['http://python-rq.org/',undef,undef,undef,'Simple job queues for Python.',undef,],
		'diesel' => ['https://github.com/dieseldev/diesel','dieseldev','Other',undef,'Greenlet-based event I/O Framework for Python.',undef,],
		'tinytag' => ['https://github.com/devsnd/tinytag','devsnd','MIT License',undef,'A library for reading music meta data of MP3. OGG. FLAC and Wave files.',undef,],
		'pyglet' => ['https://bitbucket.org/pyglet/pyglet/wiki/Home',undef,undef,undef,'A cross-platform windowing and multimedia library for Python.',undef,],
		'traceback2' => ['https://github.com/testing-cabal/traceback2','Testing-cabal','Python Software Foundation License',undef,'Backports of the traceback module',undef,],
		'plan' => ['https://github.com/fengsp/plan','fengsp','Other',undef,'Writing crontab file in Python like a charm.',undef,],
		'numba' => ['http://numba.pydata.org/',undef,undef,undef,'Python JIT compiler to LLVM aimed at scientific Python.',undef,],
		'bleach' => ['https://github.com/mozilla/bleach','mozilla','Other',undef,'A whitelist-based HTML sanitization and text linkification library.',undef,],
		'venv' => ['https://docs.python.org/3/library/venv.html',undef,undef,undef,'(Python standard library in Python 3.3+) Creating lightweight virtual environments.',undef,],
		'optimus' => ['https://github.com/ironmussa/Optimus','ironmussa','Apache License 2.0',undef,'Cleansing. pre-processing. feature engineering. exploratory data analysis and easy Machine Learning with a PySpark backend.',undef,],
		'unidecode' => ['https://pypi.python.org/pypi/Unidecode',undef,undef,undef,'ASCII transliterations of Unicode text.',undef,],
		'setuptools-git' => ['https://github.com/msabramo/setuptools-git','Marc Abramowitz','BSD License',undef,'Setuptools revision control system plugin for Git',undef,],
		'django-storages' => ['https://github.com/jschneier/django-storages','jschneier',undef,undef,'A collection of custom storage back ends for Django.',undef,],
		'pythonlibs' => ['http://www.lfd.uci.edu/~gohlke/pythonlibs/',undef,undef,undef,'Unofficial Windows binaries for Python extension packages.',undef,],
		'pillow' => ['https://github.com/python-pillow/Pillow','python-pillow','Other',undef,'Pillow is the friendly [PIL](http://www.pythonware.com/products/pil/) fork.',undef,],
		'newrelic_plugin_agent' => ['https://github.com/gmr/newrelic-plugin-agent','Gavin M. Roy','BSD License',undef,'Python based agent for collecting metrics for NewRelic',undef,],
		'johnny-cache' => ['https://github.com/jmoiron/johnny-cache','jmoiron','MIT License',undef,'A caching framework for Django applications.',undef,],
		'pymysql' => ['https://github.com/PyMySQL/PyMySQL/','yutaka.matsubara','MIT License',undef,'Pure Python MySQL Driver',undef,],
		'deform' => ['http://docs.pylonsproject.org/projects/deform',undef,'BSD',undef,'deform is a Python HTML form generation library','library',],
		'pillow' => ['http://python-pillow.org','Alex Clark (Fork Author)','Other/Proprietary License',undef,'Python Imaging Library (Fork)',undef,],
		'jmespath' => ['https://github.com/jmespath/jmespath.py','James Saryerwinnie','MIT License',undef,'JSON Matching Expressions',undef,],
		'path.py' => ['https://github.com/jaraco/path.py','jaraco','MIT License',undef,'A module wrapper for [os.path](https://docs.python.org/3/library/os.path.html).',undef,],
		'demiurge' => ['https://github.com/matiasb/demiurge','matiasb','BSD 3-Clause ""New"" or ""Revised"" License',undef,'PyQuery-based scraping micro-framework.',undef,],
		's4cmd' => ['https://github.com/bloomreach/s4cmd','bloomreach','Apache License 2.0',undef,'Super S3 command line tool. good for higher performance.',undef,],
		'pylibmc' => ['https://github.com/lericson/pylibmc','lericson','BSD 3-Clause ""New"" or ""Revised"" License',undef,'A Python wrapper around the [libmemcached](http://libmemcached.org/libMemcached.html) interface.',undef,],
		'hmap' => ['https://github.com/rossgoodwin/hmap','rossgoodwin','Other',undef,'Image histogram remapping.',undef,],
		'icecream' => ['https://github.com/gruns/icecream','gruns','MIT License',undef,'Inspect variables. expressions. and program execution with a single. simple function call.',undef,],
		'logilab-astng' => ['http://www.logilab.org/project/logilab-astng','Logilab',undef,undef,'rebuild a new abstract syntax tree from Python\'s ast',undef,],
		'asciimatics' => ['https://github.com/peterbrittain/asciimatics','peterbrittain','Apache License 2.0',undef,'A package to create full-screen text UIs (from interactive forms to ASCII animations).',undef,],
		'pylint' => ['https://www.pylint.org/',undef,undef,undef,'A fully customizable source code analyzer.',undef,],
		'box' => ['https://github.com/cdgriffith/Box','cdgriffith','MIT License',undef,'Python dictionaries with advanced dot notation access.',undef,],
		'pyaudioanalysis' => ['https://github.com/tyiannak/pyAudioAnalysis','tyiannak','Apache License 2.0',undef,'Python Audio Analysis Library: Feature Extraction. Classification. Segmentation and Applications',undef,],
		'pickledb' => ['https://pythonhosted.org/pickleDB/',undef,undef,undef,'A simple and lightweight key-value store for Python.',undef,],
		'pip-tools' => ['https://github.com/jazzband/pip-tools','jazzband','Other',undef,'A set of tools to keep your pinned Python dependencies fresh.',undef,],
		'lxml' => ['http://lxml.de/',undef,undef,undef,'A very fast. easy-to-use and versatile library for handling HTML and XML.',undef,],
		'mechanicalsoup' => ['https://github.com/hickford/MechanicalSoup','hickford','MIT License',undef,'A Python library for automating interaction with websites.',undef,],
		'pysolr' => ['https://github.com/django-haystack/pysolr','django-haystack','Other',undef,'A lightweight Python wrapper for Apache Solr (incl. SolrCloud awareness).',undef,],
		'django-appconf' => ['http://django-appconf.readthedocs.org/','Jannis Leidel','BSD License',undef,'A helper class for handling configuration defaults of packaged apps gracefully.',undef,],
		'scikit-video' => ['https://github.com/aizvorski/scikit-video','aizvorski','Other',undef,'Video processing routines for SciPy.',undef,],
		'pipenv' => ['https://github.com/kennethreitz/pipenv','kennethreitz','MIT License',undef,'Sacred Marriage of Pipfile. Pip. & Virtualenv.',undef,],
		'mako' => ['http://www.makotemplates.org/',undef,undef,undef,'Hyperfast and lightweight templating for the Python platform.',undef,],
		'youtube-dl' => ['http://rg3.github.io/youtube-dl/',undef,undef,undef,'A small command-line program to download videos from YouTube.',undef,],
		'pylama' => ['https://github.com/klen/pylama','klen','GNU Lesser General Public License v3.0',undef,'A code audit tool for Python and JavaScript.',undef,],
		'chronyk' => ['https://github.com/KoffeinFlummi/Chronyk','KoffeinFlummi','MIT License',undef,'A Python 3 library for parsing human-written times and dates.',undef,],
		'raven' => ['https://github.com/getsentry/raven-python','getsentry','BSD 3-Clause ""New"" or ""Revised"" License',undef,'Python client for Sentry. a log/error tracking. crash reporting and aggregation platform for web applications.',undef,],
		'toga' => ['https://github.com/pybee/toga','pybee','Other',undef,'A Python native. OS native GUI toolkit.',undef,],
		'sqlalchemy-migrate' => ['http://www.openstack.org/','OpenStack','Apache Software License',undef,'Database schema migration for SQLAlchemy',undef,],
		'threading' => ['https://docs.python.org/3/library/threading.html',undef,undef,undef,'(Python standard library) Higher-level threading interface.',undef,],
		'sandman' => ['https://github.com/jeffknupp/sandman','jeffknupp','Apache License 2.0',undef,'Automated REST APIs for existing database-driven systems.',undef,],
		'zc.buildout' => ['http://buildout.org','Jim Fulton','Zope Public License',undef,'System for managing development buildouts',undef,],
		'delorean' => ['https://github.com/myusuf3/delorean/','myusuf3','MIT License',undef,'A library for clearing up the inconvenient truths that arise dealing with datetimes.',undef,],
		'mongoengine' => ['http://mongoengine.org/',undef,undef,undef,'A Python Object-Document-Mapper for working with MongoDB.',undef,],
		'statsmodels' => ['https://github.com/statsmodels/statsmodels','statsmodels','Other',undef,'Statistical modeling and econometrics in Python.',undef,],
		'conda' => ['https://github.com/conda/conda/','conda','Other',undef,'Cross-platform. Python-agnostic binary package manager.',undef,],
		'dh-virtualenv' => ['https://github.com/spotify/dh-virtualenv','spotify','GNU General Public License v2.0',undef,'Build and distribute a virtualenv as a Debian package.',undef,],
		'pycparser' => ['https://github.com/eliben/pycparser','Eli Bendersky',undef,undef,'C parser in Python',undef,],
		'youcompleteme' => ['https://github.com/Valloric/YouCompleteMe','Valloric','GNU General Public License v3.0',undef,'Includes [Jedi](https://github.com/davidhalter/jedi)-based completion engine for Python.',undef,],
		'paramiko' => ['http://www.paramiko.org/',undef,undef,undef,'A Python (2.6+. 3.3+) implementation of the SSHv2 protocol. providing both client and server functionality.',undef,],
		'traitlets' => ['http://ipython.org','IPython Development Team','BSD License',undef,'Traitlets Python config system',undef,],
		'caffe' => ['https://github.com/BVLC/caffe','BVLC','Other',undef,'A fast open framework for deep learning..',undef,],
		'mrjob' => ['https://github.com/Yelp/mrjob','Yelp','Other',undef,'Run MapReduce jobs on Hadoop or Amazon Web Services.',undef,],
		'grequests' => ['https://github.com/kennethreitz/grequests','kennethreitz','BSD 2-Clause ""Simplified"" License',undef,'requests + gevent for asynchronous HTTP requests.',undef,],
		'botocore' => ['https://github.com/boto/botocore','Amazon Web Services','Apache Software License',undef,'Low-level, data-driven core of boto 3.',undef,],
		'aspen' => ['http://aspen.io/','Gratipay, LLC','MIT License',undef,'Aspen is a Python web framework. Simplates are the main attraction.',undef,],
		'python-memcached' => ['https://github.com/linsomniac/python-memcached','Sean Reifschneider','Python Software Foundation License',undef,'Pure python memcached client',undef,],
		'werkzeug' => ['https://www.palletsprojects.org/p/werkzeug/','Armin Ronacher','BSD License',undef,'The comprehensive WSGI web application library.',undef,],
		'buildout' => ['http://www.buildout.org/en/latest/',undef,undef,undef,'A build system for creating. assembling and deploying applications from multiple parts.',undef,],
		'zipline' => ['https://github.com/quantopian/zipline','quantopian','Apache License 2.0',undef,'A Pythonic algorithmic trading library.',undef,],
		'boto3' => ['https://github.com/boto/boto3','boto','Other',undef,'Python interface to Amazon Web Services.',undef,],
		'python-ldap' => ['https://www.python-ldap.org/','python-ldap project','Python Software Foundation License',undef,'Python modules for implementing LDAP clients',undef,],
		'tzlocal' => ['https://github.com/regebro/tzlocal','Lennart Regebro','MIT License',undef,'tzinfo object for the local timezone',undef,],
		'flask-api' => ['http://www.flaskapi.org/',undef,undef,undef,'Browsable Web APIs for Flask.',undef,],
		'mouse' => ['https://github.com/boppreh/mouse','boppreh','MIT License',undef,'Hook and simulate global mouse events on Windows and Linux.',undef,],
		'python-cjson' => ['https://github.com/AGProjects/python-cjson','Dan Pascu','GNU Library or Lesser General Public License (LGPL)',undef,'Fast JSON encoder/decoder for Python',undef,],
		'flask-wtf' => ['https://github.com/lepture/flask-wtf','Hsiaoming Yang','BSD License',undef,'Simple integration of Flask and WTForms.',undef,],
		'libffm' => ['https://github.com/guestwalk/libffm','guestwalk','Other',undef,'A library for Field-aware Factorization Machine (FFM).',undef,],
		'crossbar' => ['https://github.com/crossbario/crossbar/','crossbario','Other',undef,'Open-source Unified Application Router (Websocket & WAMP for Python on Autobahn).',undef,],
		'pyechonest' => ['https://github.com/echonest/pyechonest','echonest','BSD 3-Clause ""New"" or ""Revised"" License',undef,'Python client for the [Echo Nest](http://static.echonest.com/enspex/) API.',undef,],
		'django-allauth' => ['https://github.com/pennersr/django-allauth','pennersr','MIT License',undef,'Authentication app for Django that ""just works.""',undef,],
		'diskcache' => ['http://www.grantjenks.com/docs/diskcache/',undef,undef,undef,'SQLite and file backed cache backend with faster lookups than memcached and redis.',undef,],
		'docker-py' => ['https://github.com/docker/docker-py/','Joffrey F','Apache Software License',undef,'Python client for Docker.',undef,],
		'python-user-agents' => ['https://github.com/selwin/python-user-agents','selwin','MIT License',undef,'Browser user agent parser.',undef,],
		'scrapy' => ['https://scrapy.org/',undef,'Proprietary',undef,'An open source and collaborative framework for extracting the data you need from websites.','library',],
		'modoboa' => ['https://github.com/modoboa/modoboa','modoboa','ISC License',undef,'A mail hosting and management platform including a modern and simplified Web UI.',undef,],
		'jython' => ['https://hg.python.org/jython',undef,undef,undef,'Implementation of Python programming language written in Java for the Java virtual machine (JVM).',undef,],
		'virtualenv' => ['https://pypi.python.org/pypi/virtualenv',undef,undef,undef,'A tool to create isolated Python environments.',undef,],
		'waitress' => ['http://docs.pylonsproject.org/projects/waitress',undef,'Zope Public License',undef,'Waitress is meant to be a production-quality pure-Python WSGI server with very acceptable performance','WSGI server',],
		'wdb' => ['https://github.com/Kozea/wdb','Kozea','GNU General Public License v3.0',undef,'An improbable web debugger through WebSockets.',undef,],
		'web.py' => ['http://webpy.org/',undef,'free',undef,'web.py is a web framework for Python that is as simple as it is powerful. web.py is in the public domain. You can use it for whatever purpose with absolutely no restrictions.','web framework',],
		'zerorpc' => ['https://github.com/0rpc/zerorpc-python','0rpc','Other',undef,'zerorpc is a flexible RPC implementation based on [ZeroMQ](http://zeromq.org/) and [MessagePack](http://msgpack.org/).',undef,],
		'pynsist' => ['http://pynsist.readthedocs.io/en/latest/',undef,undef,undef,'A tool to build Windows installers. installers bundle Python itself.',undef,],
		'flask-assets' => ['https://github.com/miracle2k/flask-assets','miracle2k','BSD 2-Clause ""Simplified"" License',undef,'Helps you integrate webassets into your Flask app.',undef,],
		'newrelic' => ['http://newrelic.com/docs/python/new-relic-for-python','New Relic','Other/Proprietary License',undef,'New Relic Python Agent',undef,],
		'money' => ['https://github.com/carlospalol/money','carlospalol','MIT License',undef,'Money class with optional CLDR-backed locale-aware formatting and an extensible currency exchange solution.',undef,],
		'blinker' => ['https://github.com/jek/blinker','jek','MIT License',undef,'A fast Python in-process signal/event dispatching system.',undef,],
		'flanker' => ['https://github.com/mailgun/flanker','mailgun','Apache License 2.0',undef,'A email address and Mime parsing library.',undef,],
		'flask' => ['http://flask.pocoo.org/',undef,undef,undef,'A microframework for Python.',undef,],
		'oslo.i18n' => ['https://docs.openstack.org/oslo.i18n/latest','OpenStack','Apache Software License',undef,'Oslo i18n library',undef,],
		'python-swiftclient' => ['https://docs.openstack.org/python-swiftclient/latest/','OpenStack','Apache Software License',undef,'OpenStack Object Storage API Client Library',undef,],
		'vcr.py' => ['https://github.com/kevin1024/vcrpy','kevin1024','MIT License',undef,'Record and replay HTTP interactions on your tests.',undef,],
		'toolz' => ['https://github.com/pytoolz/toolz','pytoolz','Other',undef,'A collection of functional utilities for iterators. functions. and dictionaries.',undef,],
		'iso8601' => ['https://bitbucket.org/micktwomey/pyiso8601','Michael Twomey','MIT License',undef,'Simple module to parse ISO 8601 dates',undef,],
		'lektor' => ['https://www.getlektor.com/',undef,undef,undef,'An easy to use static CMS and blog engine.',undef,],
		'polyglot' => ['https://github.com/aboSamoor/polyglot','aboSamoor','GNU General Public License v3.0',undef,'Natural language pipeline supporting hundreds of languages.',undef,],
		'awesome-mysql' => ['http://shlomi-noach.github.io/awesome-mysql/',undef,undef,undef,'[awesome-mysql](http://shlomi-noach.github.io/awesome-mysql/)',undef,],
		'kube-shell' => ['https://github.com/cloudnativelabs/kube-shell','cloudnativelabs','Apache License 2.0',undef,'An integrated shell for working with the Kubernetes CLI.',undef,],
		'unittest' => ['https://docs.python.org/3/library/unittest.html',undef,undef,undef,'(Python standard library) Unit testing framework.',undef,],
		'uniout' => ['https://github.com/moskytw/uniout','moskytw','MIT License',undef,'Print readable chars instead of the escaped string.',undef,],
		'grok' => ['http://grok.zope.org/',undef,'Zope Public License',undef,'Grok is a web application framework for Python developers. It is aimed at both beginners and very experienced web developers. Grok has an emphasis on agile development. Grok is easy and powerful.','web framework',],
		'jsonschema' => ['https://github.com/Julian/jsonschema','Julian','MIT License',undef,'An implementation of [JSON Schema](http://json-schema.org/) for Python.',undef,],
		'flask-restful' => ['https://github.com/flask-restful/flask-restful','flask-restful','BSD 3-Clause ""New"" or ""Revised"" License',undef,'Quickly building REST APIs for Flask.',undef,],
		'contextlib2' => ['http://contextlib2.readthedocs.org','Nick Coghlan','Python Software Foundation License',undef,'Backports and enhancements for the contextlib module',undef,],
		'pypdf2' => ['https://github.com/mstamy2/PyPDF2','mstamy2','Other',undef,'A library capable of splitting. merging and transforming PDF pages.',undef,],
		'peewee' => ['https://github.com/coleifer/peewee','coleifer','MIT License',undef,'A small. expressive ORM.',undef,],
		'beaker' => ['https://beaker.readthedocs.io/','Ben Bangert, Mike Bayer, Philip Jenvey, Alessandro Molina','BSD License',undef,'A Session and Caching library with WSGI Middleware',undef,],
		'leaderboard' => ['https://github.com/agoragames/leaderboard-python','David Czarnecki','MIT License',undef,'Leaderboards backed by Redis in Python',undef,],
		'fapws3' => ['http://www.fapws.org/',undef,undef,undef,'Asynchronous (network side only). written in C.',undef,],
		'streamparse' => ['https://github.com/Parsely/streamparse','Parsely','Other',undef,'Run Python code against real-time streams of data. Integrates with [Apache Storm](http://storm.apache.org/).',undef,],
		'warehouse' => ['https://github.com/pypa/warehouse','pypa','Apache License 2.0',undef,'Next generation Python Package Repository (PyPI).',undef,],
		'pycharm' => ['https://www.jetbrains.com/pycharm/',undef,undef,undef,'Commercial Python IDE by JetBrains. Has free community edition available.',undef,],
		'glob2' => ['http://github.com/miracle2k/python-glob2/','Michael Elsdoerfer','BSD License',undef,'Version of the glob module that can capture patterns and supports recursive wildcards',undef,],
		'difflib' => ['https://docs.python.org/3/library/difflib.html',undef,undef,undef,'(Python standard library) Helpers for computing deltas.',undef,],
		'django-remote-forms' => ['https://github.com/WiserTogether/django-remote-forms','WiserTogether','MIT License',undef,'A platform independent Django form serializer.',undef,],
		'pendulum' => ['https://github.com/sdispater/pendulum','sdispater','MIT License',undef,'Python datetimes made easy.',undef,],
		'pyqtgraph' => ['http://www.pyqtgraph.org/',undef,undef,undef,'Interactive and realtime 2D/3D/Image plotting and science/engineering widgets.',undef,],
		'requests-oauthlib' => ['https://github.com/requests/requests-oauthlib','Kenneth Reitz','BSD License',undef,'OAuthlib authentication support for Requests.',undef,],
		'mozlog' => ['https://wiki.mozilla.org/Auto-tools/Projects/Mozbase','Mozilla Automation and Testing Team','Mozilla Public License 1.1 (MPL 1.1)',undef,'Robust log handling specialized for logging in the Mozilla universe',undef,],
		'python-patterns' => ['https://github.com/faif/python-patterns','faif',undef,undef,'A collection of design patterns in Python.',undef,],
		'kivy' => ['https://kivy.org/',undef,undef,undef,'A library for creating NUI applications. running on Windows. Linux. Mac OS X. Android and iOS.',undef,],
		'backports_abc' => ['https://github.com/cython/backports_abc','Stefan Behnel et al.','Python Software Foundation License',undef,'A backport of recent additions to the \'collections.abc\' module.',undef,],
		'clint' => ['https://github.com/kennethreitz/clint','kennethreitz','ISC License',undef,'Python Command-line Application Tools.',undef,],
		'python-modernize' => ['https://github.com/mitsuhiko/python-modernize','mitsuhiko','Other',undef,'Modernizes Python code for eventual Python 3 migration.',undef,],
		'marmir' => ['https://github.com/brianray/mm','brianray',undef,undef,'Takes Python data structures and turns them into spreadsheets.',undef,],
		'textblob' => ['https://github.com/sloria/TextBlob','sloria','MIT License',undef,'Providing a consistent API for diving into common NLP tasks.',undef,],
		'statsd' => ['https://github.com/jsocol/pystatsd','James Socol','MIT License',undef,'A simple statsd client.',undef,],
		'demjson' => ['http://deron.meranda.us/python/demjson/','Deron Meranda','GNU Library or Lesser General Public License (LGPL)',undef,'encoder, decoder, and lint/validator for JSON (JavaScript Object Notation) compliant with RFC 7159',undef,],
		'unittest2' => ['http://pypi.python.org/pypi/unittest2','Robert Collins','BSD License',undef,'The new features in unittest backported to Python 2.4+.',undef,],
		'code2flow' => ['https://github.com/scottrogowski/code2flow','scottrogowski','GNU Lesser General Public License v3.0',undef,'Turn your Python and JavaScript code into DOT flowcharts.',undef,],
		'python-decouple' => ['https://github.com/henriquebastos/python-decouple','henriquebastos','MIT License',undef,'Strict separation of settings from code.',undef,],
		'cloud-init' => ['http://cloudinit.readthedocs.io/en/latest/',undef,undef,undef,'A multi-distribution package that handles early initialization of a cloud instance.',undef,],
		'decorator' => ['https://github.com/micheles/decorator','Michele Simionato','BSD License',undef,'Better living through Python with decorators',undef,],
		'python-pptx' => ['https://github.com/scanny/python-pptx','scanny','MIT License',undef,'Python library for creating and updating PowerPoint (.pptx) files.',undef,],
		'urllib3' => ['https://github.com/shazow/urllib3','shazow','Other',undef,'A HTTP library with thread-safe connection pooling. file post support. sanity friendly.',undef,],
		'sphinx' => ['http://sphinx-doc.org/','Georg Brandl','BSD License',undef,'Python documentation generator',undef,],
		'open babel' => ['http://openbabel.org/wiki/Main_Page',undef,undef,undef,'A chemical toolbox designed to speak the many languages of chemical data.',undef,],
		'passlib' => ['https://pythonhosted.org/passlib/',undef,undef,undef,'Secure password storage/hashing library. very high level.',undef,],
		'awscli-cwlogs' => ['http://aws.amazon.com/cli/','Amazon','Other/Proprietary License',undef,'AWSCLI CloudWatch Logs plugin',undef,],
		'parse' => ['https://github.com/r1chardj0n3s/parse','Richard Jones','BSD License',undef,'parse() is the opposite of format()',undef,],
		'oslosphinx' => ['http://docs.openstack.org/developer/oslosphinx','OpenStack','Apache Software License',undef,'OpenStack Sphinx Extensions and Theme',undef,],
		'opps' => ['http://opps.github.io/opps/',undef,undef,undef,'A Django-based CMS for magazines. newspapers websites and portals with high-traffic.',undef,],
		'whoosh' => ['http://whoosh.readthedocs.io/en/latest/',undef,undef,undef,'A fast. pure Python search engine library.',undef,],
		'obspy' => ['https://github.com/obspy/obspy/wiki/','obspy','Other',undef,'A Python toolbox for seismology.',undef,],
		'turbogears' => ['http://turbogears.readthedocs.io',undef,'Open source',undef,'TurboGears is a Python web framework based on the ObjectDispatch paradigm, it is meant to make possible to write both small and concise applications in Minimal mode or complex application in Full Stack mode.','web framework',],
		'cocos2d' => ['http://cocos2d.org/',undef,undef,undef,'cocos2d is a framework for building 2D games. demos. and other graphical/interactive applications. It is based on pyglet.',undef,],
		'cytoolz' => ['https://github.com/pytoolz/cytoolz/','pytoolz','Other',undef,'Cython implementation of Toolz: High performance functional utilities.',undef,],
		'ua-parser' => ['https://github.com/ua-parser/uap-python','PBS','Apache Software License',undef,'Python port of Browserscope\'s user agent parser',undef,],
		'django-taggit' => ['https://github.com/alex/django-taggit','alex','Other',undef,'Simple tagging for Django.',undef,],
		'markupsafe' => ['https://github.com/pallets/markupsafe','pallets','Other',undef,'Implements a XML/HTML/XHTML Markup safe string for Python.',undef,],
		'pycuda' => ['https://mathema.tician.de/software/pycuda/',undef,undef,undef,'A Python wrapper for Nvidias CUDA API.',undef,],
		'joblib' => ['http://pythonhosted.org/joblib/index.html',undef,undef,undef,'A set of tools to provide lightweight pipelining in Python.',undef,],
		'pynacl' => ['https://github.com/pyca/pynacl','pyca','Apache License 2.0',undef,'Python binding to the Networking and Cryptography (NaCl) library.',undef,],
		'pysec' => ['https://github.com/ebranca/owasp-pysec','ebranca','Apache License 2.0',undef,'Hardened version of python that makes it easier for security professionals and developers to write applications more resilient to attacks and manipulations.',undef,],
		'doitlive' => ['https://github.com/sloria/doitlive','sloria','MIT License',undef,'A tool for live presentations in the terminal.',undef,],
		'pypinyin' => ['https://github.com/mozillazg/python-pinyin','mozillazg','MIT License',undef,'Convert Chinese hanzi to pinyin.',undef,],
		'south' => ['http://south.aeracode.org/','Andrew Godwin & Andy McCurdy','Apache Software License',undef,'South: Migrations for Django',undef,],
		'logilab-common' => ['http://www.logilab.org/project/logilab-common','Logilab',undef,undef,'collection of low-level Python packages and modules used by Logilab projects',undef,],
		'babel' => ['http://babel.pocoo.org/en/latest/',undef,undef,undef,'An internationalization library for Python.',undef,],
		'rsa' => ['https://stuvel.eu/rsa','Sybren A. Stuvel','Apache Software License',undef,'Pure-Python RSA implementation',undef,],
		'coala' => ['http://coala.io/',undef,undef,undef,'Language independent and easily extendable code analysis application.',undef,],
		'rfc3986' => ['http://rfc3986.readthedocs.io','Ian Cordasco','Apache Software License',undef,'Validating URI References per RFC 3986',undef,],
		'netifaces' => ['https://github.com/al45tair/netifaces','Alastair Houghton','MIT License',undef,'Portable network interface information.',undef,],
		'mozprocess' => ['https://wiki.mozilla.org/Auto-tools/Projects/Mozbase','Mozilla Automation and Tools team','Mozilla Public License 2.0 (MPL 2.0)',undef,'Mozilla-authored process handling',undef,],
		'python-nameparser' => ['https://github.com/derek73/python-nameparser','derek73','Other',undef,'Parsing human names into their individual components.',undef,],
		'django_compressor' => ['https://django-compressor.readthedocs.io/en/latest/','Jannis Leidel','MIT License',undef,'Compresses linked and inline JavaScript or CSS into single cached files.',undef,],
		'django-haystack' => ['https://github.com/django-haystack/django-haystack','django-haystack','Other',undef,'Modular search for Django.',undef,],
		'mimetypes' => ['https://docs.python.org/3/library/mimetypes.html',undef,undef,undef,'(Python standard library) Map filenames to MIME types.',undef,],
		'django-socketio' => ['https://github.com/stephenmcd/django-socketio','stephenmcd','BSD 2-Clause ""Simplified"" License',undef,'WebSockets for Django.',undef,],
		'pymssql' => ['http://www.pymssql.org/en/latest/',undef,undef,undef,'A simple database interface to Microsoft SQL Server.',undef,],
		'pyquery' => ['https://github.com/gawel/pyquery','gawel','Other',undef,'A jQuery-like library for parsing HTML.',undef,],
		'pypy' => ['https://bitbucket.org/pypy/pypy',undef,undef,undef,'Implementation of the Python programming language written in RPython and translated into C. PyPy focuses on speed. efficiency and compatibility with the original CPython interpreter. The interpreter uses black magic to make Python very fast without having to add in additional type information.',undef,],
		'wincertstore' => ['https://bitbucket.org/tiran/wincertstore','Christian Heimes','Python Software Foundation License',undef,'Python module to extract CA and CRL certs from Windows\' cert store (ctypes based).',undef,],
		'dj-database-url' => ['https://github.com/kennethreitz/dj-database-url','Kenneth Reitz','BSD License',undef,'Use Database URLs in your Django Application.',undef,],
		'scikit-learn' => ['http://scikit-learn.org/',undef,undef,undef,'The most popular Python library for Machine Learning.',undef,],
		'sh' => ['https://github.com/amoffat/sh','amoffat','MIT License',undef,'A full-fledged subprocess replacement for Python.',undef,],
		'snowballstemmer' => ['https://github.com/shibukawa/snowball_py','Yoshiki Shibukawa','BSD License',undef,'This package provides 16 stemmer algorithms (15 + Poerter English stemmer) generated from Snowball algorithms.',undef,],
		'pip' => ['https://pip.pypa.io/en/stable/',undef,undef,undef,'The Python package and dependency manager.',undef,],
		'snownlp' => ['https://github.com/isnowfy/snownlp','isnowfy','MIT License',undef,'A library for processing Chinese text.',undef,],
		'carbon' => ['http://graphiteapp.org/','Chris Davis','Apache Software License',undef,'Backend data caching and persistence daemon for Graphite',undef,],
		'ordereddict' => ['UNKNOWN','Raymond Hettinger','MIT License',undef,'A drop-in substitute for Py2.7\'s new collections.OrderedDict that works in Python 2.4-2.6.',undef,],
		'alipay' => ['https://github.com/lxneng/alipay','lxneng',undef,undef,'Unofficial Alipay API for Python.',undef,],
		'serpent.ai' => ['https://github.com/SerpentAI/SerpentAI','SerpentAI','MIT License',undef,'Game agent framework. Use any video game as a deep learning sandbox.',undef,],
		'tablib' => ['https://github.com/kennethreitz/tablib','kennethreitz','MIT License',undef,'A module for Tabular Datasets in XLS. CSV. JSON. YAML.',undef,],
		'pyston' => ['https://github.com/dropbox/pyston','dropbox','Other',undef,'A Python implementation built using LLVM and modern JIT techniques with the goal of achieving good performance.',undef,],
		'eliot' => ['https://github.com/ScatterHQ/eliot','ScatterHQ','Apache License 2.0',undef,'Logging for complex & distributed systems.',undef,],
		'python-qrcode' => ['https://github.com/lincolnloop/python-qrcode','lincolnloop','Other',undef,'A pure Python QR Code generator.',undef,],
		'stackless python' => ['https://bitbucket.org/stackless-dev/stackless/wiki/Home',undef,undef,undef,'An enhanced version of the Python programming language which allows programmers to reap the benefits of thread-based programming without the performance and complexity problems associated with conventional threads.',undef,],
		'yagmail' => ['https://github.com/kootenpv/yagmail','kootenpv','MIT License',undef,'Yet another Gmail/SMTP client.',undef,],
		'manifestparser' => ['https://wiki.mozilla.org/Auto-tools/Projects/Mozbase','Mozilla Automation and Testing Team',undef,undef,'Library to create and manage test manifests',undef,],
		'django-oauth-toolkit' => ['https://github.com/evonove/django-oauth-toolkit','evonove','Other',undef,'OAuth 2 goodies for Django.',undef,],
		'pycups' => ['http://cyberelk.net/tim/software/pycups/','Tim Waugh','GNU General Public License (GPL)',undef,'Python bindings for libcups',undef,],
		'simpleq' => ['https://github.com/rdegges/simpleq','rdegges',undef,undef,'A simple. infinitely scalable. Amazon SQS based queue.',undef,],
		'flask-login' => ['https://github.com/maxcountryman/flask-login','Matthew Frazier','MIT License',undef,'User session management for Flask',undef,],
		'django-rules' => ['https://github.com/dfunckt/django-rules','dfunckt','MIT License',undef,'A tiny but powerful app providing object-level permissions to Django. without requiring a database.',undef,],
		'unicodecsv' => ['https://github.com/jdunck/python-unicodecsv','Jeremy Dunck','BSD License',undef,'Python2\'s stdlib csv module is nice, but it doesn\'t support unicode. This module is a drop-in replacement which *does*.',undef,],
		'django-crispy-forms' => ['https://github.com/django-crispy-forms/django-crispy-forms','django-crispy-forms','MIT License',undef,'A Django app which lets you create beautiful forms in a very elegant and DRY way.',undef,],
		'sqlparse' => ['https://github.com/andialbrecht/sqlparse','andialbrecht','BSD 3-Clause ""New"" or ""Revised"" License',undef,'A non-validating SQL parser.',undef,],
		'colour' => ['http://colour-science.org/',undef,undef,undef,'A colour science package implementing a comprehensive number of colour theory transformations and algorithms.',undef,],
		'pyogre' => ['http://www.ogre3d.org/tikiwiki/PyOgre',undef,undef,undef,'Python bindings for the Ogre 3D render engine. can be used for games. simulations. anything 3D.',undef,],
		'wagtail' => ['https://wagtail.io/',undef,undef,undef,'A Django content management system.',undef,],
		'backports.ssl_match_hostname' => ['http://bitbucket.org/brandon/backports.ssl_match_hostname','Brandon Craig Rhodes','Python Software Foundation License',undef,'The ssl.match_hostname() function from Python 3.5',undef,],
		'httmock' => ['https://github.com/patrys/httmock','patrys','Other',undef,'A mocking library for requests for Python 2.6+ and 3.2+.',undef,],
		'profiling' => ['https://github.com/what-studio/profiling','what-studio','BSD 3-Clause ""New"" or ""Revised"" License',undef,'An interactive Python profiler.',undef,],
		'tinydb' => ['https://github.com/msiemens/tinydb','msiemens','MIT License',undef,'A tiny. document-oriented database.',undef,],
		'oslo.serialization' => ['http://docs.openstack.org/developer/oslo.serialization/','OpenStack','Apache Software License',undef,'Oslo Serialization library',undef,],
		'colorama' => ['https://pypi.python.org/pypi/colorama',undef,undef,undef,'Cross-platform colored terminal text.',undef,],
		'pycallgraph' => ['https://github.com/gak/pycallgraph','gak','GNU General Public License v2.0',undef,'A library that visualises the flow (call graph) of your Python application.',undef,],
		'keyboard' => ['https://github.com/boppreh/keyboard','boppreh','MIT License',undef,'Hook and simulate global keyboard events on Windows and Linux.',undef,],
		'cliff' => ['https://docs.openstack.org/developer/cliff/',undef,undef,undef,'A framework for creating command-line programs with multi-level commands.',undef,],
		'pypattyrn' => ['https://github.com/tylerlaberge/PyPattyrn','tylerlaberge','MIT License',undef,'A simple yet effective library for implementing common design patterns.',undef,],
		'substanced' => ['http://www.substanced.net/',undef,'BSD',undef,'Substance D is an application server built using the Pyramid web framework. It can be used as a base to build a general-purpose web application like a blog, a shopping cart application, a scheduling application, or any other web app that requires both an administration and a retail interface.','web framework',],
		'html5lib' => ['https://github.com/html5lib/html5lib-python','html5lib','MIT License',undef,'A standards-compliant library for parsing and serializing HTML documents and fragments.',undef,],
		'requests' => ['http://docs.python-requests.org/en/latest/',undef,undef,undef,'HTTP Requests for Humans™.',undef,],
		'dataset' => ['https://github.com/pudo/dataset','pudo','MIT License',undef,'A JSON-based database.',undef,],
		'jose' => ['https://github.com/demonware/jose','demonware','BSD 3-Clause ""New"" or ""Revised"" License',undef,'JavaScript Object Signing and Encryption draft implementation.',undef,],
		'oauth2client' => ['http://github.com/google/oauth2client/','Google Inc.','Apache Software License',undef,'OAuth 2.0 client library',undef,],
		'pycadf' => ['https://docs.openstack.org/pycadf/latest/','OpenStack','Apache Software License',undef,'CADF Library',undef,],
		'bandersnatch' => ['https://bitbucket.org/pypa/bandersnatch',undef,undef,undef,'PyPI mirroring tool provided by Python Packaging Authority (PyPA).',undef,],
		'stream-framework' => ['https://github.com/tschellenbach/Stream-Framework','tschellenbach','Other',undef,'Building newsfeed and notification systems using Cassandra and Redis.',undef,],
		'gooey' => ['https://github.com/chriskiehl/Gooey','chriskiehl','MIT License',undef,'Turn command line programs into a full GUI application with one line',undef,],
		'meinheld' => ['https://pypi.python.org/pypi/meinheld',undef,undef,undef,'Asynchronous. partly written in C.',undef,],
		'ipython' => ['https://ipython.org','The IPython Development Team','BSD License',undef,'IPython: Productive Interactive Computing',undef,],
		'py2exe' => ['http://www.py2exe.org/',undef,undef,undef,'Freezes Python scripts (Windows).',undef,],
		'django-guardian' => ['https://github.com/django-guardian/django-guardian','django-guardian','Other',undef,'Implementation of per object permissions for Django 1.2+',undef,],
		'annoy' => ['https://github.com/spotify/annoy','spotify','Apache License 2.0',undef,'Approximate Nearest Neighbors in C++/Python optimized for memory usage.',undef,],
		'pytest-cov' => ['https://github.com/pytest-dev/pytest-cov','Marc Schlaich','BSD License',undef,'Pytest plugin for measuring coverage.',undef,],
		'python-magic' => ['https://github.com/ahupp/python-magic','ahupp','MIT License',undef,'A Python interface to the libmagic file type identification library.',undef,],
		'bqplot' => ['https://github.com/bloomberg/bqplot','bloomberg','Apache License 2.0',undef,'Interactive Plotting Library for the Jupyter Notebook',undef,],
	},

	'CCpp' => {
		'qt' => ['https://www.qt.io/download/',undef,'LGPL',undef,'Qt is a comprehensive cross-platform framework and set of development tools that helps you create and build applications and user interfaces for devices.','Application development',],
		'boost' => ['http://www.boost.org/',undef,'Boost Software License','http://www.boost.org/LICENSE_1_0.txt','Boost provides free peer-reviewed portable C++ source libraries.','Application framework',],
		'wxwidgets' => ['https://www.wxwidgets.org/',undef,undef,undef,'wxWidgets is a C++ library that lets developers create applications for Windows, Mac OS X, Linux and other platforms with a single code base. It has popular language bindings for Python, Perl, Ruby and many other languages, and unlike other cross-platform toolkits, wxWidgets gives applications a truly native look and feel because it uses the platform\'s native API rather than emulating the GUI. It\'s also extensive, free, open-source and mature.','UI framework',],
		'stl' => [undef,undef,undef,undef,'The STL provides a ready-made set of common classes for C++, such as containers and associative arrays, that can be used with any built-in type and with any user-defined type that supports some elementary operations (such as copying and assignment). STL algorithms are independent of containers, which significantly reduces the complexity of the library.','API framework',],
		'cppcms' => ['http://cppcms.com/',undef,'LGPL',undef,'CppCMS is a Free High Performance Web Development Framework (not a CMS) aimed at Rapid Web Application Development','Rapid Application Development',],
		'gtkmm' => ['http://www.gtkmm.org/en/',undef,'LGPL',undef,'gtkmm (formerly known as gtk-- or gtk minus minus) is the official C++ interface for the popular GUI library GTK+. gtkmm allows the creation of user interfaces either in code or with the Glade Interface Designer, using the Gtk::Builder class. Other features include typesafe callbacks, a comprehensive set of graphical control elements, and the extensibility of widgets via inheritance.','UI framework',],
		'reason' => ['http://www.reasoning.biz/',undef,'GPL','http://www.gnu.org/licenses/gpl-2.0.html','Reason is a cross platform framework designed to bring the ease of use of Java, Net, or Python to developers who require the performance and strength of C++.','Application development',],
		'fltk' => ['http://www.fltk.org/',undef,'LGPL','http://www.fltk.org/COPYING.php','FLTK (pronounced ""fulltick"") is a cross-platform C++ GUI toolkit for UNIX�/Linux� (X11), Microsoft� Windows�, and MacOS� X. FLTK provides modern GUI functionality without the bloat and supports 3D graphics via OpenGL� and its built-in GLUT emulation','UI framework',],
		'kde' => ['https://www.openhub.net/p/kdelibs',undef,'LGPL',undef,'KDElibs is a set of libraries that provide frameworks and features for software developers that integrates with the KDE environment.','Application development',],
		'directx' => ['https://msdn.microsoft.com/fr-fr/library/windows/desktop/dn643743(v=vs.85).aspx',undef,'Proprietary',undef,'Slew of application programming interfaces (API) it uses for multimedia and video applications','Graphic and Gaming framework',],
		'poco' => ['http://pocoproject.org/',undef,undef,undef,'Modern, powerful open source C++ class libraries for building network- and internet-based applications that run on desktop, server, mobile and embedded systems.','Web & Mobile applications',],
		'platinum' => ['http://www.pt-framework.org/',undef,'LGPL',undef,'Platinum (Pt) is a comprehensive C++ framework, which allows developers to write high-performance applications for many platforms with only one codebase. It provides a large amount of features and is still very easy to use. It intergrates well into existing toolkits and frameworks.','Application development',],
		'juce' => ['http://www.juce.com/',undef,'GPL',undef,'JUCE is a C++ cross-platform framework built for speed','Application framework',],
		'sdl' => ['https://www.libsdl.org/',undef,'zlib','http://www.gzip.org/zlib/zlib_license.html','Simple DirectMedia Layer is a cross-platform development library designed to provide low level access to audio, keyboard, mouse, joystick, and graphics hardware via OpenGL and Direct3D.','Graphic and Gaming framework',],
		'gtk' => ['http://www.gtk.org/',undef,'LGPL',undef,'GTK+, or the GIMP Toolkit, is a multi-platform toolkit for creating graphical user interfaces. Offering a complete set of widgets, GTK+ is suitable for projects ranging from small one-off tools to complete application suites.','UI framework',],
		'gnome' => ['https://www.gnome.org/',undef,'GPL',undef,'Gnome is perhaps distinguished by having a C API (GTK+)','API framework',],
		'wt' => ['http://www.webtoolkit.eu/wt',undef,'GPL',undef,'Wt (pronounced as witty) is a C++ library for developing web applications','Web Applications',],
		'cegui' => ['http://cegui.org.uk/',undef,'MIT',undef,'Crazy Eddie\'s GUI System is a free library providing windowing and widgets for graphics APIs / engines ','UI framework',],
		'ultimate++' => ['http://www.ultimatepp.org/',undef,'BSD',undef,'U++ is a C++ cross-platform rapid application development framework focused on programmers productivity. It includes a set of libraries (GUI, SQL, etc..), and an integrated development environment.','Application development',],
		'mfc' => [undef,undef,undef,undef,'The Microsoft Foundation Class (MFC) Library is a collection of�class�es (generalized definitions used in�object-oriented programming�) that can be used in building�application program�s.�','Application development',],
		'opengl' => ['https://www.opengl.org',undef,'OpenGL�',undef,'OpenGL is the premier environment for developing portable, interactive 2D and 3D graphics applications. ','Graphic and Gaming framework',],
		'tntnet' => ['http://www.tntnet.org/',undef,'LGPL',undef,'Tntnet is a web server which allows users to develop web applications using C++. It has a template language�ecpp�where C++ code can be embedded into html similar to php or jsp. The pages are compiled and linked into a shared library. The result is a native web application which is compact and fast.','Web Applications',],
	},

	'PHP' => {
		'doctrineextensions' => [undef,'Benjamin Eberlei','BSD-3-Clause',undef,'A set of extensions to Doctrine 2 that add support for additional query functions available in MySQL and Oracle.',undef,],
		'twig-bundle' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony TwigBundle',undef,],
		'form' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony Form Component',undef,],
		'silverstripe' => ['https://www.silverstripe.org/','SilverStripe','BSD',undef,'SilverStripe Platform lets you reinvent customer engagement across every digital device. We create online experiences that propel businesses ahead. Our development and infrastructure expertise combined with SilverStripe open source software produce successful digital projects from launch and beyond!','CMS',],
		'framework-bundle' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony FrameworkBundle',undef,],
		'event-manager' => ['https://www.doctrine-project.org/projects/event-manager.html','Roman Borschel','MIT',undef,'Doctrine Event Manager component',undef,],
		'pipeline' => ['https://laravel.com','Taylor Otwell','MIT',undef,'The Illuminate Pipeline package.',undef,],
		'flysystem-aws-s3-v3' => [undef,'Frank de Jonge','MIT',undef,'Flysystem adapter for the AWS S3 SDK v3.x',undef,],
		'doctrine-migrations-bundle' => ['http://www.doctrine-project.org','Symfony Community','MIT',undef,'Symfony DoctrineMigrationsBundle',undef,],
		'fpdi' => ['https://www.setasign.com/fpdi','Jan Slabon','MIT',undef,'FPDI is a collection of PHP classes facilitating developers to read pages from existing PDF documents and use them as templates in FPDF. Because it is also possible to use FPDI with TCPDF, there are no fixed dependencies defined. Please see suggestions for packages which evaluates the dependencies automatically.',undef,],
		'collision' => [undef,'Nuno Maduro','MIT',undef,'Cli error handling for console/command-line PHP applications.',undef,],
		'object-reflector' => ['https://github.com/sebastianbergmann/object-reflector/','Sebastian Bergmann','BSD-3-Clause',undef,'Allows reflection of object attributes, including inherited and non-public ones',undef,],
		'web-profiler-bundle' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony WebProfilerBundle',undef,],
		'polyfill-intl-icu' => ['https://symfony.com','Nicolas Grekas','MIT',undef,'Symfony polyfill for intl\'s ICU-related data and classes',undef,],
		'discovery' => ['http://php-http.org','Márk Sági-Kazár','MIT',undef,'Finds installed HTTPlug implementations and PSR-7 message factories',undef,],
		'monolog' => ['http://github.com/Seldaek/monolog','Jordi Boggiano','MIT',undef,'Sends your logs to files, sockets, inboxes, databases and various web services',undef,],
		'phpseclib' => ['http://phpseclib.sourceforge.net','Jim Wigginton','MIT',undef,'PHP Secure Communications Library - Pure-PHP implementations of RSA, AES, SSH2, SFTP, X.509 etc.',undef,],
		'jsrouting-bundle' => ['http://friendsofsymfony.github.com','FriendsOfSymfony Community','MIT',undef,'A pretty nice way to expose your Symfony2 routing to client applications.',undef,],
		'tokenizer' => [undef,'Arne Blankerts','BSD-3-Clause',undef,'A small library for converting tokenized PHP source code into XML and potentially other formats',undef,],
		'php-parser' => [undef,'Nikita Popov','BSD-3-Clause',undef,'A PHP parser written in PHP',undef,],
		'type-resolver' => [undef,'Mike van Riel','MIT',undef,'A PSR-5 based resolver of Class names, Types and Structural Element Names',undef,],
		'php-encryption' => [undef,'Taylor Hornby','MIT',undef,'Secure PHP Encryption Library',undef,],
		'security-acl' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony Security Component - ACL (Access Control List)',undef,],
		'doctrine-cache-bundle' => ['http://www.doctrine-project.org','Symfony Community','MIT',undef,'Symfony Bundle for Doctrine Cache',undef,],
		'finder' => ['https://nette.org','David Grudl','BSD-3-Clause',undef,'🔍 Nette Finder: find files and directories with an intuitive API.',undef,],
		'predis' => ['http://github.com/nrk/predis','Daniele Alessandri','MIT',undef,'Flexible and feature-complete Redis client for PHP and HHVM',undef,],
		'yii2-composer' => [undef,'Qiang Xue','BSD-3-Clause',undef,'The composer plugin for Yii extension installer',undef,],
		'oauth2-client' => [undef,'Alex Bilbie','MIT',undef,'OAuth 2.0 Client Library',undef,],
		'php-css-parser' => ['http://www.sabberworm.com/blog/2010/6/10/php-css-parser','Raphael Schweikert','MIT',undef,'Parser for CSS Files written in PHP',undef,],
		'imagine' => ['http://imagine.readthedocs.org/','Bulat Shakirzyanov','MIT',undef,'Image processing for PHP 5.3',undef,],
		'htmlpurifier' => ['http://htmlpurifier.org/','Edward Z. Yang','LGPL-2.1-or-later',undef,'Standards compliant HTML filter written in PHP',undef,],
		'version' => [undef,'Arne Blankerts','BSD-3-Clause',undef,'Library for handling version information and constraints',undef,],
		'encryption' => ['https://laravel.com','Taylor Otwell','MIT',undef,'The Illuminate Encryption package.',undef,],
		'jwt-auth' => ['https://github.com/tymondesigns/jwt-auth','Sean Tymon','MIT',undef,'JSON Web Token Authentication for Laravel and Lumen',undef,],
		'utils' => ['https://nette.org','David Grudl','BSD-3-Clause',undef,'🛠 Nette Utils: lightweight utilities for string & array manipulation, image handling, safe JSON encoding/decoding, validation, slug or strong password generating etc.',undef,],
		'common' => ['https://www.doctrine-project.org','Roman Borschel','MIT',undef,'Common Library for Doctrine projects',undef,],
		'jwt' => [undef,'Luís Cobucci','BSD-3-Clause',undef,'A simple library to work with JSON Web Token and JSON Web Signature',undef,],
		'swiftmailer' => ['https://swiftmailer.symfony.com','Chris Corbyn','MIT',undef,'Swiftmailer, free feature-rich PHP mailer',undef,],
		'utf8' => ['https://github.com/tchwork/utf8','Nicolas Grekas','(Apache-2.0 or GPL-2.0)',undef,'Portable and performant UTF-8, Unicode and Grapheme Clusters for PHP',undef,],
		'image' => ['http://image.intervention.io/','Oliver Vogel','MIT',undef,'Image handling and manipulation library with support for Laravel integration',undef,],
		'doctrine-bundle' => ['http://www.doctrine-project.org','Symfony Community','MIT',undef,'Symfony DoctrineBundle',undef,],
		'easyrdf' => ['http://www.easyrdf.org/','Nicholas Humfrey','BSD-3-Clause',undef,'EasyRdf is a PHP library designed to make it easy to consume and produce RDF.',undef,],
		'prado' => ['http://www.pradoframework.net/','PRADO Ggroup','BSD',undef,'PRADO is a component-based and event-driven programming framework for developing Web applications in PHP 5. PRADO stands for PHP Rapid Application Development Object-oriented.','Rapid Application Development',],
		'knp-snappy-bundle' => ['http://github.com/KnpLabs/KnpSnappyBundle','KnpLabs Team','MIT',undef,'Easily create PDF and images in Symfony2 by converting Twig/HTML templates.',undef,],
		'classpreloader' => [undef,'Michael Dowling','MIT',undef,'Helps class loading performance by generating a single PHP file containing all of the autoloaded files for a specific use case',undef,],
		'uri-template' => [undef,'Marut K','MIT',undef,'PHP URI Template (RFC 6570) supports both expansion & extraction',undef,],
		'braintree_php' => [undef,'Braintree','MIT',undef,'Braintree PHP Client Library',undef,],
		'swiftmailer-bundle' => ['http://symfony.com','Symfony Community','MIT',undef,'Symfony SwiftmailerBundle',undef,],
		'http' => ['https://laravel.com','Taylor Otwell','MIT',undef,'The Illuminate Http package.',undef,],
		'path-util' => [undef,'Bernhard Schussek','MIT',undef,'A robust cross-platform utility for normalizing, comparing and modifying file paths.',undef,],
		'sdk' => ['http://github.com/twilio/twilio-php','Twilio API Team','MIT',undef,'A PHP wrapper for Twilio\'s API',undef,],
		'jsonlint' => [undef,'Jordi Boggiano','MIT',undef,'JSON Linter',undef,],
		'hashids' => ['http://hashids.org/php','Ivan Akimov','MIT',undef,'Generate short, unique, non-sequential ids (like YouTube and Bitly) from numbers',undef,],
		'serializer-bundle' => ['http://jmsyst.com/bundles/JMSSerializerBundle','Asmir Mustafic','MIT',undef,'Allows you to easily serialize, and deserialize data of any complexity',undef,],
		'ca-bundle' => [undef,'Jordi Boggiano','MIT',undef,'Lets you find a path to the system CA bundle, and includes a fallback to the Mozilla CA bundle.',undef,],
		'framework' => ['https://laravel.com','Taylor Otwell','MIT',undef,'The Laravel Framework.',undef,],
		'laravel-ide-helper' => [undef,'Barry vd. Heuvel','MIT',undef,'Laravel IDE Helper, generates correct PHPDocs for all Facade classes, to improve auto-completion.',undef,],
		'finder-facade' => ['https://github.com/sebastianbergmann/finder-facade','Sebastian Bergmann','BSD-3-Clause',undef,'FinderFacade is a convenience wrapper for Symfony\'s Finder component.',undef,],
		'translation' => ['https://laravel.com','Taylor Otwell','MIT',undef,'The Illuminate Translation package.',undef,],
		'php-console-color' => [undef,'Jakub Onderka','BSD-2-Clause',undef,undef,undef,],
		'cssmin' => ['https://github.com/tubalmartin/YUI-CSS-compressor-PHP-port','Túbal Martín','BSD-3-Clause',undef,'A PHP port of the YUI CSS compressor',undef,],
		'migrations' => ['https://www.doctrine-project.org/projects/migrations.html','Benjamin Eberlei','MIT',undef,'Database Schema migrations using Doctrine DBAL',undef,],
		'zend' => ['http://framework.zend.com/',undef,'New BSD',undef,'Zend Framework 2 is an open source framework for developing web applications and services using PHP 5.3+. Zend Framework 2 uses 100% object-oriented code and utilises most of the new features of PHP 5.3, namely namespaces, late static binding, lambda functions and closures.','Web & Mobile applications',],
		'oauth1-client' => [undef,'Ben Corlett','MIT',undef,'OAuth 1.0 Client Library',undef,],
		'polyfill-php70' => ['https://symfony.com','Nicolas Grekas','MIT',undef,'Symfony polyfill backporting some PHP 7.0+ features to lower PHP versions',undef,],
		'tcpdf' => ['http://www.tcpdf.org/','Nicola Asuni','LGPL-3.0',undef,'TCPDF is a PHP class for generating PDF documents and barcodes.',undef,],
		'flow3' => ['http://flow.typo3.org/','Typo3','GPL 3.0 ',undef,'Flow is a web application platform enabling developers creating excellent web solutions and bring back the joy of coding.','Web & Mobile applications',],
		'phinx' => ['https://phinx.org','Woody Gilk','MIT',undef,'Phinx makes it ridiculously easy to manage the database migrations for your PHP app.',undef,],
		'mink-goutte-driver' => ['http://mink.behat.org/','Konstantin Kudryashov','MIT',undef,'Goutte driver for Mink framework',undef,],
		'diff' => ['https://github.com/PHP-CS-Fixer','Kore Nordmann','BSD-3-Clause',undef,'sebastian/diff v3 backport support for PHP 5.6+',undef,],
		'knp-snappy' => ['http://github.com/KnpLabs/snappy','KnpLabs Team','MIT',undef,'PHP5 library allowing thumbnail, snapshot or PDF generation from a url or a html page. Wrapper for wkhtmltopdf/wkhtmltoimage.',undef,],
		'php-text-template' => ['https://github.com/sebastianbergmann/php-text-template/','Sebastian Bergmann','BSD-3-Clause',undef,'Simple template engine.',undef,],
		'knp-menu-bundle' => [undef,'Christophe Coevoet','MIT',undef,'This bundle provides an integration of the KnpMenu library',undef,],
		'markdown' => ['https://github.com/cebe/markdown#readme','Carsten Brandt','MIT',undef,'A super fast, highly extensible markdown parser for PHP',undef,],
		'support' => ['https://laravel.com','Taylor Otwell','MIT',undef,'The Illuminate Support package.',undef,],
		'cg' => [undef,'Johannes M. Schmitt','Apache2',undef,'Toolset for generating PHP code',undef,],
		'reflection-common' => ['http://www.phpdoc.org','Jaap van Otterdijk','MIT',undef,'Common reflection classes used by phpdocumentor to reflect the code structure',undef,],
		'e107' => ['http://e107.org/',undef,'GPL 2.0',undef,'An open-source CMS designed for Bootstrap v3.','CMS',],
		'phalcon' => ['https://phalconphp.com/',undef,'New BSD',undef,'A full-stack PHP framework delivered as a C-extension. Its innovative architecture makes Phalcon the fastest PHP framework ever built!','MVC framework',],
		'reflection-docblock' => [undef,'Mike van Riel','MIT',undef,undef,undef,],
		'mouf' => ['http://mouf-php.com/',undef,'MIT',undef,'At the core, Mouf is a very special dependency injection library that comes with a web-based user interface','Module loader',],
		'xdebug-handler' => [undef,'John Stevenson','MIT',undef,'Restarts a process without xdebug.',undef,],
		'guzzle6-adapter' => ['http://httplug.io','Márk Sági-Kazár','MIT',undef,'Guzzle 6 HTTP Adapter',undef,],
		'geocoder' => ['http://geocoder-php.org','William Durand','MIT',undef,'Common files for PHP Geocoder',undef,],
		'imagine-bundle' => ['http://liip.ch','Liip and other contributors','MIT',undef,'This bundle provides an image manipulation abstraction toolkit for Symfony-based projects.',undef,],
		'symfony' => ['https://symfony.com/','SensioLabs','MIT',undef,'Symfony is a set of PHP Components, a Web Application framework, a Philosophy, and a Community � all working together in harmony.','Web & Mobile applications',],
		'directus' => ['http://getdirectus.com/',undef,'GPL',undef,'Directus is a customer-facing MySQL database GUI built around a robust and extensible API. Create database architectures based on specific project needs, design websites and native applications without limitations, and follow any development workflow you prefer.','CMS',],
		'seagull' => [undef,undef,'BSD',undef,'Seagull is a mature OOP framework for building web, command line and GUI applications. Licensed under BSD, the project allows PHP developers to easily integrate and manage code resources, and build complex applications quickly.','Application development',],
		'dbal' => ['http://www.doctrine-project.org','Roman Borschel','MIT',undef,'Database Abstraction Layer',undef,],
		'promises' => [undef,'Michael Dowling','MIT',undef,'Guzzle promises library',undef,],
		'fdomdocument' => ['https://github.com/theseer/fDOMDocument','Arne Blankerts','BSD-3-Clause',undef,'The classes contained within this repository extend the standard DOM to use exceptions at all occasions of errors instead of PHP warnings or notices. They also add various custom methods and shortcuts for convenience and to simplify the usage of DOM.',undef,],
		'silex' => ['https://silex.symfony.com','Fabien Potencier','MIT',undef,'The PHP micro-framework based on the Symfony Components',undef,],
		'filesystem' => ['https://laravel.com','Taylor Otwell','MIT',undef,'The Illuminate Filesystem package.',undef,],
		'phing' => ['https://www.phing.info/','Michiel Rook','LGPL-3.0-only',undef,'PHing Is Not GNU make it\'s a PHP project build system or build tool based on Apache Ant.',undef,],
		'mink' => ['http://mink.behat.org/','Konstantin Kudryashov','MIT',undef,'Browser controller/emulator abstraction for PHP',undef,],
		'emogrifier' => ['https://www.myintervals.com/emogrifier.php','John Reeve','MIT',undef,'Converts CSS styles into inline style attributes in your HTML code',undef,],
		'phpunit-wrapper' => [undef,'Davert','MIT',undef,'PHPUnit classes used by Codeception',undef,],
		'mockery' => ['https://github.com/mockery/mockery','Pádraic Brady','BSD-3-Clause',undef,'Mockery is a simple yet flexible PHP mock object framework',undef,],
		'json-schema' => ['https://github.com/justinrainbow/json-schema','Bruno Prieto Reis','MIT',undef,'A library to validate a json schema.',undef,],
		'php-console-highlighter' => [undef,'Jakub Onderka','MIT',undef,undef,undef,],
		'faker' => [undef,'François Zaninotto','MIT',undef,'Faker is a PHP library that generates fake data for you.',undef,],
		'expander' => [undef,'Matthew Grasmick','MIT',undef,'Expands internal property references in PHP arrays file.',undef,],
		'installers' => ['https://composer.github.io/installers/','Kyle Robinson Young','MIT',undef,'A multi-framework Composer library installer',undef,],
		'console' => ['https://laravel.com','Taylor Otwell','MIT',undef,'The Illuminate Console package.',undef,],
		'rabbitmq-bundle' => [undef,'Alvaro Videla','MIT',undef,'Integrates php-amqplib with Symfony & RabbitMq. Formerly oldsound/rabbitmq-bundle.',undef,],
		'zippy' => [undef,'Alchemy','MIT',undef,'Zippy, the archive manager companion',undef,],
		'php-token-stream' => ['https://github.com/sebastianbergmann/php-token-stream/','Sebastian Bergmann','BSD-3-Clause',undef,'Wrapper around PHP\'s tokenizer extension.',undef,],
		'phpcpd' => ['https://github.com/sebastianbergmann/phpcpd','Sebastian Bergmann','BSD-3-Clause',undef,'Copy/Paste Detector (CPD) for PHP code.',undef,],
		'gelf-php' => [undef,'Benjamin Zikarsky','MIT',undef,'A php implementation to send log-messages to a GELF compatible backend like Graylog2.',undef,],
		'phpcollection' => [undef,'Johannes M. Schmitt','Apache2',undef,'General-Purpose Collection Library for PHP',undef,],
		'composer-patches' => [undef,'Cameron Eagans','BSD-3-Clause',undef,'Provides a way to patch Composer packages.',undef,],
		'symfony' => ['https://symfony.com','Fabien Potencier','MIT',undef,'The Symfony PHP framework',undef,],
		'queue' => ['https://laravel.com','Taylor Otwell','MIT',undef,'The Illuminate Queue package.',undef,],
		'cotonti' => ['https://www.cotonti.com/',undef,'BSD',undef,'Cotonti is a powerful open-source web development framework and content manager with a focus on security, speed and flexibility.','CMS',],
		'qcodo' => ['http://www.qcodo.com/',undef,'MIT',undef,'The Qcodo Development Framework is an open-source PHP framework that focuses on freeing developers from unnecessary tedious, mundane coding.','Application development',],
		'xyster' => ['https://libreworks.github.io/xyster/',undef,'BSD',undef,'The Xyster Framework leverages and extends several parts of the Zend Framework providing a collection of useful tools for PHP applications.','Application development',],
		'knp-menu' => ['https://knplabs.com','Christophe Coevoet','MIT',undef,'An object oriented menu library',undef,],
		'lithium' => [undef,undef,'BSD',undef,undef,'Web & Mobile applications',],
		'framework-extra-bundle' => [undef,'Fabien Potencier','MIT',undef,'This bundle provides a way to configure your controllers with annotations',undef,],
		'redis-bundle' => ['https://github.com/snc/SncRedisBundle','Henrik Westphal','MIT',undef,'A Redis bundle for Symfony',undef,],
		'monolog-bridge' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony Monolog Bridge',undef,],
		'html' => ['https://laravelcollective.com','Taylor Otwell','MIT',undef,'HTML and Form Builders for the Laravel Framework',undef,],
		'distribution-bundle' => [undef,'Fabien Potencier','MIT',undef,'Base bundle for Symfony Distributions',undef,],
		'stopwatch' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony Stopwatch Component',undef,],
		'polyfill-php54' => ['https://symfony.com','Nicolas Grekas','MIT',undef,'Symfony polyfill backporting some PHP 5.4+ features to lower PHP versions',undef,],
		'whoops' => ['https://filp.github.io/whoops/','Filipe Dobreira','MIT',undef,'php error handling for cool kids',undef,],
		'jsonp-callback-validator' => [undef,'William Durand','MIT',undef,'JSONP callback validator.',undef,],
		'intl' => ['https://symfony.com','Bernhard Schussek','MIT',undef,'A PHP replacement layer for the C intl extension that includes additional data from the ICU library.',undef,],
		'web-service-common' => ['https://github.com/maxmind/web-service-common-php','Gregory Oschwald','Apache-2.0',undef,'Internal MaxMind Web Service API',undef,],
		'pagerfanta' => [undef,'Pablo Díez','MIT',undef,'Pagination for PHP',undef,],
		'swagger-php' => ['https://github.com/zircote/swagger-php/','Robert Allen','Apache2',undef,'Swagger-PHP - Generate interactive documentation for your RESTful API using phpdoc annotations',undef,],
		'yii2-swiftmailer' => [undef,'Paul Klimov','BSD-3-Clause',undef,'The SwiftMailer integration for the Yii framework',undef,],
		'psr-http-message-bridge' => ['http://symfony.com','Symfony Community','MIT',undef,'PSR HTTP message bridge',undef,],
		'polyfill-apcu' => ['https://symfony.com','Nicolas Grekas','MIT',undef,'Symfony polyfill backporting apcu_* functions to lower PHP versions',undef,],
		'output-formatters' => [undef,'Greg Anderson','MIT',undef,'Format text by applying transformations provided by plug-in formatters.',undef,],
		'doctrine-fixtures-bundle' => ['http://www.doctrine-project.org','Symfony Community','MIT',undef,'Symfony DoctrineFixturesBundle',undef,],
		'aiki' => [undef,'Aiki Lab','AGPL 3.0',undef,'Aiki Framework is a flexible PHP + MYSQL (LAMP) web application framework that allows designers and programmers to easily create and work with existing content management systems from the web.','Web & Mobile applications',],
		'geoip2' => ['https://github.com/maxmind/GeoIP2-php','Gregory J. Oschwald','Apache-2.0',undef,'MaxMind GeoIP2 PHP API',undef,],
		'php-jwt' => ['https://github.com/firebase/php-jwt','Neuman Vong','BSD-3-Clause',undef,'A simple library to encode and decode JSON Web Tokens (JWT) in PHP. Should conform to the current spec.',undef,],
		'knp-paginator-bundle' => ['http://github.com/KnpLabs/KnpPaginatorBundle','KnpLabs Team','MIT',undef,'Paginator bundle for Symfony to automate pagination and simplify sorting and other features',undef,],
		'exporter' => ['http://www.github.com/sebastianbergmann/exporter','Jeff Welch','BSD-3-Clause',undef,'Provides the functionality to export PHP variables for visualization',undef,],
		'fractal' => ['http://fractal.thephpleague.com/','Phil Sturgeon','MIT',undef,'Handle the output of complex data structures ready for API output.',undef,],
		'cache' => ['https://laravel.com','Taylor Otwell','MIT',undef,'The Illuminate Cache package.',undef,],
		'reader' => ['https://github.com/maxmind/MaxMind-DB-Reader-php','Gregory J. Oschwald','Apache-2.0',undef,'MaxMind DB Reader API',undef,],
		'stack-cors' => ['https://github.com/asm89/stack-cors','Alexander','MIT',undef,'Cross-origin resource sharing library and stack middleware',undef,],
		'sql-formatter' => ['https://github.com/jdorn/sql-formatter/','Jeremy Dorn','MIT',undef,'a PHP SQL highlighting library',undef,],
		'locale' => [undef,'Joshua Gigg','MIT',undef,'Locale functions required by libphonenumber-for-php',undef,],
		'php-webdriver' => ['http://instaclick.com/','Justin Bishop','Apache-2.0',undef,'PHP WebDriver for Selenium 2',undef,],
		'orm' => ['http://www.doctrine-project.org','Roman Borschel','MIT',undef,'Object-Relational-Mapper for PHP',undef,],
		'jshrink' => ['http://github.com/tedious/JShrink','Robert Hafner','BSD-3-Clause',undef,'Javascript Minifier built in PHP',undef,],
		'property-access' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony PropertyAccess Component',undef,],
		'prestissimo' => [undef,'Hiraku NAKANO','MIT',undef,'composer parallel install plugin',undef,],
		'streams' => ['http://guzzlephp.org/','Michael Dowling','MIT',undef,'Provides a simple abstraction over streams of data',undef,],
		'knp-gaufrette-bundle' => ['http://knplabs.com','The contributors','MIT',undef,'Allows to easily use the Gaufrette library in a Symfony project',undef,],
		'bugsnag' => ['https://github.com/bugsnag/bugsnag-php','James Smith','MIT',undef,'Official Bugsnag notifier for PHP applications.',undef,],
		'contracts' => ['https://laravel.com','Taylor Otwell','MIT',undef,'The Illuminate Contracts package.',undef,],
		'security-advisories' => [undef,'Marco Pivetta','MIT',undef,'Prevents installation of composer packages with known security vulnerabilities: no API, simply require it',undef,],
		'stripe-php' => ['https://stripe.com/','Stripe and contributors','MIT',undef,'Stripe PHP Library',undef,],
		'mobiledetectlib' => ['https://github.com/serbanghita/Mobile-Detect','Serban Ghita','MIT',undef,'Mobile_Detect is a lightweight PHP class for detecting mobile devices. It uses the User-Agent string combined with specific HTTP headers to detect the mobile environment.',undef,],
		'phpspec' => ['http://phpspec.net/','Konstantin Kudryashov','MIT',undef,'Specification-oriented BDD framework for PHP 5.6+',undef,],
		'event' => [undef,'Frank de Jonge','MIT',undef,'Event package',undef,],
		'validator' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony Validator Component',undef,],
		'css-to-inline-styles' => ['https://github.com/tijsverkoyen/CssToInlineStyles','Tijs Verkoyen','BSD-3-Clause',undef,'CssToInlineStyles is a class that enables you to convert HTML-pages/files into HTML-pages/files with inline styles. This is very useful when you\'re sending emails.',undef,],
		'polyfill-ctype' => ['https://symfony.com','Symfony Community','MIT',undef,'Symfony polyfill for ctype functions',undef,],
		'flysystem' => [undef,'Frank de Jonge','MIT',undef,'Filesystem abstraction: Many filesystems, one API.',undef,],
		'security-checker' => [undef,'Fabien Potencier','MIT',undef,'A security checker for your composer.lock',undef,],
		'php-code-coverage' => ['https://github.com/sebastianbergmann/php-code-coverage','Sebastian Bergmann','BSD-3-Clause',undef,'Library that provides collection, processing, and rendering functionality for PHP code coverage information.',undef,],
		'proxy' => [undef,'Chris Fidao','MIT',undef,'Set trusted proxies for Laravel',undef,],
		'api-doc-bundle' => [undef,'Nelmio','MIT',undef,'Generates documentation for your REST API from annotations',undef,],
		'guzzle' => ['http://guzzlephp.org/','Michael Dowling','MIT',undef,'PHP HTTP client. This library is deprecated in favor of https://packagist.org/packages/guzzlehttp/guzzle',undef,],
		'goutte' => ['https://github.com/FriendsOfPHP/Goutte','Fabien Potencier','MIT',undef,'A simple PHP Web Scraper',undef,],
		'link-util' => [undef,'PHP-FIG','MIT',undef,'Common utility implementations for HTTP links',undef,],
		'prophecy' => ['https://github.com/phpspec/prophecy','Konstantin Kudryashov','MIT',undef,'Highly opinionated mocking framework for PHP 5.3+',undef,],
		'psr7' => [undef,'Michael Dowling','MIT',undef,'PSR-7 message implementation that also provides common utility methods',undef,],
		'akelos' => ['https://github.com/akelos',undef,'LGPL',undef,undef,undef,],
		'log' => [undef,'Greg Anderson','MIT',undef,'Improved Psr-3 / Psr\Log logger based on Symfony Console components.',undef,],
		'psysh' => ['http://psysh.org','Justin Hileman','MIT',undef,'An interactive shell for modern PHP.',undef,],
		'neon' => ['http://ne-on.org','David Grudl','BSD-3-Clause',undef,'🍸 Nette NEON: encodes and decodes NEON file format.',undef,],
		'password-compat' => ['https://github.com/ircmaxell/password_compat','Anthony Ferrara','MIT',undef,'A compatibility library for the proposed simplified password hashing algorithm: https://wiki.php.net/rfc/password_hash',undef,],
		'event-dispatcher' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony EventDispatcher Component',undef,],
		'symfony2-extension' => ['http://behat.org','Christophe Coevoet','MIT',undef,'Symfony2 framework extension for Behat',undef,],
		'kumbia php' => ['http://www.kumbiaphp.com/',undef,'New BSD',undef,'Kumbia is a Web & app MVC PHP framework','MVC framework',],
		'templating' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony Templating Component',undef,],
		'gaufrette' => ['http://knplabs.com','The contributors','MIT',undef,'PHP library that provides a filesystem abstraction layer',undef,],
		'dompdf' => ['https://github.com/dompdf/dompdf','Fabien Ménager','LGPL-2.1',undef,'DOMPDF is a CSS 2.1 compliant HTML to PDF converter',undef,],
		'http-message' => ['https://github.com/php-fig/http-message','PHP-FIG','MIT',undef,'Common interface for HTTP messages',undef,],
		'php-font-lib' => ['https://github.com/PhenX/php-font-lib','Fabien Ménager','LGPL-3.0',undef,'A library to read, parse, export and make subsets of different types of font files.',undef,],
		'environment' => ['http://www.github.com/sebastianbergmann/environment','Sebastian Bergmann','BSD-3-Clause',undef,'Provides functionality to handle HHVM/PHP environments',undef,],
		'assetic' => ['https://github.com/kriswallsmith/assetic','Kris Wallsmith','MIT',undef,'Asset Management for PHP',undef,],
		'php-enum' => ['http://github.com/myclabs/php-enum','PHP Enum contributors','MIT',undef,'PHP Enum implementation',undef,],
		'yaml' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony Yaml Component',undef,],
		'atomik' => ['http://atomikframework.com/',undef,'MIT',undef,'Atomik is a PHP micro framework that provides everything you need to make small to medium websites and get you started as quickly as possible. It\'s simple nature makes it the perfect fit for beginners.','Web & Mobile applications',],
		'config' => [undef,'Greg Anderson','MIT',undef,'Provide configuration services for a commandline tool.',undef,],
		'property-info' => ['https://symfony.com','Kévin Dunglas','MIT',undef,'Symfony Property Info Component',undef,],
		'doctrine-extensions' => ['http://gediminasm.org/','David Buchmann','MIT',undef,'Doctrine2 behavioral extensions',undef,],
		'polyfill-mbstring' => ['https://symfony.com','Nicolas Grekas','MIT',undef,'Symfony polyfill for the Mbstring extension',undef,],
		'negotiation' => ['http://williamdurand.fr/Negotiation/','William Durand','MIT',undef,'Content Negotiation tools for PHP provided as a standalone library.',undef,],
		'global-state' => ['http://www.github.com/sebastianbergmann/global-state','Sebastian Bergmann','BSD-3-Clause',undef,'Snapshotting of global state',undef,],
		'object-enumerator' => ['https://github.com/sebastianbergmann/object-enumerator/','Sebastian Bergmann','BSD-3-Clause',undef,'Traverses array structures and object graphs to enumerate all referenced objects',undef,],
		'thanks' => [undef,'Nicolas Grekas','MIT',undef,'Give thanks (in the form of a GitHub ⭐) to your fellow PHP package maintainers (not limited to Symfony components)!',undef,],
		'csv' => ['http://csv.thephpleague.com','Ignace Nyamagana Butera','MIT',undef,'Csv data manipulation made easy in PHP',undef,],
		'robo' => [undef,'Davert','MIT',undef,'Modern task runner',undef,],
		'view' => ['https://laravel.com','Taylor Otwell','MIT',undef,'The Illuminate View package.',undef,],
		'codeigniter' => ['https://www.codeigniter.com/','British Columbia Institute of Techology','OSL 3.0',undef,'CodeIgniter is a powerful PHP framework with a very small footprint, built for developers who need a simple and elegant toolkit to create full-featured web applications','Web & Mobile applications',],
		'sentry' => ['http://getsentry.com','David Cramer','BSD-3-Clause',undef,'A PHP client for Sentry (http://getsentry.com)',undef,],
		'php-svg-lib' => ['https://github.com/PhenX/php-svg-lib','Fabien Ménager','LGPL-3.0',undef,'A library to read, parse and export to PDF SVG files.',undef,],
		'asset' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony Asset Component',undef,],
		'composer' => ['https://getcomposer.org/','Nils Adermann','MIT',undef,'Composer helps you declare, manage and install dependencies of PHP projects, ensuring you have the right stack everywhere.',undef,],
		'mandrill' => ['https://bitbucket.org/mailchimp/mandrill-api-php','Mandrill Devs','Apache-2.0',undef,'API client library for the Mandrill email as a service platform',undef,],
		'polyfill-php72' => ['https://symfony.com','Nicolas Grekas','MIT',undef,'Symfony polyfill backporting some PHP 7.2+ features to lower PHP versions',undef,],
		'random_compat' => [undef,'Paragon Initiative Enterprises','MIT',undef,'PHP 5.x polyfill for random_bytes() and random_int() from PHP 7',undef,],
		'bacon-qr-code' => ['https://github.com/Bacon/BaconQrCode','Ben Scholzen \'DASPRiD\'','BSD-2-Clause',undef,'BaconQrCode is a QR code generator for PHP.',undef,],
		'pagination' => ['https://laravel.com','Taylor Otwell','MIT',undef,'The Illuminate Pagination package.',undef,],
		'midgard' => ['http://midgard-project.org/midgardmvc/',undef,'LGPL',undef,'Midgard MVC is a web framework for PHP. Being a framework, it provides a standard way to build and deploy web applications. Your applications provide a set of interfaces that Midgard MVC calls when a matching HTTP request is made.','MVC framework',],
		'inflector' => ['https://symfony.com','Bernhard Schussek','MIT',undef,'Symfony Inflector Component',undef,],
		'var-dumper' => ['https://symfony.com','Nicolas Grekas','MIT',undef,'Symfony mechanism for exploring and dumping PHP variables',undef,],
		'phpunit-bridge' => ['https://symfony.com','Nicolas Grekas','MIT',undef,'Symfony PHPUnit Bridge',undef,],
		'pretty-package-versions' => [undef,'Alessandro Lai','MIT',undef,'A wrapper for ocramius/package-versions to get pretty versions strings',undef,],
		'ringphp' => [undef,'Michael Dowling','MIT',undef,'Provides a simple API and specification that abstracts away the details of HTTP into a single PHP function.',undef,],
		'doctrine-extensions-bundle' => ['https://github.com/stof/StofDoctrineExtensionsBundle','Christophe Coevoet','MIT',undef,'Integration of the gedmo/doctrine-extensions with Symfony2',undef,],
		'security' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony Security Component',undef,],
		'superclosure' => ['https://github.com/jeremeamia/super_closure','Jeremy Lindblom','MIT',undef,'Serialize Closure objects, including their context and binding',undef,],
		'promise' => ['http://httplug.io','Márk Sági-Kazár','MIT',undef,'Promise used for asynchronous HTTP requests',undef,],
		'evenement' => [undef,'Igor Wiedler','MIT',undef,'Événement is a very simple event dispatching library for PHP',undef,],
		'phpunit-mock-objects' => ['https://github.com/sebastianbergmann/phpunit-mock-objects/','Sebastian Bergmann','BSD-3-Clause',undef,'Mock Object library for PHPUnit',undef,],
		'debug-bundle' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony DebugBundle',undef,],
		'extensions' => [undef,'Fabien Potencier','MIT',undef,'Common additional features for Twig that do not directly belong in core',undef,],
		'yii2-bootstrap' => [undef,'Paul Klimov','BSD-3-Clause',undef,'The Twitter Bootstrap extension for the Yii framework',undef,],
		'phpdotenv' => [undef,'Vance Lucas','BSD-3-Clause',undef,'Loads environment variables from `.env` to `getenv()`, `$_ENV` and `$_SERVER` automagically.',undef,],
		'less.php' => ['http://lessphp.gpeasy.com','Matt Agar','Apache-2.0',undef,'PHP port of the Javascript version of LESS http://lesscss.org (Originally maintained by Josh Schmidt)',undef,],
		'phpunit' => ['https://phpunit.de/','Sebastian Bergmann','BSD-3-Clause',undef,'The PHP Unit Testing framework.',undef,],
		'instantiator' => ['https://github.com/doctrine/instantiator','Marco Pivetta','MIT',undef,'A small, lightweight utility to instantiate objects in PHP without invoking their constructors',undef,],
		'data-fixtures' => ['http://www.doctrine-project.org','Jonathan Wage','MIT',undef,'Data Fixtures for all Doctrine Object Managers',undef,],
		'maker-bundle' => ['https://symfony.com/doc/current/bundles/SymfonyMakerBundle/index.html','Symfony Community','MIT',undef,'Symfony Maker helps you create empty commands, controllers, form classes, tests and more so you can forget about writing boilerplate code.',undef,],
		'passport' => [undef,'Taylor Otwell','MIT',undef,'Laravel Passport provides OAuth2 server support to Laravel.',undef,],
		'email-validator' => ['https://github.com/egulias/EmailValidator','Eduardo Gulias Davis','MIT',undef,'A library for validating emails against several RFCs',undef,],
		'dependency-injection' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony DependencyInjection Component',undef,],
		'knp-components' => ['http://github.com/KnpLabs/knp-components','KnpLabs Team','MIT',undef,'Knplabs component library',undef,],
		'phpmailer' => [undef,'Jim Jagielski','LGPL-2.1',undef,'PHPMailer is a full-featured email creation and transfer class for PHP',undef,],
		'php-cs-fixer' => [undef,'Dariusz Rumiński','MIT',undef,'A tool to automatically fix PHP code style',undef,],
		'slugify' => [undef,'Ivo Bathke','MIT',undef,'Converts a string into a slug.',undef,],
		'http-kernel' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony HttpKernel Component',undef,],
		'buzz' => ['https://github.com/kriswallsmith/Buzz','Kris Wallsmith','MIT',undef,'Lightweight HTTP client',undef,],
		'manifest' => [undef,'Arne Blankerts','BSD-3-Clause',undef,'Component for reading phar.io manifest information from a PHP Archive (PHAR)',undef,],
		'events' => ['https://laravel.com','Taylor Otwell','MIT',undef,'The Illuminate Events package.',undef,],
		'twig-bridge' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony Twig Bridge',undef,],
		'oauth2-server' => ['https://oauth2.thephpleague.com/','Alex Bilbie','MIT',undef,'A lightweight and powerful OAuth 2.0 authorization and resource server library with support for all the core specification grants. This library will allow you to secure your API with OAuth and allow your applications users to approve apps that want to access their data from your API.',undef,],
		'cakephp' => ['http://cakephp.org/',undef,'MIT',undef,'CakePHP makes building web applications simpler, faster and require less code.','Web & Mobile applications',],
		'php-file-iterator' => ['https://github.com/sebastianbergmann/php-file-iterator/','Sebastian Bergmann','BSD-3-Clause',undef,'FilterIterator implementation that filters files based on a list of suffixes.',undef,],
		'mink-selenium2-driver' => ['http://mink.behat.org/','Konstantin Kudryashov','MIT',undef,'Selenium2 (WebDriver) driver for Mink framework',undef,],
		'assert' => [undef,'Benjamin Eberlei','BSD-2-Clause',undef,'Thin assertion library for input validation in business models.',undef,],
		'phpmd' => ['https://phpmd.org/','Manuel Pichler','BSD-3-Clause',undef,'PHPMD is a spin-off project of PHP Depend and aims to be a PHP equivalent of the well known Java tool PMD.',undef,],
		'laravel-debugbar' => [undef,'Barry vd. Heuvel','MIT',undef,'PHP Debugbar integration for Laravel',undef,],
		'collections' => ['http://www.doctrine-project.org','Roman Borschel','MIT',undef,'Collections Abstraction library',undef,],
		'gherkin' => ['http://behat.org/','Konstantin Kudryashov','MIT',undef,'Gherkin DSL parser for PHP 5.3',undef,],
		'gastonjs' => ['https://github.com/jcalderonzumba/gastonjs','Juan Francisco Calderón Zumba','MIT',undef,'PhantomJS API based server for webpage automation',undef,],
		'debug' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony Debug Component',undef,],
		'mink-phantomjs-driver' => ['http://mink.behat.org/','Juan Francisco Calderón Zumba','MIT',undef,'PhantomJS driver for Mink framework',undef,],
		'php-diff' => [undef,'Chris Boulton','BSD-3-Clause',undef,'A comprehensive library for generating differences between two hashable objects (strings or arrays).',undef,],
		'cron-expression' => [undef,'Michael Dowling','MIT',undef,'CRON for PHP: Calculate the next or previous run date and determine if a CRON expression is due',undef,],
		'pheanstalk' => ['https://github.com/pda/pheanstalk','Paul Annesley','MIT',undef,'PHP client for beanstalkd queue',undef,],
		'mink-extension' => ['http://extensions.behat.org/mink','Christophe Coevoet','MIT',undef,'Mink extension for Behat',undef,],
		'annotated-command' => [undef,'Greg Anderson','MIT',undef,'Initialize Symfony Console commands from annotated command class methods.',undef,],
		'pimple' => ['https://pimple.symfony.com','Fabien Potencier','MIT',undef,'Pimple, a simple Dependency Injection Container',undef,],
		'elasticsearch' => [undef,'Zachary Tong','Apache-2.0',undef,'PHP Client for Elasticsearch',undef,],
		'parsedown' => ['http://parsedown.org','Emanuil Rusev','MIT',undef,'Parser for Markdown.',undef,],
		'jmespath.php' => [undef,'Michael Dowling','MIT',undef,'Declaratively specify how to extract elements from a JSON document',undef,],
		'httplug' => ['http://httplug.io','Eric GELOEN','MIT',undef,'HTTPlug, the HTTP client abstraction for PHP',undef,],
		'vfsstream' => ['http://vfs.bovigo.org/','Frank Kleine','BSD-3-Clause',undef,undef,undef,],
		'kajona' => ['https://www.kajona.de/',undef,'LGPL',undef,'Kajona is an open source Content Management System (CMS).','CMS',],
		'css-selector' => ['https://symfony.com','Jean-François Simon','MIT',undef,'Symfony CssSelector Component',undef,],
		'symfony-console-completion' => [undef,'Stephen Holdaway','MIT',undef,'Automatic BASH completion for Symfony Console Component based applications.',undef,],
		'bus' => ['https://laravel.com','Taylor Otwell','MIT',undef,'The Illuminate Bus package.',undef,],
		'comparator' => ['https://github.com/sebastianbergmann/comparator','Jeff Welch','BSD-3-Clause',undef,'Provides the functionality to compare PHP values for equality',undef,],
		'composer-parameter-handler' => ['https://github.com/Incenteev/ParameterHandler','Christophe Coevoet','MIT',undef,'Composer script handling your ignored parameter file',undef,],
		'stringy' => ['https://github.com/danielstjules/Stringy','Daniel St. Jules','MIT',undef,'A string manipulation library with multibyte support',undef,],
		'http-foundation' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony HttpFoundation Component',undef,],
		'simple-cache' => [undef,'PHP-FIG','MIT',undef,'Common interfaces for simple caching',undef,],
		'client-common' => ['http://httplug.io','Márk Sági-Kazár','MIT',undef,'Common HTTP Client implementations and tools for HTTPlug',undef,],
		'fuelphp' => ['http://fuelphp.com/',undef,'MIT',undef,'FuelPHP is a MVC (Model-View-Controller) framework that was designed from the ground up to have full support for HMVC as part of its architecture. But we didn\'t stop there, we also added ViewModels (also known as presentation models) into the mix which give you the option to add a powerful layer between the Controller and the View.','MVC framework',],
		'code-unit-reverse-lookup' => ['https://github.com/sebastianbergmann/code-unit-reverse-lookup/','Sebastian Bergmann','BSD-3-Clause',undef,'Looks up which function or method a line of code belongs to',undef,],
		'polyfill-php55' => ['https://symfony.com','Nicolas Grekas','MIT',undef,'Symfony polyfill backporting some PHP 5.5+ features to lower PHP versions',undef,],
		'laravel-cors' => [undef,'Barry vd. Heuvel','MIT',undef,'Adds CORS (Cross-Origin Resource Sharing) headers support in your Laravel application',undef,],
		'mink-browserkit-driver' => ['http://mink.behat.org/','Konstantin Kudryashov','MIT',undef,'Symfony2 BrowserKit driver for Mink framework',undef,],
		'message' => ['http://php-http.org','Márk Sági-Kazár','MIT',undef,'HTTP Message related tools',undef,],
		'fast-route' => [undef,'Nikita Popov','BSD-3-Clause',undef,'Fast request router for PHP',undef,],
		'crawler-detect' => ['https://github.com/JayBizzle/Crawler-Detect/','Mark Beech','MIT',undef,'CrawlerDetect is a PHP class for detecting bots/crawlers/spiders via the user agent',undef,],
		'elastica' => ['http://elastica.io/','Nicolas Ruflin','MIT',undef,'Elasticsearch Client',undef,],
		'php_codesniffer' => ['http://www.squizlabs.com/php-codesniffer','Greg Sherwood','BSD-3-Clause',undef,'PHP_CodeSniffer tokenizes PHP, JavaScript and CSS files and detects violations of a defined set of coding standards.',undef,],
		'tinker' => [undef,'Taylor Otwell','MIT',undef,'Powerful REPL for the Laravel framework.',undef,],
		'validation' => ['https://laravel.com','Taylor Otwell','MIT',undef,'The Illuminate Validation package.',undef,],
		'laravel-dompdf' => [undef,'Barry vd. Heuvel','MIT',undef,'A DOMPDF Wrapper for Laravel',undef,],
		'dbunit' => ['https://github.com/sebastianbergmann/dbunit/','Sebastian Bergmann','BSD-3-Clause',undef,'PHPUnit extension for database interaction testing',undef,],
		'socialite' => [undef,'Taylor Otwell','MIT',undef,'Laravel wrapper around OAuth 1 & OAuth 2 libraries.',undef,],
		'drupal-finder' => [undef,'Florian Weber','GPL-2.0+',undef,'Helper class to locate a Drupal installation from a given path.',undef,],
		'alice' => [undef,'Jordi Boggiano','MIT',undef,'Expressive fixtures generator',undef,],
		'recursion-context' => ['http://www.github.com/sebastianbergmann/recursion-context','Jeff Welch','BSD-3-Clause',undef,'Provides functionality to recursively process PHP variables',undef,],
		'php-timer' => ['https://github.com/sebastianbergmann/php-timer/','Sebastian Bergmann','BSD-3-Clause',undef,'Utility class for timing',undef,],
		'stream-filter' => ['https://github.com/clue/php-stream-filter','Christian Lück','MIT',undef,'A simple and modern approach to stream filtering in PHP',undef,],
		'security-bundle' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony SecurityBundle',undef,],
		'session' => ['https://laravel.com','Taylor Otwell','MIT',undef,'The Illuminate Session package.',undef,],
		'yii2' => ['http://www.yiiframework.com/','Qiang Xue','BSD-3-Clause',undef,'Yii PHP Framework Version 2',undef,],
		'polyfill-util' => ['https://symfony.com','Nicolas Grekas','MIT',undef,'Symfony utilities for portability of PHP codes',undef,],
		'generator-bundle' => [undef,'Fabien Potencier','MIT',undef,'This bundle generates code for you',undef,],
		'punycode' => ['https://github.com/true/php-punycode','Renan Gonçalves','MIT',undef,'A Bootstring encoding of Unicode for Internationalized Domain Names in Applications (IDNA)',undef,],
		'behat' => ['http://behat.org/','Konstantin Kudryashov','MIT',undef,'Scenario-oriented BDD framework for PHP 5.3',undef,],
		'annotations' => ['http://www.doctrine-project.org','Roman Borschel','MIT',undef,'Docblock Annotations Parser',undef,],
		'resource-operations' => ['https://www.github.com/sebastianbergmann/resource-operations','Sebastian Bergmann','BSD-3-Clause',undef,'Provides a list of PHP built-in functions that operate on resources',undef,],
		'expression-language' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony ExpressionLanguage Component',undef,],
		'lts' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Enforces Long Term Supported versions of Symfony components',undef,],
		'browser-kit' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony BrowserKit Component',undef,],
		'monolog-bundle' => ['http://symfony.com','Symfony Community','MIT',undef,'Symfony MonologBundle',undef,],
		'drush' => ['http://www.drush.org','Moshe Weitzman','GPL-2.0-or-later',undef,'Drush is a command line shell and scripting interface for Drupal, a veritable Swiss Army knife designed to make life easier for those of us who spend some of our working hours hacking away at the command prompt.',undef,],
		'di' => ['https://nette.org','David Grudl','BSD-3-Clause',undef,'💎 Nette Dependency Injection Container: Flexible, compiled and full-featured DIC with perfectly usable autowiring and support for all new PHP 7.1 features.',undef,],
		'agavi' => ['http://www.agavi.org/','Bitextender','LGPL',undef,'Agavi is a general purpose PHP application framework built around the Model-View-Controller architecture originally based on the Mojavi 3 Web application framework written by Sean Kerr. It provides a rich toolset that solves most of the routine problems in Web application development','MVC framework',],
		'php-generator' => ['https://nette.org','David Grudl','BSD-3-Clause',undef,'🐘 Nette PHP Generator: generates neat PHP code for you. Supports new PHP 7.2 features.',undef,],
		'yii' => ['http://www.yiiframework.com/',undef,'New BSD',undef,'Yii is a high-performance PHP framework best for developing Web 2.0 applications. Yii comes with rich features: MVC, DAO/ActiveRecord, I18N/L10N, caching, authentication and role-based access control, scaffolding, testing, etc. It can reduce your development time significantly.','Web & Mobile applications',],
		'ez publish' => ['http://ez.no/',undef,'GPL 2.0',undef,'eZ is an open source content management system (CMS) provider that helps businesses maximize the value of their content.','CMS',],
		'bootstrap' => ['https://nette.org','David Grudl','BSD-3-Clause',undef,'🅱 Nette Bootstrap: the simple way to configure and bootstrap your Nette application.',undef,],
		'dot-access-data' => ['https://github.com/dflydev/dflydev-dot-access-data','Dragonfly Development Inc.','MIT',undef,'Given a deep data structure, access data by dot notation.',undef,],
		'proxy-manager' => ['https://github.com/Ocramius/ProxyManager','Marco Pivetta','MIT',undef,'A library providing utilities to generate, instantiate and generally operate with Object Proxies',undef,],
		'reflection' => ['https://www.doctrine-project.org/projects/reflection.html','Roman Borschel','MIT',undef,'Doctrine Reflection component',undef,],
		'html5' => ['http://masterminds.github.io/html5-php','Matt Butcher','MIT',undef,'An HTML5 parser and serializer.',undef,],
		'dom-crawler' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony DomCrawler Component',undef,],
		'copix' => ['http://www.copix.org/',undef,undef,undef,undef,'Web & Mobile applications',],
		'flex' => [undef,'Fabien Potencier','MIT',undef,'Composer plugin for Symfony',undef,],
		'laravel' => ['https://laravel.com/','Taylor Otwell','MIT',undef,'The PHP Framework For Web Artisans','Web & Mobile applications',],
		'assetic-bundle' => ['https://github.com/symfony/AsseticBundle','Kris Wallsmith','MIT',undef,'Integrates Assetic into Symfony2',undef,],
		'options-resolver' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony OptionsResolver Component',undef,],
		'dotenv' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Registers environment variables from a .env file',undef,],
		'phpspreadsheet' => ['https://github.com/PHPOffice/PhpSpreadsheet','Maarten Balliauw','LGPL-2.1-or-later',undef,'PHPSpreadsheet - Read, Create and Write Spreadsheet documents in PHP - Spreadsheet engine',undef,],
		'sentry-laravel' => ['https://sentry.io','David Cramer','Apache-2.0',undef,'Laravel integration for Sentry (https://sentry.io)',undef,],
		'phpoption' => [undef,'Johannes M. Schmitt','Apache2',undef,'Option Type for PHP',undef,],
		'database' => ['https://laravel.com','Taylor Otwell','MIT',undef,'The Illuminate Database package.',undef,],
		'class-loader' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony ClassLoader Component',undef,],
		'spdx-licenses' => [undef,'Nils Adermann','MIT',undef,'SPDX licenses list and validation library.',undef,],
		'agent' => ['https://github.com/jenssegers/agent','Jens Segers','MIT',undef,'Desktop/mobile user agent parser with support for Laravel, based on Mobiledetect',undef,],
		'phar-utils' => [undef,'Jordi Boggiano','MIT',undef,'PHAR file format utilities, for when PHP phars you up',undef,],
		'lexer' => ['http://www.doctrine-project.org','Roman Borschel','MIT',undef,'Base library for a lexer that can be used in Top-Down, Recursive Descent Parsers.',undef,],
		'mongodb' => ['https://jira.mongodb.org/browse/PHPLIB','Jeremy Mikola','Apache-2.0',undef,'MongoDB driver library',undef,],
		'php-amqplib' => ['https://github.com/php-amqplib/php-amqplib/','Alvaro Videla','LGPL-2.1-or-later',undef,'Formerly videlalvaro/php-amqplib.  This library is a pure PHP implementation of the AMQP protocol. It\'s been tested against RabbitMQ.',undef,],
		'rest-bundle' => ['http://friendsofsymfony.github.com','Lukas Kahwe Smith','MIT',undef,'This Bundle provides various tools to rapidly develop RESTful API\'s with Symfony',undef,],
		'metadata' => [undef,'Asmir Mustafic','MIT',undef,'Class/method/property metadata management in PHP',undef,],
		'cli-prompt' => [undef,'Jordi Boggiano','MIT',undef,'Allows you to prompt for user input on the command line, and optionally hide the characters they type',undef,],
		'debugbar' => ['https://github.com/maximebf/php-debugbar','Maxime Bouroumeau-Fuseau','MIT',undef,'Debug bar in the browser for php application',undef,],
		'doctrine-bridge' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony Doctrine Bridge',undef,],
		'yaml-expander' => [undef,'Matthew Grasmick','MIT',undef,'Expands internal property references in a yaml file.',undef,],
		'yii2-debug' => [undef,'Qiang Xue','BSD-3-Clause',undef,'The debugger extension for the Yii framework',undef,],
		'carbon' => ['http://carbon.nesbot.com','Brian Nesbitt','MIT',undef,'A simple API extension for DateTime.',undef,],
		'serializer' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony Serializer Component',undef,],
		'polyfill-php56' => ['https://symfony.com','Nicolas Grekas','MIT',undef,'Symfony polyfill backporting some PHP 5.6+ features to lower PHP versions',undef,],
		'aws-sdk-php' => ['http://aws.amazon.com/sdkforphp','Amazon Web Services','Apache-2.0',undef,'AWS SDK for PHP - Use Amazon Web Services in your PHP project',undef,],
		'persistence' => ['https://doctrine-project.org/projects/persistence.html','Roman Borschel','MIT',undef,'Doctrine Persistence abstractions.',undef,],
		'robot-loader' => ['https://nette.org','David Grudl','BSD-3-Clause',undef,'🍀 Nette RobotLoader: high performance and comfortable autoloader that will search and autoload classes within your application.',undef,],
		'jelix' => ['http://jelix.org/',undef,'LGPL',undef,'Jellix offers a MVC compatible application working with PHP5','MVC framework',],
		'process' => ['https://symfony.com','Fabien Potencier','MIT',undef,'Symfony Process Component',undef,],
		'user-bundle' => ['http://friendsofsymfony.github.com','Christophe Coevoet','MIT',undef,'Symfony FOSUserBundle',undef,],
		'credis' => ['https://github.com/colinmollenhour/credis','Colin Mollenhour','MIT',undef,'Credis is a lightweight interface to the Redis key-value store which wraps the phpredis library when available for better performance.',undef,],
		'mpdf' => ['https://mpdf.github.io','Matěj Humpál','GPL-2.0-only',undef,'A PHP class to generate PDF files from HTML with Unicode/UTF-8 and CJK support',undef,],
		'chronos' => ['http://cakephp.org','Brian Nesbitt','MIT',undef,'A simple API extension for DateTime.',undef,],
		'libphonenumber-for-php' => ['https://github.com/giggsey/libphonenumber-for-php','Joshua Gigg','Apache-2.0',undef,'PHP Port of Google\'s libphonenumber',undef,],
		'phploc' => ['https://github.com/sebastianbergmann/phploc','Sebastian Bergmann','BSD-3-Clause',undef,'A tool for quickly measuring the size of a PHP project.',undef,],
		'routing' => ['http://cmf.symfony.com','Symfony CMF Community','MIT',undef,'Extends the Symfony routing component for dynamic routes and chaining several routers',undef,],
		'website-php' => ['http://www.website-php.com/',undef,undef,undef,'WebSite-PHP is a PHP Framework which has the distinction of being fully object-oriented, and not requiring special knowledge of HTML or JavaScript. Knowledges of PHP and mechanisms for object-oriented programming (OOP) are still required.','Web & Mobile applications',],
		'spyc' => ['https://github.com/mustangostang/spyc/','mustangostang','MIT',undef,'A simple YAML loader/dumper class for PHP',undef,],
		'link' => ['https://github.com/php-fig/link','PHP-FIG','MIT',undef,'Common interfaces for HTTP links',undef,],
		'message-factory' => ['http://php-http.org','Márk Sági-Kazár','MIT',undef,'Factory interfaces for PSR-7 HTTP Message',undef,],
		'container' => ['https://github.com/thephpleague/container','Phil Bennett','MIT',undef,'A fast and intuitive dependency injection container.',undef,],
		'jose' => [undef,'Alessandro Nadalin','MIT',undef,'JSON Object Signing and Encryption library for PHP.',undef,],
		'polyfill-iconv' => ['https://symfony.com','Nicolas Grekas','MIT',undef,'Symfony polyfill for the Iconv extension',undef,],
		'zeta' => ['http://zetacomponents.org/',undef,'Apache License',undef,'Zeta Components are a high quality, general purpose library of loosly coupled components for development of applications based on PHP 5. Beside typical modules for web application development, like a Template engine, Database tools and an MVC component, Zeta Components contain command line tools, a chart rendering library, a WebDAV server, a universal document conversion component and many more tools to ease developers live.','Application framework',],
		'package-versions' => [undef,'Marco Pivetta','MIT',undef,'Composer plugin that provides efficient querying for installed package versions (no runtime IO)',undef,],
		'cors-bundle' => [undef,'Nelmio','MIT',undef,'Adds CORS (Cross-Origin Resource Sharing) headers support in your Symfony2 application',undef,],
		'semver' => [undef,'Nils Adermann','MIT',undef,'Semver library that offers utilities, version constraint parsing and validation.',undef,],
		'builder' => [undef,'Igor Wiedler','MIT',undef,'Builder for stack middlewares based on HttpKernelInterface.',undef,],
	},

	'JS' => {
		'meteor' => ['https://www.meteor.com/','Meteor Development Group Inc.','MIT',undef,'Meteor is an open source platform for web, mobile and desktop.','Web & Mobile applications',],
		'phonegap' => ['http://phonegap.com/','Adobe','Apache License 2.0',undef,'Easily create apps using the web technologies you know and love: HTML, CSS, and JavaScript PhoneGap is a free and open source framework that allows you to create mobile apps using standardized web APIs for the platforms you care about.','Mobile applications',],
		'activejs' => ['https://github.com/aptana/activejs',undef,'MIT',undef,'ActiveJS is a JavaScript application framework that provides local and REST based data modeling and pure DOM view construction with back button and history support.',undef,],
		'dojo' => ['https://dojotoolkit.org/',undef,'BSD',undef,'Provides everything you need to build a Web app. Language utilities, UI components, and more, all in one place, designed to work together perfectly.','Web & Mobile applications',],
		'backbone.wreqr' => ['https://github.com/marionettejs/backbone.wreqr',undef,'MIT',undef,'A simple infrastructure based on messaging patterns and service bus implementations for decoupling Backbone and Backbone.Marionette applications.','MVC framework',],
		'trimjunction' => [undef,undef,'Open Source',undef,undef,undef,],
		'durandal' => ['http://durandaljs.com/',undef,'MIT','https://raw.github.com/BlueSpire/Durandal/master/License.txt','We didn\'t try to re-invent the wheel. Durandal is built on libs you know and love like jQuery, Knockout and RequireJS. There\'s little to learn and building apps feels comfortable and familiar. Dive in and enjoy.','Single-Page Application framework',],
		'prototype' => ['http://www.prototypejs.org/',undef,'MIT',undef,'Prototype takes the complexity out of client-side web programming. Built to solve real-world problems, it adds useful extensions to the browser scripting environment and provides elegant APIs around the clumsy interfaces of Ajax and the Document Object Model.','Web applications',],
		'geddy' => ['http://geddyjs.org/',undef,'Apache License',undef,'The original MVC Web framework for Node - a simple, structured way to create full stack javascript applications','MVC framework',],
		'jamal' => [undef,undef,'free',undef,undef,undef,],
		'eyeballs' => [undef,undef,'MIT',undef,undef,undef,],
		'spine' => [undef,undef,'MIT',undef,'Spine is a simple and lightweight framework, and doesn\'t consist of a vast amount of complex widgets to configure and theme.','MVC framework',],
		'emberjs' => ['http://emberjs.com/',undef,'MIT',undef,'Ember makes Handlebars templates even better, by ensuring your HTML stays up-to-date when the underlying model changes. To get started, you don\'t even need to write any JavaScript.','Web & Mobile applications',],
		'canjs' => ['https://canjs.com/',undef,'MIT',undef,'CanJS is a JavaScript library that makes developing complex applications simple and fast. Easy-to-learn, small, and unassuming of your application structure, but with modern features like custom tags and 2-way binding.','Web & Mobile applications',],
		'socket.io' => ['http://socket.io/',undef,'MIT',undef,'Socket.IO enables real-time bidirectional event-based communication. It works on every platform, browser or device, focusing equally on reliability and speed.','UI framework',],
		'marionette' => ['http://marionettejs.com/',undef,'MIT','http://mutedsolutions.mit-license.org','Marionette simplifies your Backbone application code with robust views and architecture solutions.','MVC framework',],
		'openui5' => ['http://openui5.org/','SAP','Apache License 2.0',undef,'OpenUI5 is an Open Source JavaScript UI library, maintained by SAP and available under the Apache 2.0 license. OpenUI5 lets you build enterprise-ready web applications, responsive to all devices, running on almost any browser of your choice. It�s based on JavaScript, using JQuery as its foundation and follows web standards. It eases your development with a client-side HTML5 rendering library including a rich set of controls and supports data binding to different models (JSON, XML and OData).','UI framework',],
		'backbone' => ['http://backbonejs.org/',undef,'MIT',undef,'Backbone.js gives structure to web applications by providing models with key-value binding and custom events, collections with a rich API of enumerable functions, views with declarative event handling, and connects it all to your existing API over a RESTful JSON interface.','MVC framework',],
		'hapi' => ['http://hapijs.com/',undef,'New BSD',undef,'hapi enables developers to focus on writing reusable application logic instead of spending time building infrastructure.','MVC framework',],
		'puremvc' => [undef,undef,'MIT',undef,undef,undef,],
		'bootstrap' => ['http://getbootstrap.com/',undef,'MIT',undef,'Bootstrap is the most popular HTML, CSS, and JS framework for developing responsive, mobile first projects on the web.','UI framework',],
		'express' => ['http://expressjs.com/','StrongLoop, an IBM company','MIT',undef,'Express is a minimal and flexible Node.js web application framework that provides a robust set of features for web and mobile applications.','Web & Mobile applications',],
		'backbone.babysitter' => ['https://github.com/marionettejs/backbone.babysitter',undef,'MIT',undef,'Backbone provides a lot of functionality in its views, but does not directly provide a way to manage child views or nested views. This is not terribly difficult to do on your own, but it gets tedious to write the same code over and over again. Backbone.BabySitter provides a simple way to manage an unknown number of child views within a Backbone.View, or other object that needs to track a list of views.','MVC framework',],
		'kendo ui' => ['http://www.telerik.com/kendo-ui','Telerik, a Progress company','Apache License 2.0',undef,'Kendo UI delivers everything you need to build a modern web application under tight deadlines. Choose from more than 70 UI components and easily combine them to create beautiful and responsive apps.','UI framework',],
		'extjs' => ['https://www.sencha.com/products/extjs',undef,'GPL 3.0 ',undef,'The most comprehensive JavaScript framework for building feature-rich cross-platform web applications targeting desktop, tablets, and smartphones. Ext JS leverages HTML5 features on modern browsers while maintaining compatibility and functionality for legacy browsers','Web & Mobile applications',],
		'asana luna' => ['https://asana.com/luna',undef,'MIT',undef,'Luna is an in-house end-to-end framework that automates the busy work of writing rich web applications to an unprecedented degree.',undef,],
		'appaccelerator' => ['http://www.appcelerator.com/',undef,'Apache License 2.0',undef,'Appcelerator\'s mobile app development platform delivers great native apps, rich MBaaS, and real-time mobile analytics.','Web & Mobile applications',],
		'polymer' => ['https://www.polymer-project.org',undef,'BSD',undef,'The Polymer library is designed to make it easier and faster for developers to create great, reusable components for the modern web.','Web applications',],
		'choco' => [undef,undef,'free',undef,undef,undef,],
		'batman' => ['http://batmanjs.org/',undef,'MIT',undef,'Batman.js is no longer in production at Shopify and is not actively maintained.','Web & Mobile applications',],
		'cormvc' => [undef,undef,'free',undef,undef,undef,],
		'underscore' => ['http://underscorejs.org/',undef,'MIT',undef,'JavaScript library that provides a whole mess of useful functional programming helpers without extending any built-in objects. It�s the answer to the question: �If I sit down in front of a blank HTML page, and want to start being productive immediately, what do I need?�','Web applications',],
		'qooxdoo' => [undef,undef,'LGPL',undef,'qooxdoo is a universal JavaScript framework with a coherent set of individual components and a powerful toolchain.',undef,],
		'jquery' => ['http://www.jquery.com',undef,'MIT',undef,'jQuery is a fast, small, and feature-rich JavaScript library. It makes things like HTML document traversal and manipulation, event handling, animation, and Ajax much simpler with an easy-to-use API that works across a multitude of browsers. With a combination of versatility and extensibility, jQuery has changed the way that millions of people write JavaScript.','Web & Mobile applications',],
		'derbyjs' => ['http://derbyjs.com/',undef,'MIT',undef,'DerbyJS is a full-stack framework for writing modern web applications.','MVC framework',],
		'agility' => ['http://agilityjs.com/',undef,'MIT',undef,'Agility.js is an MVC library for Javascript that lets you write maintainable and reusable browser code without the verbose or infrastructural overhead found in other MVC libraries. The goal is to enable developers to write web apps at least as quickly as with jQuery, while simplifying long-term�',undef,],
		'handlebars' => ['http://handlebarsjs.com/',undef,'MIT',undef,'Handlebars provides the power necessary to let you build semantic templates effectively with no frustration.','Web & Mobile applications',],
		'sails' => ['http://sailsjs.org/',undef,'MIT',undef,'Sails makes it easy to build custom, enterprise-grade Node.js apps. It is designed to emulate the familiar MVC pattern of frameworks like Ruby on Rails, but with support for the requirements of modern apps: data-driven APIs with a scalable, service-oriented architecture. It\'s especially good for building chat, realtime dashboards, or multiplayer games, but you can use it for any web application project - top to bottom.','MVC framework',],
		'nodejs' => ['https://nodejs.org/','Joyent, Inc.','MIT',undef,'Node.js is a JavaScript runtime built on Chrome\'s V8 JavaScript engine. Node.js uses an event-driven, non-blocking I/O model that makes it lightweight and efficient.','Runtime platform',],
		'less' => ['http://lesscss.org/',undef,'Apache License 2.0',undef,'Less is a CSS pre-processor, meaning that it extends the CSS language, adding features that allow variables, mixins, functions and many other techniques that allow you to make CSS that is more maintainable, themable and extendable.','UI framework',],
		'sammy' => [undef,undef,'MIT',undef,undef,undef,],
		'requirejs' => ['http://requirejs.org/',undef,'BSD',undef,'RequireJS is a JavaScript file and module loader. It is optimized for in-browser use, but it can be used in other JavaScript environments, like Rhino and Node. Using a modular script loader like RequireJS will improve the speed and quality of your code.','Module loader',],
		'cappuccino' => ['http://www.cappuccino-project.org/',undef,'LGPL v2.1',undef,'Cappuccino is an open source framework that makes it easy to build desktop-caliber applications that run in a web browser.',undef,],
		'loopback' => ['http://loopback.io/','StrongLoop, an IBM company','MIT',undef,'LoopBack is a highly-extensible, open-source Node.js framework.','API framework',],
		'knockout' => ['http://knockoutjs.com/',undef,'MIT','http://www.opensource.org/licenses/mit-license.php','Simplify dynamic JavaScript UIs with the Model-View-View Model (MVVM)','UI framework',],
		'angularjs' => ['http://angularjs.org/',undef,'MIT',undef,'AngularJS lets you extend HTML vocabulary for your application. The resulting environment is extraordinarily expressive, readable, and quick to develop.','Web & Mobile applications',],
	},

	'Java' => {
		'org.eclipse.jetty' => ['https://mvnrepository.com/artifact/org.eclipse.jetty/jetty-server',undef,'EPL',undef,'The core jetty server artifact.',undef,],
		'protobuf' => ['https://developers.google.com/protocol-buffers/','Google','Proprietary',undef,'Protocol Buffers (a.k.a., protobuf) are language-neutral, platform-neutral, extensible mechanism for serializing structured data','Data Serialization framework',],
		'ofbiz' => ['https://ofbiz.apache.org/index.html','Apache Fundation','Apache License 2.0',undef,'Apache OFBiz provides a foundation and starting point for reliable, secure and scalable enterprise solutions. Use it out-of-the-box, customize it or use it as a framework to implement your most challenging business needs. ',undef,],
		'ch.qos.logback' => ['https://mvnrepository.com/artifact/ch.qos.logback/logback-core',undef,'LGPL',undef,'logback-core module',undef,],
		'com.google.guava' => ['https://mvnrepository.com/artifact/com.google.guava/guava',undef,'Apache',undef,'Guava is a suite of core and expanded libraries that include',undef,],
		'objenesis' => ['http://objenesis.org/',undef,'Apache License 2.0',undef,'Objenesis is a small Java library that serves one purpose: To instantiate a new object of a particular class.','Library',],
		'org.powermock' => ['https://mvnrepository.com/artifact/org.powermock/powermock-api-mockito',undef,'Apache',undef,'PowerMock API for Mockito 1.+..',undef,],
		'org.codehaus.jackson' => ['https://mvnrepository.com/artifact/org.codehaus.jackson/jackson-core-asl',undef,'Apache',undef,'Jackson is a high-performance JSON processor (parser, generator)',undef,],
		'org.reflections' => ['https://mvnrepository.com/artifact/org.reflections/reflections',undef,'BSD',undef,'Reflections - a Java runtime metadata analysis',undef,],
		'javax.inject' => ['https://mvnrepository.com/artifact/javax.inject/javax.inject',undef,'Apache',undef,'The javax.inject API',undef,],
		'freemarker' => ['http://freemarker.org/','Apache Fundation','Apache License 2.0',undef,'Apache FreeMarker is a�template engine: a Java library to generate text output (HTML web pages, e-mails, configuration files, source code, etc.) based on templates and changing data.','Library',],
		'commons-collections' => ['https://mvnrepository.com/artifact/commons-collections/commons-collections',undef,'Apache',undef,'Types that extend and augment the Java Collections Framework.',undef,],
		'commons-lang' => ['https://mvnrepository.com/artifact/commons-lang/commons-lang',undef,'Apache',undef,'Commons Lang, a package of Java utility classes for the',undef,],
		'org.hibernate' => ['https://mvnrepository.com/artifact/org.hibernate/hibernate-entitymanager',undef,'LGPL',undef,'(deprecated - use hibernate-core instead) Hibernate O/RM implementation of the JPA specification',undef,],
		'com.google.code.gson' => ['https://mvnrepository.com/artifact/com.google.code.gson/gson',undef,'Apache',undef,'Gson',undef,],
		'org.apache.httpcomponents' => ['https://mvnrepository.com/artifact/org.apache.httpcomponents/httpcore',undef,'Apache',undef,'Apache HttpComponents Core (blocking I/O)',undef,],
		'ztemplates' => ['http://www.ztemplates.org/',' Gerd Ziegler','Apache License 2.0','http://www.apache.org/licenses/LICENSE-2.0','ztemplates is an open source web application framework based on the Java platform 1.5 or later. It is licensed under the Apache 2.0 License.','Web applications',],
		'org.codehaus.groovy' => ['https://mvnrepository.com/artifact/org.codehaus.groovy/groovy-all',undef,'Apache',undef,'Groovy: A powerful, dynamic language for the JVM',undef,],
		'powermock' => ['https://github.com/jayway/powermock',undef,'Apache License 2.0',undef,'PowerMock is a framework that extends other mock libraries such as EasyMock with more powerful capabilities.','Unit Testing framework',],
		'smartclient' => ['http://www.smartclient.com/','Isomorphic Software','LGPL',undef,'SmartClient combines the industry\'s richest set of cross-browser UI components with a Java server framework to provide an end-to-end solution for building business web applications.','UI Framework',],
		'commons-cli' => ['https://mvnrepository.com/artifact/commons-cli/commons-cli',undef,'Apache',undef,'Apache Commons CLI provides a simple API for presenting, processing and validating a command line interface.',undef,],
		'javaserver faces' => ['http://www.javaserverfaces.org/',undef,'Proprietary',undef,'JavaServer� Faces (JSF) is the standard component-oriented user interface (UI) framework for the Java EE platform','Java Specification Requests',],
		'commons-beanutils' => ['https://mvnrepository.com/artifact/commons-beanutils/commons-beanutils',undef,'Apache',undef,'Apache Commons BeanUtils provides an easy-to-use but flexible wrapper around reflection and introspection.',undef,],
		'play!' => ['https://playframework.com/',undef,'Apache License 2.0',undef,'Play is a high-productivity Java and Scala web application framework that integrates the components and APIs you need for modern web application development.','Web applications',],
		'javassist' => ['http://jboss-javassist.github.io/javassist/',undef,'MPL 1.1',undef,'Java bytecode engineering toolkit (a class library for editing bytecodes in Java)','Bytecode Edition library',],
		'jackson' => ['https://github.com/FasterXML',undef,'Apache License 2.0',undef,'JSON library for Java','Java Specification Requests',],
		'hamcrest' => ['http://hamcrest.org/',undef,'BSD',undef,'Hamcrest is a framework for writing matcher objects allowing \'match\' rules to be defined declaratively','Unit Testing Framework',],
		'jvx webui' => [undef,undef,'Apache License 2.0',undef,undef,'UI Framework',],
		'hamlets' => ['http://hamlets.sourceforge.net/',undef,'BSD',undef,'IBM Servlet-based Content Creation Framework','Web applications',],
		'com.h2database' => ['https://mvnrepository.com/artifact/com.h2database/h2',undef,'MPL',undef,'H2 Database Engine',undef,],
		'clojure-complete' => ['https://mvnrepository.com/artifact/clojure-complete/clojure-complete',undef,'EPL',undef,'Standalone completion library adapted from swank-clojure',undef,],
		'itsnat' => ['http://itsnat.org/home',undef,'LGPL',undef,'Java AJAX Component based Web Framework','Web applications',],
		'javax.validation' => ['https://mvnrepository.com/artifact/javax.validation/validation-api',undef,'Apache',undef,'Bean Validation API',undef,],
		'sling' => ['https://sling.apache.org/','Apache Fundation','Apache License 2.0',undef,'Apache Sling is an innovative web framework that is intended to bring back the fun to web development.','Web applications',],
		'manydesigns portofino' => ['https://github.com/ManyDesigns/Portofino',undef,'GPL 3.0 ',undef,'Portofino is a web application framework written in Java and extensible using Groovy','Web applications',],
		'org.apache.maven' => ['https://mvnrepository.com/artifact/org.apache.maven/maven-core',undef,'Apache',undef,'Maven Core classes.',undef,],
		'joda-time' => ['https://mvnrepository.com/artifact/joda-time/joda-time',undef,'Apache',undef,'Date and time library to replace JDK date handling',undef,],
		'org.springframework' => ['https://mvnrepository.com/artifact/org.springframework/spring-context-support',undef,'Apache',undef,'Spring Context Support',undef,],
		'zk' => ['http://zkoss.org/',' zkoss.org','LGPL',undef,'ZK is an open-source Ajax Web application framework, written in Java, that enables creation of graphical user interfaces for Web applications with little required programming knowledge.','UI framework',],
		'webwork' => ['http://www.opensymphony.com/','OpenSymphony','Apache License 2.0','http://www.apache.org/licenses/LICENSE-2.0','WebWork was a Java-based web application framework developed by OpenSymphony that merged into the current Struts2 framework. It was designed to improve developer productivity and simplify code. WebWork was built on top of XWork, which provided a generic command pattern framework as well as an Inversion of Control container. WebWork provided support for building reusable UI templates, such as form controls, UI themes, internationalization, dynamic form parameter mapping to JavaBeans, client and server side validation, etc.','Web applications',],
		'javax.mail' => ['https://mvnrepository.com/artifact/javax.mail/mail',undef,'GPL',undef,'JavaMail API (compat)',undef,],
		'thinwire' => ['http://www.sourceforge.net/projects/thinwire','ThinWire','LGPL','https://www.gnu.org/copyleft/lesser.html','ThinWire is an open source, Java-based web application framework that uses Ajax techniques to give Web Applications the look and feel of traditional GUI applications. The project is open source software licensed under the GNU Lesser General Public License.','Web applications',],
		'log4j' => ['https://mvnrepository.com/artifact/log4j/log4j',undef,'Apache',undef,'Apache Log4j 1.2',undef,],
		'commons-codec' => ['https://mvnrepository.com/artifact/commons-codec/commons-codec',undef,'Apache',undef,'The Apache Commons Codec package contains simple encoder and decoders for',undef,],
		'org.projectlombok' => ['https://mvnrepository.com/artifact/org.projectlombok/lombok',undef,'MIT',undef,'Spice up your java: Automatic Resource Management, automatic generation of getters, setters, equals, hashCode and toString, and more!',undef,],
		'javax.enterprise' => ['https://mvnrepository.com/artifact/javax.enterprise/cdi-api',undef,'Apache',undef,'APIs for CDI (Contexts and Dependency Injection for Java)',undef,],
		'hibernate' => ['http://hibernate.org/','RedHat','LGPL 2.1',undef,'Hibernate�an open source Java persistence framework project','Library',],
		'org.spockframework' => ['https://mvnrepository.com/artifact/org.spockframework/spock-core',undef,'Apache',undef,'Spock is a testing and specification framework for Java and Groovy applications.',undef,],
		'openlaszlo' => [undef,undef,'CPL',undef,'OpenLaszlo is a discontinued open source platform for the development and delivery of rich Internet applications.','Web & Mobile applications',],
		'apache struts' => ['https://struts.apache.org/','Apache Fundation','Apache License 2.0',undef,'Apache Struts is a free, open-source, MVC framework for creating elegant, modern Java web applications','Web applications',],
		'org.scala-js' => ['https://mvnrepository.com/artifact/org.scala-js/scalajs-test-interface',undef,'BSD',undef,'Scala.js test interface',undef,],
		'appfuse' => ['http://www.appfuse.org/',undef,undef,undef,'AppFuse�is�a full-stack framework for building web applications on the JVM','Web applications',],
		'struts' => ['https://struts.apache.org/','Apache Fundation','Apache License 2.0',undef,'Apache Struts is a free, open-source, MVC framework for creating elegant, modern Java web applications','Web applications',],
		'mx4j' => ['http://mx4j.sourceforge.net/',undef,'Apache License 1.1',undef,'MX4J is a project to build an Open Source implementation of the Java(TM) Management Extensions (JMX) and of the JMX Remote API (JSR 160) specifications, and to build tools relating to JMX','Library',],
		'apache shale' => ['http://shale.apache.org/','Apache Fundation','Apache License 2.0',undef,'Shale is a modern web application framework, fundamentally based on JavaServer Faces','Web applications',],
		'gwt' => ['http://www.gwtproject.org/',undef,'Apache License 2.0',undef,'Google Web Toolkit is a development toolkit for building and optimizing complex browser-based applications. Its goal is to enable productive development of high-performance web applications without the developer having to be an expert in browser quirks, XMLHttpRequest, and JavaScript.','UI Framework',],
		'commons-io' => ['https://mvnrepository.com/artifact/commons-io/commons-io',undef,'Apache',undef,'The Apache Commons IO library contains utility classes, stream implementations, file filters,',undef,],
		'hsqldb' => ['http://hsqldb.org/',undef,'Proprietary',undef,'HSQLDB (HyperSQL DataBase) is a SQL relational database software written in Java','Runtime Platform',],
		'oracle adf' => ['http://www.oracle.com/technetwork/developer-tools/adf/overview/index.html',undef,'Oracle Technology Network Developer License',undef,'Oracle ADF is an end-to-end Java EE framework that simplifies application development by providing out-of-the-box infrastructure services and a visual and declarative development experience','Application development',],
		'org.jetbrains.kotlin' => ['https://mvnrepository.com/artifact/org.jetbrains.kotlin/kotlin-stdlib',undef,'Apache',undef,'Kotlin Standard Library for JVM',undef,],
		'apache commons' => ['https://commons.apache.org/','Apache Fundation','Apache License 2.0',undef,'Project focused on all aspects of reusable Java components.','Library',],
		'org.scala-lang' => ['https://mvnrepository.com/artifact/org.scala-lang/scala-reflect',undef,'BSD',undef,'Compiler for the Scala Programming Language',undef,],
		'easymock' => ['http://easymock.org/',undef,'Apache License 2.0',undef,'Easy mocking. Better testing.','Unit Testing Framework',],
		'spring' => ['http://spring.io/','Pivotal','Apache License 2.0',undef,'Spring helps development teams everywhere build simple, portable,  fast and flexible JVM-based systems and applications.','Application development',],
		'com.google.inject' => ['https://mvnrepository.com/artifact/com.google.inject/guice',undef,'Apache',undef,'Google Guice Core Library',undef,],
		'org.apache.logging.log4j' => ['https://mvnrepository.com/artifact/org.apache.logging.log4j/log4j-slf4j-impl',undef,'Apache',undef,'The Apache Log4j SLF4J API binding to Log4j 2 Core',undef,],
		'apache poi' => ['https://poi.apache.org/','Apache Fundation','Apache License 2.0',undef,'The java API for Microsoft Office documents','Library',],
		'formengine' => ['http://www.form-engine.de/',undef,'MIT',undef,'FormEngine is a Java Web Framework that enables simple definition and processing of complex and dynamic forms.','Library',],
		'com.google.code.findbugs' => ['https://mvnrepository.com/artifact/com.google.code.findbugs/jsr305',undef,'Apache',undef,'JSR305 Annotations for Findbugs',undef,],
		'slf4j' => ['http://www.slf4j.org/',undef,'MIT',undef,'The Simple Logging Facade for Java (SLF4J) serves as a simple facade or abstraction for various logging frameworks','Logging framework',],
		'org.apache.maven.plugin-tools' => ['https://mvnrepository.com/artifact/org.apache.maven.plugin-tools/maven-plugin-annotations',undef,'Apache',undef,'Java 5 annotations to use in Mojos',undef,],
		'jettison' => ['https://github.com/codehaus/jettison',undef,'Apache License 2.0',undef,'A StAX implementation for JSON.','API framework',],
		'stripes' => ['https://stripesframework.atlassian.net/wiki/display/STRIPES/Home',undef,'Apache License 2.0',undef,'Stripes is a presentation framework for building web applications�','Web applications',],
		'org.mockito' => ['https://mvnrepository.com/artifact/org.mockito/mockito-all',undef,'MIT',undef,'Mock objects library for java',undef,],
		'javax.servlet' => ['https://mvnrepository.com/artifact/javax.servlet/javax.servlet-api',undef,'GPL',undef,'Java Servlet API',undef,],
		'wavemaker' => ['http://www.wavemaker.com/','WaveMaker','Apache License 2.0','http://www.apache.org/licenses/LICENSE-2.0','WaveMaker is a private aPaaS (application platform-as-a-service) software for building and running custom apps. WaveMaker provides Rapid API App Development & Deployment to quickly build enterprise-grade multi-device apps, and leverages Docker containerization for an app-optimized infrastructure.','Runtime Platform',],
		'org.json' => ['https://mvnrepository.com/artifact/org.json/json',undef,'JSON',undef,'JSON is a light-weight, language independent, data interchange format.',undef,],
		'commons-logging' => ['https://mvnrepository.com/artifact/commons-logging/commons-logging',undef,'Apache',undef,'Apache Commons Logging is a thin adapter allowing configurable bridging to other,',undef,],
		'com.fasterxml.jackson.core' => ['https://mvnrepository.com/artifact/com.fasterxml.jackson.core/jackson-annotations',undef,'Apache',undef,'Core annotations used for value types, used by Jackson data binding package.',undef,],
		'jsonpath' => ['https://github.com/jayway/JsonPath',undef,'Apache License 2.0',undef,'Jayway JsonPath is a Java port of�Stefan Goessner JsonPath implementation','API framework',],
		'org.scalacheck' => ['https://mvnrepository.com/artifact/org.scalacheck/scalacheck',undef,'BSD',undef,'scalacheck',undef,],
		'org.apache.commons' => ['https://mvnrepository.com/artifact/org.apache.commons/commons-lang3',undef,'Apache',undef,'Apache Commons Lang, a package of Java utility classes for the',undef,],
		'jersey' => ['https://jersey.java.net/',undef,'CDDL 1.1',undef,'RESTful Web Services in Java','API framework',],
		'org.springframework.boot' => ['https://mvnrepository.com/artifact/org.springframework.boot/spring-boot-starter-web',undef,'Apache',undef,'Starter for building web, including RESTful, applications using Spring',undef,],
		'dbunit' => ['http://dbunit.sourceforge.net/',undef,'LGPL 2.1',undef,'DbUnit is a JUnit extension (also usable with Ant) targeted at database-driven projects that, among other things, puts your database into a known state between test runs.','Unit Testing Framework',],
		'eclipse rap' => [undef,undef,'Eclipse',undef,undef,undef,],
		'org.scoverage' => ['https://mvnrepository.com/artifact/org.scoverage/scalac-scoverage-plugin',undef,'Apache',undef,'scalac-scoverage-plugin',undef,],
		'org.slf4j' => ['https://mvnrepository.com/artifact/org.slf4j/log4j-over-slf4j',undef,'Apache',undef,'Log4j implemented over SLF4J',undef,],
		'dom4j' => ['https://mvnrepository.com/artifact/dom4j/dom4j',undef,'BSD',undef,'dom4j: the flexible XML framework for Java',undef,],
		'apache tapestry' => ['http://tapestry.apache.org/','Apache Fundation','Apache License 2.0',undef,'A component-oriented framework for creating highly scalable web applications in Java.','Web applications',],
		'org.testng' => ['https://mvnrepository.com/artifact/org.testng/testng',undef,'Apache',undef,'A testing framework for the JVM',undef,],
		'jaxr' => ['http://www.oracle.com/technetwork/java/index-jsp-140032.html',undef,undef,undef,'Java API for XML Registries�(JAXR) defines a�standard�API�for�Java platform�applications�to access and programmatically interact with various kinds of�metadata registries','API framework',],
		'org.hamcrest' => ['https://mvnrepository.com/artifact/org.hamcrest/hamcrest-core',undef,'BSD',undef,'This is the core API of hamcrest matcher framework to be used by third-party framework providers. This includes the a foundation set of matcher implementations for common operations.',undef,],
		'junit' => ['https://mvnrepository.com/artifact/junit/junit',undef,'EPL',undef,'JUnit is a unit testing framework for Java, created by Erich Gamma and Kent Beck.',undef,],
		'ant' => ['https://ant.apache.org/','Apache Fundation','Apache License 2.0',undef,'Apache Ant is a Java library and command-line tool whose mission is to drive processes described in build files as targets and extension points dependent upon each other','Runtime Platform',],
		'vaadin' => ['https://vaadin.com/home','Vaadin','Apache License 2.0','http://www.apache.org/licenses/LICENSE-2.0','Vaadin is an open source Web application framework for rich Internet applications. In contrast to JavaScript libraries and browser-plugin based solutions, it features a server-side architecture, which means that the majority of the logic runs on the servers. Ajax technology is used at the browser-side to ensure a rich and interactive user experience. On the client-side Vaadin is built on top of and can be extended with Google Web Toolkit','Web applications',],
		'jspx' => ['http://jspx-bay.sourceforge.net/',undef,'Apache License 2.0',undef,'Jspx is a free open source java web framework. It is easy to learn and fast to run. you can use Jspx to create modern and easy to maintain java web applications. Jspx is fully supporting EL based on Apache JEXL.','Web applications',],
		'openxava' => ['http://openxava.org/',undef,'LGPL',undef,'OpenXava is an�AJAX Java Framework�for�Rapid Development�of�Enterprise Web Applications','Rapid Development Framework',],
		'org.javassist' => ['https://mvnrepository.com/artifact/org.javassist/javassist',undef,'MPL',undef,'Javassist (JAVA programming ASSISTant) makes Java bytecode manipulation',undef,],
		'corba' => ['http://www.corba.org/',undef,undef,undef,'CORBA is the acronym for Common Object Request Broker Architecture, OMG\'s open, vendor-independent architecture and infrastructure that computer applications use to work together over networks.','Java Specification Requests',],
		'com.android.support' => ['https://mvnrepository.com/artifact/com.android.support/support-v4',undef,'Apache',undef,'The Support Library is a static library that you can add to your Android application in order to use APIs that are either not available for older platform versions or utility APIs that aren\'t a part of the framework APIs. Compatible on devices running API 14 or later.',undef,],
		'rmi' => ['http://docs.oracle.com/javase/1.5.0/docs/guide/rmi/index.html',undef,undef,undef,undef,'Application development',],
		'org.scalatest' => ['https://mvnrepository.com/artifact/org.scalatest/scalatest',undef,'Apache',undef,'scalatest',undef,],
		'json-simple' => ['https://code.google.com/archive/p/json-simple/',undef,'Apache License 2.0',undef,'JSON.simple is a simple Java toolkit for JSON','API framework',],
		'org.codehaus.plexus' => ['https://mvnrepository.com/artifact/org.codehaus.plexus/plexus-utils',undef,'Apache',undef,'A collection of various utility classes to ease working with strings, files, command lines, XML and',undef,],
		'org.hsqldb' => ['https://mvnrepository.com/artifact/org.hsqldb/hsqldb',undef,'Apache',undef,'HSQLDB - Lightweight 100% Java SQL Database Engine',undef,],
		'rife' => ['http://rifers.org/',undef,'LGPL',undef,'Full-stack open-source component framework to quickly and consistently develop and maintain Java web applications','Web applications',],
		'jna' => ['https://github.com/java-native-access/jna',undef,'LGPL 2.1',undef,'JNA provides Java programs easy access to native shared libraries without writing anything but Java code - no JNI or native code is required','Library',],
		'com.google.gwt' => ['https://mvnrepository.com/artifact/com.google.gwt/gwt-user',undef,'Apache',undef,'GWT User',undef,],
		'commons-httpclient' => ['https://mvnrepository.com/artifact/commons-httpclient/commons-httpclient',undef,'Apache',undef,'The HttpClient component supports the client-side of RFC 1945 (HTTP/1.0) and RFC 2616 (HTTP/1.1) , several related specifications (RFC 2109 (Cookies) , RFC 2617 (HTTP Authentication) , etc.), and provides a framework by which new request types (methods) or HTTP extensions can be created easily.',undef,],
		'apache wicket' => ['https://wicket.apache.org/','Apache Fundation','Apache License 2.0',undef,'Wicket is an open source, component oriented, serverside, Java web application framework','Web applications',],
		'org.osgi' => ['https://mvnrepository.com/artifact/org.osgi/org.osgi.compendium',undef,'Apache',undef,'OSGi Compendium Release 5, Interfaces and Classes for use in compiling bundles.',undef,],
		'org.clojure' => ['https://mvnrepository.com/artifact/org.clojure/clojurescript',undef,'EPL',undef,'ClojureScript compiler and core runtime library.',undef,],
		'webobjects' => ['http://www.apple.com/webobjects','Apple','Proprietary',undef,'WebObjects is a Java (originally Objective-C) web application server from Apple Inc. and a server-based web application framework. It is available at no additional cost. Its hallmark features are its object-orientation, database connectivity, and prototyping tools. Applications created with WebObjects can be deployed as web sites, Java Web Start desktop applications, and/or standards-based web services.','Web applications',],
		'org.assertj' => ['https://mvnrepository.com/artifact/org.assertj/assertj-core',undef,'Apache',undef,'Rich and fluent assertions for testing for Java',undef,],
		'mysql' => ['https://mvnrepository.com/artifact/mysql/mysql-connector-java',undef,'GPL',undef,'JDBC Type 4 driver for MySQL',undef,],
		'jboss seam' => ['http://seamframework.org/',undef,'LGPL',undef,'Seam is a powerful open source development platform for building rich Internet applications in Java','Web & Mobile applications',],
		'jpa' => [undef,undef,undef,undef,undef,'Java Specification Requests',],
		'org.easymock' => ['https://mvnrepository.com/artifact/org.easymock/easymock',undef,'Apache',undef,'EasyMock provides an easy way to create Mock Objects for interfaces and classes generating them on the fly',undef,],
		'xerces' => ['https://mvnrepository.com/artifact/xerces/xercesImpl',undef,'Apache',undef,'Xerces2 is the next generation of high performance, fully compliant XML parsers in the Apache Xerces family. This new version of Xerces introduces the Xerces Native Interface (XNI), a complete framework for building parser components and configurations that is extremely modular and easy to program.',undef,],
		'grails' => ['https://grails.org/',undef,'Apache License 2.0',undef,'Grails�is a framework used to build web applications with the�Groovy�programming language','Web applications',],
	},

);

sub getDB($) {
	my $techno =shift;
	
	return $DB{$techno};
}

1;
